// Copyright (c) 2008-2011 Mighty Heave Software LLC.
// 
// Permission is hereby granted, free of charge, to any person obtaining a copy
// of this software and associated documentation files (the "Software"), to deal
// in the Software without restriction, including without limitation the rights
// to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
// copies of the Software, and to permit persons to whom the Software is
// furnished to do so, subject to the following conditions:
// 
// The above copyright notice and this permission notice shall be included in
// all copies or substantial portions of the Software.
// 
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
// AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
// OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
// THE SOFTWARE.
#ifndef __chtest_h
#define __chtest_h

#include "glrexport.h"
#include "ints.h"

typedef uint32_t codepoint;
#define BAD_CODEPOINT (0xffffffff)
#define MAX_CODEPOINT (0x0010ffff)

// These functions use the unicode 5.0.1 definitions.
bool LIBGLR_EXPORT glr_isspace(codepoint c);
bool LIBGLR_EXPORT glr_isdigit(codepoint c);
int LIBGLR_EXPORT glr_digitvalue(codepoint c);
bool LIBGLR_EXPORT glr_isxdigit(codepoint c);
int LIBGLR_EXPORT glr_xdigitvalue(codepoint c);
codepoint LIBGLR_EXPORT glr_toupper(codepoint c);
codepoint LIBGLR_EXPORT glr_tolower(codepoint c);

#endif


