#line 1 "reducesrc.gg"
// Copyright (c) 2008-2011 Mighty Heave Software LLC.
// 
// Permission is hereby granted, free of charge, to any person obtaining a copy
// of this software and associated documentation files (the "Software"), to deal
// in the Software without restriction, including without limitation the rights
// to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
// copies of the Software, and to permit persons to whom the Software is
// furnished to do so, subject to the following conditions:
// 
// The above copyright notice and this permission notice shall be included in
// all copies or substantial portions of the Software.
// 
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
// AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
// OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
// THE SOFTWARE.
#include "emitC.h"

struct src_glb
{
    EmitGlobals *globals;
    defines *defs;
    outbuf *wr;
};
static outbuf *g_trace = 0;


#line 33 "reducesrc.cpp"
/*
   generated by glrgen.  
   (Skeleton Code) Copyright (c) 2008-2011 Mighty Heave Software LLC.
   Wormhole license (MIT Style)  http://www.mightyheave.com
*/
/* duplicode management {
   define C_IO_STATIC, or nothing to get a stand alone parser, static functions
     GLR_API -> static
   define C_IO_CPP to implement extern functions
   define C_IO_EXTERN to use extern functions
   define C_IO_HEADER to use extern functions
     GLR_API -> extern
     
   In all modes except C_IO_STATIC, you may provide an alternate GLR_API preprocessor
   definition, which can be handy for importing and exporting dll functions on windows.
} duplicode management */
#if ! defined(C_IO_STATIC) && (defined(C_IO_CPP) || defined(C_IO_EXTERN) || defined(C_IO_HEADER))
#ifndef GLR_API
#define GLR_API extern
#endif
#else
#ifndef C_IO_STATIC
#define C_IO_STATIC
#endif
#undef GLR_API
#define GLR_API static
#endif
#ifndef __c_skeleton_decl
#define __c_skeleton_decl
#ifdef __cplusplus
extern "C" {
#endif
GLR_API void *vp_realloc(void *vp, size_t size);
GLR_API void vp_memzero(void *dst, size_t size);
GLR_API char *nv_strdup(const char *str, size_t *len);
#ifdef __cplusplus
} /* extern "C" */
#endif
#include <stdio.h>
#ifdef _WIN32
#include <windows.h>
typedef HANDLE handle_t;
#define H_STDIN GetStdHandle(STD_INPUT_HANDLE)
#define H_STDOUT GetStdHandle(STD_OUTPUT_HANDLE)
#define H_STDERR GetStdHandle(STD_ERROR_HANDLE)
typedef __int64 foff_t;
#else
#include <unistd.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
typedef int handle_t;
#define H_STDIN STDIN_FILENO
#define H_STDOUT STDOUT_FILENO
#define H_STDERR STDERR_FILENO
typedef long long foff_t;
#endif

#define BUF_BLOCK_SIZE (32767)
#define SZ(a) (sizeof(a)/sizeof(a[0]))

#ifdef __cplusplus
extern "C" {
#endif

#define INBUF_SET (0)
#define INBUF_CUR (1)
#define INBUF_END (2)

struct tag_inbuf;
typedef struct tag_inbuf inbuf;
typedef int (*ibf_read)(inbuf*,void*,int);
typedef foff_t (*ibf_seek)(inbuf*,foff_t,int);
typedef void (*ibf_close)(inbuf*);

GLR_API inbuf *new_inbuf(size_t inbufsize, const char *fname, ibf_read readfnct, ibf_seek seekfnct, ibf_close closefnct);
GLR_API void free_inbuf(inbuf *buf);
GLR_API int ib_read(inbuf *buf, void *vp, int count);
GLR_API foff_t ib_seek(inbuf *buf, foff_t to, int whence);
GLR_API foff_t ib_tell(inbuf *buf);

struct tag_inbuf
{
  char *s;
  const char *fname;
  foff_t startpos;
  int count;
  int capacity;
  int pos;
  int eof;
  int line;
  int col;
  int strbuf;
  ibf_read readfnct;
  ibf_seek seekfnct;
  ibf_close closefnct;
#ifdef __cplusplus
  int read(void *vp,int len) { return ib_read(this,vp,len); }
  foff_t seek(foff_t off, int whence) { return ib_seek(this,off,whence); }
  foff_t tell() { return ib_tell(this); }
  void close() { if(!closefnct) return; closefnct(this); }
  void free() { free_inbuf(this); }
#endif
};

struct tag_fpinbuf; typedef struct tag_fpinbuf fpinbuf;
struct tag_fpinbuf {
    inbuf base;
    handle_t h;
};

GLR_API inbuf *h_inbuf(const char *fname, handle_t h, int handoff);
GLR_API inbuf *file_inbuf(const char *fname);
GLR_API inbuf *string_inbuf(const char *s, int staticstr);

struct tag_outbuf;
typedef struct tag_outbuf outbuf;
typedef void (*obf_write)(outbuf *buf, const char *s, size_t len);
typedef void (*obf_flush)(outbuf *buf);
typedef void (*obf_close)(outbuf *buf);

GLR_API outbuf *new_ob(size_t size, obf_write write, obf_flush flush, obf_close close);
GLR_API void free_ob(outbuf *buf);
GLR_API void ob_write(outbuf *buf, const char *s, size_t len);
GLR_API void ob_printf(outbuf *buf, const char *fmt, ...);
GLR_API void ob_vprintf(outbuf *buf, const char *fmt, ...);
GLR_API void ob_flush(outbuf *buf);
GLR_API void ob_putc(outbuf *buf, int c);
GLR_API void ob_puts(outbuf *buf, const char *s);

struct tag_outbuf
{
    char buffer[BUF_BLOCK_SIZE];
    char safetynet[16];
    size_t bufused;
    int enc;
    obf_write writefnct;
    obf_flush flushfnct;
    obf_close closefnct;
    int lineno;
    int colno;
    int autoflush;
#ifdef __cplusplus
    void write(const char *s, size_t len) { ob_write(this,s,len); }
    void printf(const char *fmt, ...)
    {
        va_list args;
        va_start(args,fmt);
        ob_vprintf(this,fmt,args);
        va_end(args);
    }
    void vprintf(const char *fmt, va_list args) { ob_vprintf(this,fmt,args); }
    void flush(outbuf *buf) { ob_flush(this); }
    void putc(int c) { ob_putc(this,c); }
    void puts(const char *s) { ob_puts(this,s); }
    void free() { free_ob(this); }
#endif
};

typedef struct tag_file_outbuf
{
    outbuf base;
    handle_t h;
} file_outbuf;

GLR_API outbuf *new_file_outbuf(const char *fname);
GLR_API outbuf *new_h_outbuf(const char *fname, handle_t h, int handoff, int autoflush);

typedef struct tag_string_outbuf
{
    outbuf base;
    int capacity, count;
    char *buf;
} string_outbuf;

GLR_API outbuf *new_string_outbuf();
GLR_API void obs_clear(outbuf *buf);
GLR_API const char *obs_getstr(outbuf *buf);

#ifdef __cplusplus
} /* extern "C" */
#endif
#define NULL_TYPESTACK {0, 0, 0}
#define NULL_LXSTACK {0, 0, 0}

#define WS_FLAG   (1)
#define PUSH_FLAG (2)
#define POP_FLAG  (3)
#define GOTO_FLAG (4)

#define STKVALUE(stk,t,i) (*((t*)((stk)->nodes[(stk)->tncount+(i)].vp)))
#define SH (0)
#define RD (1)

#ifdef __cplusplus
#include <new>
template<class T> void init_T(void *vp) { new(vp) T; }
template<class T> void destruct_T(void *t) { ((T*)t)->~T(); }
#define INIT_T(T)     init_T<T>
#define DESTRUCT_T(T) destruct_T<T>
#else
#define INIT_T(T)     0
#define DESTRUCT_T(T) 0
#endif

#ifdef __cplusplus
extern "C" {
#endif

typedef struct tag_lxstack { int *i, count, capacity; } lxstack;
GLR_API int lxstack_push(lxstack *stk, int i);
GLR_API int lxstack_pop(lxstack *stk);
GLR_API int lxstack_size(lxstack *stk);
GLR_API void lxstack_clear(lxstack *stk);
GLR_API int lxstack_top(lxstack *stk);

typedef struct tag_ttype {
  const char *name;
  size_t size;
  void (*init)(void *vp);
  void (*destroy)(void *vp);
} ttype;

extern ttype ptr_tt;

struct tag_toknode;
typedef struct tag_toknode toknode;
struct tag_toknode {
  int ref;
  int line, col;
  int sym, state;
  void *vp;
  size_t size;
  ttype *tt;
  size_t tokslen; char *tokstr;
  toknode *wstop, *wsbottom;
  size_t sncount, sncapacity; toknode **subnodes;
};

GLR_API toknode *new_toknode(size_t size, ttype *tt, int sym, int state);
GLR_API void toknode_addref(toknode *node);
GLR_API void toknode_destroytt(toknode *node);
GLR_API void toknode_decref(toknode *node);

typedef struct tag_typestack
{
  toknode **nodes;
  size_t tncount, tncapacity;
} typestack;

GLR_API int typestack_bump_capacity(typestack *tstack);
GLR_API void *typestack_alloc(typestack *tstack, ttype *tt, int sym, int state);
GLR_API size_t measure_str(toknode *node, int ws);
GLR_API char *collect_str(toknode *node, char *dst, int ws);
GLR_API char *toknode_str(toknode *node);
GLR_API int typestack_pop(typestack *stk, size_t count);
GLR_API int typestack_moveone(typestack *dststk, typestack *srcstk);
GLR_API void typestack_clear(typestack *stk);
GLR_API size_t typestack_size(typestack *stk);
GLR_API toknode *typestack_top(typestack *stk);

typedef struct tag_symbol { const char *name; ttype *tt; } symbol;
typedef struct tag_production { int id, origid, nt, scount, *symbols, skcount, *skips; } production;
#ifdef NO_COMPRESSED_LR_TABLE
typedef struct tag_parse_action { int token, action, shiftto_or_reduceby; } parse_action;
typedef struct tag_parse_state { int acount; parse_action *actions; } parse_state;
#else
typedef struct tag_parse_action_range { int action, first, last, *range; } parse_action_range;
typedef struct tag_parse_state { int acount; parse_action_range *actions; } parse_state;
#endif
#ifdef NO_COMPRESSED_SCANNER
typedef struct tag_lxtr { int low, high, next, tok; } lxtr;
typedef struct tag_lxstnfo { int from, icount; lxtr *toranges; } lxstnfo;
typedef struct tag_tsinfo { int tokstate, lxcount; lxstnfo *lxinfos; } tsinfo;
#else
typedef struct tag_scnitem { int pos, off, count, lead, next; } scnitem;
typedef struct tag_tsinfo { int brkcount, *brks, statecount, *accepttoks, scncnt; scnitem *scnitems; } tsinfo;
#endif
GLR_API int subnodes_bump_capacity(toknode *node);
GLR_API int subnodes_add(toknode *node, toknode *sub);
GLR_API toknode *makews(toknode *wsdst, toknode *wssrc);
GLR_API void toknode_set_subnodes(toknode *node, toknode **nodes, int sncount);
GLR_API void toknode_unset_subnodes(toknode *node, toknode **nodes, int sncount);
GLR_API void toknode_keep_subnodes(toknode *node);

typedef struct tag_line_col {
  int line, col;
} line_col;

typedef struct lxact_tag { int sym, flags, next; } lxact;

GLR_API void update_buf_line_col(inbuf *buf, int len);

GLR_API int readtok(inbuf *buf, lxstack *lexstk, typestack *instk, outbuf *trace, int *isws, outbuf *oberr, int eof, tsinfo *tsinfos, symbol *allsymbols, lxact **lxactions);

typedef int (*reduce_action_fnct)(toknode **nodes, int pid, const char *fname, int line, int col, outbuf *oberr, void *pextra);

GLR_API int update_parse_state(typestack *prsstk, typestack *instk, toknode **nodes, inbuf *buf, outbuf *trace, line_col *err_lc,
                                parse_state *parse_states,
                                production *productions,
                                int production_adjust_count,
                                symbol *allsymbols,
                                int starttok,
                                int errtok,
                                int acceptstate,
                                outbuf *oberr,
                                reduce_action_fnct ra,
                                void *pextra
                                );

GLR_API int parse_any(inbuf *buf, outbuf *obuf, outbuf *trace, line_col *err_lc,
                                tsinfo *tsinfos,
                                lxact **lxactions,
                                parse_state *parse_states,
                                production *productions,
                                int production_adjust_count,
                                int max_production_symbols,
                                symbol *allsymbols,
                                int starttok,
                                int errtok,
                                int eoftok,
                                int acceptstate,
                                int parser_start_state,
                                int initial_tokenset,
                                reduce_action_fnct ra,
                                void *pextra);

#ifdef __cplusplus
} /* extern "C" */
#endif
#endif /* __c_skeleton_decl */
#if defined(C_IO_STATIC) || defined(C_IO_CPP)
#ifdef __cplusplus
extern "C" {
#endif
// you may choose to define your own allocation function.
#ifndef vp_realloc
GLR_API void *vp_realloc(void *vp, size_t size) {
  if( ! vp && ! size )
    return 0;
  else if( ! vp )
    vp = malloc(size);
  else if( ! size ) {
    free(vp);
    return 0;
  }
  else
    vp = realloc(vp, size);
  return vp;
}
#endif
GLR_API void vp_memzero(void *dst, size_t size) {
  size_t i = 0;
  if( ! size )
    return;
  for( ; i < size; ++i )
    ((char*)dst)[i] = 0;
}
GLR_API char *nv_strdup(const char *str, size_t *len)
{
    char *sdup = 0;
    size_t slen = strlen(str), i = 0;
    if( len ) *len = slen;
    sdup = (char*)vp_realloc(0, slen+1);
    while( str[i] )
    {
        sdup[i] = str[i];
        ++i;
    }
    sdup[slen] = 0;
    return sdup;
}
#ifdef __cplusplus
} /* extern "C" */
#endif
#ifdef __cplusplus
extern "C" {
#endif
GLR_API inbuf *new_inbuf(size_t inbufsize, const char *fname, ibf_read readfnct, ibf_seek seekfnct, ibf_close closefnct)
{
  inbuf *buf = (inbuf*)vp_realloc(0, inbufsize);
  vp_memzero(buf, inbufsize);
  buf->readfnct = readfnct;
  buf->seekfnct = seekfnct;
  buf->closefnct = closefnct;
  buf->fname = fname ? fname : "";
  buf->line = buf->col = 1;
  buf->strbuf = 0;
  return buf;
}

GLR_API void free_inbuf(inbuf *buf)
{
    if( buf->closefnct ) buf->closefnct(buf);
    if(!buf->strbuf && buf->s) vp_realloc(buf->s, 0);
    vp_realloc(buf, 0);
}

GLR_API int ib_read(inbuf *buf, void *vp, int count)
{
    int rd = 0, i0, i1, n;
    char *dst = (char*)vp, *tmps = 0;
    if( ! buf->readfnct )
        return 0;
    while( count )
    {
        // Copy from the buffer if we can
        if( buf->pos < buf->count )
        {
            for( i0=0,i1=buf->pos, n=((count<=(buf->count-buf->pos))?count:(buf->count-buf->pos)); i0<n; ++i0,++i1 )
                dst[i0] = buf->s[i1];
            buf->pos += n;
            count -= n;
            rd += n;
            dst += n;
            continue;
        }
        // if we're out of file, stop.
        if( buf->eof )
            break;
        // Out of buffer, let's read large chunks directly into the destination.
        n = (count / BUF_BLOCK_SIZE) * BUF_BLOCK_SIZE;
        if(n)
        {
            buf->readfnct(buf, dst, n);
            buf->startpos += n;
            rd += n;
            dst += n;
            count -= n;
            continue;
        }
        // Out of large chunks, let's read a single chunk to the buffer (fast io, copy on next loop).
        if( buf->capacity < BUF_BLOCK_SIZE ) {
            // make sure we have a single chunk available
            tmps = (char*)vp_realloc(buf->s, BUF_BLOCK_SIZE);
            if( ! tmps ) break;
            buf->s = tmps;
            buf->capacity = BUF_BLOCK_SIZE;
        }
        buf->pos = 0;
        buf->startpos += buf->count;
        buf->count = buf->readfnct(buf, buf->s, BUF_BLOCK_SIZE);
        if( buf->count == 0 )
        {
            buf->eof = 1;
            break;
        }
    }
    return rd;
}

GLR_API foff_t ib_seek(inbuf *buf, foff_t to, int whence)
{
    // Seeks within the current buffer are handled without using seekfnct,
    // so file devices which buffer all of their contents, e.g. strings, require no seek function.
    if( whence == INBUF_SET )
    {
        if( (to>=buf->startpos) && (to<=buf->startpos+buf->count) )
        {
            buf->pos = (int)(to-buf->startpos);
            return to;
        }
    }
    else if( whence == INBUF_CUR )
    {
        if( (buf->pos+to) >= 0 && (buf->pos+to) <= buf->count )
        {
            buf->pos = buf->pos + (int)to;
            return buf->startpos+buf->pos;
        }
    }
    else if( whence == INBUF_END )
    {
        if( buf->eof && (to<=0) && (-to<=buf->count))
        {
            buf->pos = buf->count+(int)to;
            return buf->startpos+buf->pos;
        }
    }
    else
        return -1;
    // Anything with an actual backing store needs a seek funciton.
    if( ! buf->seekfnct )
        return -1;
    to = buf->seekfnct(buf, to, whence);
    if( to == -1 )
        return -1;
    buf->startpos = to;
    buf->pos = 0;
    buf->count = 0;
    return to;
}

GLR_API foff_t ib_tell(inbuf *buf)
{
    return buf->startpos + buf->pos;
}

GLR_API int read_file(fpinbuf *buf, void *dst, int count)
{
#ifdef _WIN32
  DWORD dwRead = 0;
  if( ! ReadFile(buf->h, dst, count, &dwRead, 0) )
    return 0;
  return dwRead;
#else
  ssize_t rdsz = read(buf->h, dst, count);
  if( rdsz == -1 )
      return 0;
  return rdsz;
#endif
}

GLR_API foff_t seek_file(fpinbuf *buf, foff_t to, int whence)
{
#ifdef _WIN32
    LARGE_INTEGER liDistanceToMove, liNewFilePointer;
    liDistanceToMove.QuadPart = to;
    if( ! SetFilePointerEx(buf->h, liDistanceToMove, &liNewFilePointer, whence) )
        return -1;
    return liNewFilePointer.QuadPart;
#else
    return lseek64(buf->h, to, whence);
#endif
}

GLR_API void close_file(fpinbuf *buf)
{
#ifdef _WIN32
    CloseHandle(buf->h);
#else
    close(buf->h);
#endif
}

GLR_API inbuf *h_inbuf(const char *fname, handle_t h, int handoff)
{
  fpinbuf *ret = (fpinbuf*)new_inbuf(sizeof(fpinbuf), fname, (ibf_read)read_file, (ibf_seek)seek_file, handoff ? (ibf_close)close_file : 0);
  ret->h = h;
  return (inbuf*)ret;
}

GLR_API inbuf *file_inbuf(const char *fname)
{
  fpinbuf *ret = 0;
#ifdef _WIN32
  HANDLE h = CreateFileA(fname, GENERIC_READ, FILE_SHARE_READ, 0, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, 0);
  if( h == INVALID_HANDLE_VALUE ) return 0;
#else
    int h = open(fname, O_RDONLY);
    if( h == -1 )
        return 0;
#endif
  return h_inbuf(fname, h, 1);
}

GLR_API int read_str(inbuf *buf, void *dst, int count) { return 0; }
GLR_API void close_str(inbuf *buf) {}

GLR_API inbuf *string_inbuf(const char *s, int staticstr)
{
  inbuf *ret = new_inbuf(sizeof(inbuf), "<string>", read_str, (ibf_seek)0, close_str);
  size_t len = 0;
  ret->strbuf = staticstr;
  if( staticstr )
      ret->eof = 1;
  if( ! staticstr )
    ret->s = nv_strdup(s, &len);
  else
  {
      ret->s = (char*)s;
      while( *s++ ) ++len;
  }
  ret->capacity = ret->count = (int)len;
  return ret;
}

GLR_API outbuf *new_ob(size_t size, obf_write writefnct, obf_flush flushfnct, obf_close closefnct)
{
    outbuf *out = (outbuf*)vp_realloc(0, size);
    vp_memzero(out, size);
    out->bufused = 0;
    out->writefnct = writefnct;
    out->flushfnct = flushfnct;
    out->closefnct = closefnct;
    out->colno = 1;
    out->lineno = 1;
    out->autoflush = 0;
    return out;
}

GLR_API void ob_write(outbuf *buf, const char *s, size_t len)
{
    int do_autoflush = 0;
    size_t a;
    for( a = 0; a < len; ++a )
    {
        if( s[a] == '\n' )
        {
            if( ! do_autoflush && buf->autoflush )
                do_autoflush = 1;
            buf->colno = 1;
            buf->lineno++;
        }
        else
            buf->colno++;
    }
    // fill the remaining buffer and write out if it is filled.
    if( buf->bufused )
    {
        a = SZ(buf->buffer)-buf->bufused;
        if( a )
        {
            if( a > len )
                a = len;
            memcpy(buf->buffer+buf->bufused, s, a);
            buf->bufused += a;
            len -= a;
            s += a;
        }
        if( buf->bufused == SZ(buf->buffer) )
        {
            buf->writefnct(buf, buf->buffer, buf->bufused);
            buf->bufused = 0;
        }
    }
    while( len >= BUF_BLOCK_SIZE )
    {
        buf->writefnct(buf, s, BUF_BLOCK_SIZE);
        len -= BUF_BLOCK_SIZE;
        s += BUF_BLOCK_SIZE;
    }
    if( len )
    {
        memcpy(buf->buffer, s, len);
        buf->bufused = len;
    }
    if( do_autoflush )
        ob_flush(buf);
}

GLR_API void ob_printf(outbuf *buf, const char *fmt, ...)
{
  va_list args;
  va_start(args,fmt);
  ob_vprintf(buf,fmt,args);
  va_end(args);
}

GLR_API void ob_vprintf(outbuf *buf, const char *fmt, va_list args)
{
  char sbuf[1024];
  size_t len = 0;
  if( ! buf )
      return;
  len = vsprintf(sbuf, fmt, args);
  if( len )
    ob_write(buf, sbuf, len);
}

GLR_API void ob_putc(outbuf *buf, int c)
{
    char ch = c;
    ob_write(buf, &ch, 1);
}

GLR_API void ob_puts(outbuf *buf, const char *s)
{
    const char *send = s;
    while( *send ) ++send;
    ob_write(buf, s, send-s);
}

GLR_API void ob_flush(outbuf *buf)
{
    if( buf->bufused )
    {
        buf->writefnct(buf, buf->buffer, buf->bufused);
        buf->bufused = 0;
    }
    if( buf->flushfnct )
        buf->flushfnct(buf);
}

GLR_API void free_ob(outbuf *buf)
{
    if( buf->bufused )
    {
        buf->writefnct(buf, buf->buffer, buf->bufused);
        buf->bufused = 0;
    }
    ob_flush(buf);
    vp_realloc(buf, 0);
}

GLR_API void file_write(file_outbuf *buf, const char *s, size_t len)
{
#ifdef _WIN32
  DWORD dwWrote = 0;
  WriteFile(buf->h, s, (DWORD)len, &dwWrote, 0);
#else
  ssize_t wrote = write(buf->h, s, len);
#endif
}

GLR_API void file_flush(file_outbuf *buf)
{
#ifdef _WIN32
    FlushFileBuffers(buf->h);
#else
    fsync(buf->h);
#endif
}

GLR_API void file_close(file_outbuf *buf)
{
#ifdef _WIN32
    CloseHandle(buf->h);
#else
    close(buf->h);
#endif
}

GLR_API outbuf *new_h_outbuf(const char *fname, handle_t h, int handoff, int autoflush)
{
    file_outbuf *out = (file_outbuf*)new_ob(sizeof(file_outbuf), (obf_write)file_write, (obf_flush)file_flush, handoff ? (obf_close)file_close : 0);
    out->h = h;
    out->base.autoflush = autoflush;
    return (outbuf*)out;
}

GLR_API outbuf *new_file_outbuf(const char *fname)
{
    file_outbuf *out = 0;
#ifdef _WIN32
    HANDLE h = CreateFileA(fname, GENERIC_WRITE, 0, 0, OPEN_ALWAYS, FILE_ATTRIBUTE_NORMAL, 0);
    if( h == INVALID_HANDLE_VALUE )
        return 0;
    if( GetLastError() == ERROR_ALREADY_EXISTS )
    {
        SetFilePointer(h, 0, 0, FILE_BEGIN);
        SetEndOfFile(h);
    }
#else
    int h = open(fname, O_WRONLY|O_CREAT|O_TRUNC);
    if( h == -1 )
        return 0;
#endif
    return new_h_outbuf(fname, h, 1, 0);
}

GLR_API void string_write(string_outbuf *buf, const char *s, size_t len)
{
    char *dst = 0;
    if( ! len ) return;
    if( buf->count+(int)len+1 > buf->capacity )
        buf->buf = (char*)vp_realloc(buf->buf, buf->count+len+1);
    dst = buf->buf+buf->count;
    while( len-- )
        *dst++ = *s++;
    *dst = 0;
}

GLR_API void string_close(string_outbuf *buf)
{
    vp_realloc(buf->buf, 0);
}

GLR_API outbuf *new_string_outbuf()
{
    return new_ob(sizeof(string_outbuf), (obf_write)string_write, (obf_flush)0, (obf_close)string_close);
}

GLR_API void obs_clear(outbuf *buf)
{
    string_outbuf *obs = (string_outbuf*)buf;
    obs->base.bufused = 0;
    obs->count = 0;
}

GLR_API const char *obs_getstr(outbuf *buf)
{
    string_outbuf *obs = (string_outbuf*)buf;
    if( obs->base.bufused )
        ob_flush(buf);
    return obs->buf;
}

#ifdef __cplusplus
} /* extern "C" */
#endif
#ifdef __cplusplus
extern "C" {
#endif
ttype ptr_tt = {"*", sizeof(void*), 0, 0};

GLR_API int lxstack_push(lxstack *stk, int i)
{
  int newcapacity = 0;
  int *newi = 0;
  if( stk->count == stk->capacity ) {
    newcapacity = stk->capacity ? (stk->capacity * 2) : 16;
    newi = (int*)vp_realloc(stk->i, newcapacity*sizeof(int));
    if( ! newi ) return 0;
    stk->i = newi;
    stk->capacity = newcapacity;
  }
  stk->i[stk->count++] = i;
  return 1;
}
GLR_API int lxstack_pop(lxstack *stk)
{
  if( stk->count == 0 ) return -1;
  return stk->i[--stk->count];
}
GLR_API int lxstack_size(lxstack *stk) { return stk->count; }
GLR_API void lxstack_clear(lxstack *stk)
{
  if( stk->i ) { vp_realloc(stk->i, 0); stk->i = 0; }
  stk->count = 0;
  stk->capacity = 0;
}
GLR_API int lxstack_top(lxstack *stk)
{
  if( ! stk->count ) return -1;
  return stk->i[stk->count-1];
}
GLR_API toknode *new_toknode(size_t size, ttype *tt, int sym, int state)
{
  toknode *node = (toknode*)vp_realloc(0, sizeof(toknode));
  vp_memzero(node, sizeof(toknode));
  if( size ) {
    node->vp = vp_realloc(0, size);
    vp_memzero(node->vp, size);
    node->size = size;
    node->tt = tt;
    if( tt && tt->init )
        tt->init(node->vp);
  }
  node->ref = 1;
  node->sym = sym;
  node->state = state;
  return node;
}
GLR_API void toknode_addref(toknode *node) { if(node) ++node->ref; }
GLR_API void toknode_destroytt(toknode *node)
{
  if( ! node || ! node->vp )
    return;
  if( node->tt && node->tt->destroy )
    node->tt->destroy(node->vp);
  vp_realloc(node->vp, 0);
  node->size = 0;
  node->vp = 0;
  node->tt = 0;
}
GLR_API void toknode_flatten(toknode *node)
{
    size_t i = 0, j = 0, endj = 0;
    toknode *cursubnode = 0;
    if( node->wstop )
    {
        subnodes_add(node, node->wstop);
        node->wstop = 0;
    }
    if( node->wsbottom )
    {
        subnodes_add(node, node->wsbottom);
        node->wsbottom = 0;
    }
    // notice that node->sncount may grow on each iteration.
    for( i = 0; i < node->sncount; ++i )
    {
        cursubnode = node->subnodes[i];
        if( ! cursubnode || cursubnode->ref > 1 )
            continue;
        if( cursubnode->wstop )
        {
            subnodes_add(node, cursubnode->wstop);
            cursubnode->wstop = 0;
        }
        if( cursubnode->wsbottom )
        {
            subnodes_add(node, cursubnode->wsbottom);
            cursubnode->wsbottom = 0;
        }
        j = 0;
        endj = cursubnode->sncount;
        for( ; j < endj; ++j )
            subnodes_add(node, cursubnode->subnodes[j]);
        cursubnode->sncount = 0;
    }
}
GLR_API void toknode_decref(toknode *node)
{
  size_t i;
  if( ! node )
    return;
  if( --node->ref > 0 )
    return;
  toknode_destroytt(node);
  if(node->tokstr) {
    vp_realloc(node->tokstr, 0);
    node->tokstr = 0;
  }
  /*
  The original code looked like this...

  if(node->wstop) {
    toknode_decref(node->wstop);
    node->wstop = 0;
  }
  if(node->wsbottom) {
    toknode_decref(node->wsbottom);
    node->wsbottom = 0;
  }
  for( i = 0; i < node->sncount; ++i )
    toknode_decref(node->subnodes[i]);

  unfortunately, we would get stack overflow
  when the call tree was very deep.  So instead,
  we'll decref by iteration instead of recursion.
  */
  if( node->wstop || node->wsbottom || node->sncount )
  {
    toknode_flatten(node);
    for( i = 0; i < node->sncount; ++i )
        toknode_decref(node->subnodes[i]);
  }
  node->sncount = node->sncapacity = 0;
  vp_realloc(node->subnodes, 0);
  node->subnodes = 0;
  vp_realloc(node, 0);
}
GLR_API int typestack_bump_capacity(typestack *tstack) {
  size_t newcapacity = 0;
  toknode **nodes = 0;
  if( tstack->tncount == tstack->tncapacity )
  {
    newcapacity = tstack->tncapacity ? (tstack->tncapacity * 2) : 16;
    nodes = (toknode**)vp_realloc(tstack->nodes, newcapacity*sizeof(toknode*));
    if( ! nodes )
      return 0;
    tstack->nodes = nodes;
    tstack->tncapacity = newcapacity;
  }
  return 1;
}
GLR_API void *typestack_alloc(typestack *tstack, ttype *tt, int sym, int state) {
  toknode *node = 0;
  size_t size = tt ? tt->size : 0;
  if( ! typestack_bump_capacity(tstack) )
      return 0;
  node = new_toknode(size, tt, sym, state);
  tstack->nodes[tstack->tncount++] = node;
  return node->vp;
}
GLR_API size_t measure_str(toknode *node, int ws) {
  size_t i, slen = 0;
  if( ! node )
    return 0;
  if( ws && node->wstop )
    slen += measure_str(node->wstop,1);
  if( node->sncount == 0 && node->tokstr )
      slen += node->tokslen;
  else {
    for( i = 0; i < node->sncount; ++i )
      slen += measure_str(node->subnodes[i],1);
  }
  if( ws && node->wsbottom )
    slen += measure_str(node->wsbottom,1);
  return slen;
}
GLR_API char *collect_str(toknode *node, char *dst, int ws) {
  size_t i = 0, n = 0;
  if( ! node )
    return dst;
  if( ws && node->wstop )
    dst = collect_str(node->wstop, dst, 1);
  if( node->sncount == 0 && node->tokstr ) {
    for( i = 0, n = node->tokslen; i < n; ++i )
      dst[i] = node->tokstr[i];
    dst += n;
  } else {
    for( i = 0; i < node->sncount; ++i )
      dst = collect_str(node->subnodes[i], dst, 1);
  }
  if( ws && node->wsbottom )
    dst = collect_str(node->wsbottom, dst, 1);
  return dst;
}
GLR_API char *toknode_str(toknode *node) {
  if( ! node )
    return "";
  if( node->sncount == 0 && node->tokstr )
    return node->tokstr;
  node->tokslen = measure_str(node,0);
  node->tokstr = (char*)vp_realloc(node->tokstr,node->tokslen+1);
  *collect_str(node,node->tokstr,0) = 0;
  return node->tokstr;
}
GLR_API int typestack_pop(typestack *stk, size_t count)
{
  int i = 0, n = 0;
  if( count > stk->tncount )
    return 0;
  for( i = (int)stk->tncount-1, n = (int)(stk->tncount-count); i >= n; --i )
    toknode_decref(stk->nodes[i]);
  stk->tncount -= count;
  return 1;
}
GLR_API int typestack_moveone(typestack *dststk, typestack *srcstk)
{
  if( srcstk->tncount == 0 )
    return 0;
  if( ! typestack_bump_capacity(dststk) )
    return 0;
  dststk->nodes[dststk->tncount++] = srcstk->nodes[--srcstk->tncount];
  return 1;
}
GLR_API void typestack_clear(typestack *stk)
{
  typestack_pop(stk, stk->tncount);
  vp_realloc(stk->nodes, 0);
  stk->nodes = 0;
  stk->tncount = 0;
  stk->tncapacity = 0;
}
GLR_API size_t typestack_size(typestack *stk) { return stk->tncount; }
GLR_API toknode *typestack_top(typestack *stk)
{
  if( ! stk->tncount ) return 0;
  return stk->nodes[stk->tncount-1];
}
GLR_API int subnodes_bump_capacity(toknode *node) {
  size_t newcapacity = 0;
  toknode **subnodes = 0;
  if( node->sncount == node->sncapacity )
  {
    newcapacity = node->sncapacity ? (node->sncapacity * 2) : 16;
    subnodes = (toknode**)vp_realloc(node->subnodes, newcapacity*sizeof(toknode*));
    if( ! subnodes )
      return 0;
    node->subnodes = subnodes;
    node->sncapacity = newcapacity;
  }
  return 1;
}
GLR_API int subnodes_add(toknode *node, toknode *sub) {
  if( ! subnodes_bump_capacity(node) ) return 0;
  node->subnodes[node->sncount++] = sub;
  return 1;
}
GLR_API toknode *makews(toknode *wsdst, toknode *wssrc) {
    toknode *tmp = 0;
    if( ! wsdst ) return wssrc;
    if( ! wssrc ) return wsdst;
    if( wsdst->sncount ) {
      subnodes_add(wsdst, wssrc);
      return wsdst; }
    tmp = new_toknode(0,0,0,0);
    subnodes_add(tmp, wsdst);
    subnodes_add(tmp, wssrc);
    return tmp;
}
GLR_API void toknode_set_subnodes(toknode *node, toknode **nodes, int sncount) {
  int i = 0;
  node->subnodes = (toknode**)vp_realloc(node->subnodes, sizeof(toknode*)*sncount);
  node->sncount = node->sncapacity = sncount;
  for( ; i < sncount; ++i )
    node->subnodes[i] = nodes[i];
  // copy leading and trailing ws to the nonterminal
  for( i = 0; i < sncount && node->subnodes[i] == 0; ++i );
  if( i < sncount && node->subnodes[i]->wstop ) {
    node->wstop = node->subnodes[i]->wstop;
    node->subnodes[i]->wstop = 0;
  }
  for( i = sncount-1; i >= 0 && node->subnodes[i] == 0; --i );
  if( i >= 0 && node->subnodes[i]->wsbottom ) {
    node->wsbottom = node->subnodes[i]->wsbottom;
    node->subnodes[i]->wsbottom = 0;
  }
}
GLR_API void toknode_unset_subnodes(toknode *node, toknode **nodes, int sncount) {
  int i = 0;
  // copy leading and trailing ws back to the terminals
  for( i = 0; i < sncount && node->subnodes[i] == 0; ++i );
  if( i < sncount && node->subnodes[i]->wstop ) {
    node->subnodes[i]->wstop = node->wstop;
    node->wstop = 0;
  }
  for( i = sncount-1; i >= 0 && node->subnodes[i] == 0; --i );
  if( i >= 0 && node->subnodes[i]->wsbottom ) {
    node->subnodes[i]->wsbottom = node->wsbottom;
    node->wsbottom = 0;
  }
  node->sncount = node->sncapacity = 0;
  (toknode**)vp_realloc(node->subnodes, 0);
  node->subnodes = 0;
}
GLR_API void toknode_keep_subnodes(toknode *node) {
  size_t i = 0, sncount = node->sncount;
  for( ; i < sncount; ++i )
    toknode_destroytt(node->subnodes[i]);
}
GLR_API void update_buf_line_col(inbuf *buf, int len)
{
  int i;
  for( i = 0; i < len; ++i ) {
      if( buf->s[buf->pos+i] == '\n' ) { buf->line++; buf->col = 1; } else buf->col++;
  }
}
#ifdef NO_COMPRESSED_SCANNER
GLR_API int next_state(int c, int curs, int lexs, int *plastaccepttok, tsinfo *tsinfos)
{
    lxstnfo *lxinfo = lxinfo = tsinfos[lexs].lxinfos+curs;
    int low = 0, high = lxinfo->icount-1, mid = 0, nexts = -1;
    lxtr *ranges = 0;
    *plastaccepttok = -1;
    while( low <= high ) {
        mid = (low+high)/2; ranges = lxinfo->toranges + mid;
        if( c < ranges->low ) { high = mid-1; continue; }
        if( c > ranges->high ) { low = mid+1; continue; }
        nexts = ranges->next;
        if( ranges->tok != -1 ) *plastaccepttok = ranges->tok;
        break;
    }
    return nexts;
}
#else
GLR_API int next_state(int c, int curs, int lexs, int *plastaccepttok, tsinfo *tsinfos)
{
    tsinfo *tsfo = tsinfos+lexs;
    int brk = -1, high, low, mid, seek, s;
    scnitem *scnit = 0;

    low = 0; high = tsfo->brkcount-2;
    while(low<=high)
    {
        mid = (low+high)/2;
        if( c < tsfo->brks[mid] )
        {
            high = mid-1;
            continue;
        }
        if( c >= tsfo->brks[mid+1] )
        {
            low = mid+1;
            continue;
        }
        break;
    }
    brk = mid;

    high = tsfo->scncnt-1;
    seek = curs*tsfo->brkcount+brk;
    while(1)
    {
        low = 0;
        while( low <= high )
        {
            mid = (low+high)/2;
            scnit = tsfo->scnitems+mid;
            if( seek < scnit->pos )
            {
                high = mid-1;
                continue;
            }
            if( seek > scnit->pos+scnit->count )
            {
                low = mid+1;
                continue;
            }
            break;
        }
        if(low>high)
            return -1;
        if(scnit->pos+scnit->count == seek)
            break;
        high = mid-1;
        seek = scnit->off + ((seek - scnit->pos) % scnit->lead);
    }
    s = scnit->next;
    if(s < 0 || s >= tsfo->statecount)
    {
        s = -1;
        *plastaccepttok = -1;
    }
    else
        *plastaccepttok = tsfo->accepttoks[s];
    return s;
}
#endif
GLR_API int readtok(inbuf *buf, lxstack *lexstk, typestack *instk, outbuf *trace, int *isws, outbuf *oberr, int eof, tsinfo *tsinfos, symbol *allsymbols, lxact **lxactions)
{
  int pos = 0, s = 0, lexs = 0, c = 0, accepttok = -1, lastaccepttok = -1, lastacceptlen = 0, i = 0, n = 0, low = 0, high = 0, mid = 0, rd = 0, nc = 0, fr = 0, mbdec_i = 0, mbdec_n = 0;
  char **ptok = 0, *tok = 0, *tmps = 0;
  toknode *node = 0;
  lxact *tkact = 0;
  lexs = lxstack_top(lexstk);
  pos = buf->pos;
  *isws = 0;
  while( c != -1 && s != -1 ) {
    if( pos == buf->count ) {
      //read more buffer if you can
      if( ! buf->eof ) {
        if( buf->pos >= BUF_BLOCK_SIZE ) {
            //use the space in the existing buffer
            fr = (buf->pos / BUF_BLOCK_SIZE) * BUF_BLOCK_SIZE;
            buf->startpos += fr;
            for( i = 0, n = buf->capacity-fr; i < n; ++i ) buf->s[i] = buf->s[fr+i];
            buf->count -= fr;
            buf->pos -= fr;
            pos -= fr;
        }
        else {
            //make more space in the buffer
            nc = buf->capacity + BUF_BLOCK_SIZE; fr = BUF_BLOCK_SIZE;
            tmps = (char*)vp_realloc(buf->s, nc);
            if( ! tmps ) return 0;
            buf->s = tmps; buf->capacity = nc;
        }
        rd = buf->readfnct(buf, buf->s+buf->count, fr);
        if( rd < fr )
          buf->eof = 1;
        buf->count += rd;
      }
      //we are really out of buffer
      if( pos == buf->count ) {
        //we're out, but we've consumed some buffer, so it's a token, or an error.
        if( pos > buf->pos )
          break;
        //we're out, and haven't consumed any buffer, so it's EOF
        typestack_alloc(instk, 0, eof, -1);
        node = typestack_top(instk);
        node->line = buf->line;
        node->col = buf->col;
        return 1;
      }
    }
    //get the next code point
    if( ! mbdec_n )
    {
        c = ((unsigned char*)buf->s)[pos++];
        if( c > 0x7F )
        {
            // started a multi-byte fetch.
            mbdec_i = 0;
            mbdec_n = 0;
            while( c & 0x0080 )
            {
                c <<= 1;
                mbdec_n++;
            }
            c &= 0x007F;
            c >>= mbdec_n;
        }
    }
    // if we've started or are continuing a multi-byte fetch, proceed.
    while(mbdec_n && pos < buf->count)
    {
        --mbdec_n;
        rd = ((unsigned char*)buf->s)[pos++];
	    if( (rd & 0xC0000000) != 0x80000000 )
        {
            update_buf_line_col(buf, pos-buf->pos);
            ob_printf(oberr, "%s:%d:%d: error: tokenizer stall, bad multibyte encoding byte %d\n", buf->fname, buf->line, buf->col, mbdec_i+2);
		    return 0;
        }
	    if( mbdec_i == 0 && (rd & 0x3FFFFFFF) == 0 )
        {
            update_buf_line_col(buf, pos-buf->pos);
            ob_printf(oberr, "%s:%d:%d: error: tokenizer stall, overlong encoding\n", buf->fname, buf->line, buf->col);
		    return 0;
        }
        c = (c<<6)|(rd&0x7F);
        mbdec_i++;
    }
    if( mbdec_n )
    {
        if( ! buf->eof )
            continue;
        update_buf_line_col(buf, pos-buf->pos);
        ob_printf(oberr, "%s:%d:%d: error: tokenizer stall, eof while doing multi-byte decoding\n", buf->fname, buf->line, buf->col);
	    return 0;        
    }
    //do a binary search for the next state
    s = next_state(c, s, lexs, &accepttok, tsinfos);
    if( accepttok != -1 )
    {
        lastaccepttok = accepttok;
        lastacceptlen = pos-buf->pos;
    }
  }
  if( lastaccepttok == -1 ) {
      ob_printf(oberr, "%s:%d:%d: error: tokenizer stall\n", buf->fname, buf->line, buf->col); return 0; }
  if( trace )
    ob_printf(trace, "read token %s\n", allsymbols[lastaccepttok].name);
  ptok = (char**)typestack_alloc(instk, &ptr_tt, lastaccepttok, -1);
  node = typestack_top(instk);
  node->line = buf->line;
  node->col = buf->col;
  node->tokslen = lastacceptlen;
  node->tokstr = tok = *ptok = (char*)vp_realloc(0, lastacceptlen+1);
  for( i = 0; i < lastacceptlen; ++i ) tok[i] = buf->s[buf->pos+i];
  tok[lastacceptlen] = 0;
  update_buf_line_col(buf, lastacceptlen);
  buf->pos += lastacceptlen;
  tkact = lxactions[lexs];
  while( tkact->sym != -1 && tkact->sym != lastaccepttok )
    ++tkact;
  switch(tkact->flags){
    case PUSH_FLAG: lxstack_push(lexstk, tkact->next); break;
    case POP_FLAG:
      lxstack_pop(lexstk);
      if( lexstk->count == 0 ) {
        ob_printf(oberr, "empty lexer state stack\n"); return 0; }
      break;
    case GOTO_FLAG: lexstk->i[lexstk->count-1] = tkact->next; break;
    case WS_FLAG:
      *isws = 1;
      break;
    default: break;
  }
  return 1;
}

#ifdef NO_COMPRESSED_LR_TABLE
#define ACTION_SYMBOL(a,s) ((a)->shiftto_or_reduceby)
#else
#define FIRST_SYMBOL(a) ((a)->range[1])
#define LAST_SYMBOL(a) ((a)->range[(a)->range[0]*2])
#define ACTION_SYMBOL(a,s) (((a)->first)+(((a)->first==(a)->last)?0:((s)-FIRST_SYMBOL(a))))
#endif

GLR_API int update_parse_state(typestack *prsstk, typestack *instk, toknode **nodes, inbuf *buf, outbuf *trace, line_col *err_lc,
                                parse_state *parse_states,
                                production *productions,
                                int production_adjust_count,
                                symbol *allsymbols,
                                int starttok,
                                int errtok,
                                int acceptstate,
                                outbuf *oberr,
                                reduce_action_fnct ra,
                                void *pextra
                                )
{
  int state = -1, tok = -1, low = 0, high = 0, mid = 0, gotlc = 0, stkpos = -1;
  parse_state *ps = 0;
#ifdef NO_COMPRESSED_LR_TABLE
  parse_action *action = 0;
#else
  parse_action_range *action = 0;
#endif
  production *p = 0, *pO = 0; ttype *tt = 0;
#ifndef NO_COMPRESSED_LR_TABLE
  int *srange = 0;
#endif
  int *skips = 0, *endskips = 0;
  toknode **curnode = 0, **dstnode = 0, *ntnode = 0, *errnode = 0;
  
  while( typestack_size(instk) ) {
    tok = typestack_top(instk)->sym;
    state = typestack_top(prsstk)->state;
    if( state < 0 ) break;
    ps = parse_states+state;
    low = 0; high = ps->acount-1;
    while( low <= high ) {
      mid = (low+high)/2;
      action = ps->actions+mid;
#ifdef NO_COMPRESSED_LR_TABLE
      if( tok < action->token ) { high = mid-1; continue; }
      if( tok > action->token ) { low = mid+1; continue; }
#else
      if( tok < FIRST_SYMBOL(action) ) { high = mid-1; continue; }
      if( tok > LAST_SYMBOL(action) ) { low = mid+1; continue; }
#endif
      break;
    }
#ifdef NO_COMPRESSED_LR_TABLE
    if(tok != action->token) {
#else
    if( low <= high ) {
        // we found a candidate action range, now see if it pans out.
        low = 0; high = action->range[0]-1;
        while( low <= high ) {
          mid = (low+high)/2;
          srange = action->range+1+mid*2;
          if( tok < srange[0] ) { high = mid-1; continue; }
          if( tok > srange[1] ) { low = mid+1; continue; }
          break;
        }
    }
    if( low > high ) {
#endif
      // An error!
      if( typestack_top(prsstk)->sym == errtok )
      {
          if(trace)
            ob_printf(trace, "handling parse error: discarding token\n", tok);
          typestack_pop(instk, 1);
          continue;
      }
      // Search for an error handling production
      for(stkpos=(int)typestack_size(prsstk)-1;stkpos>=0;--stkpos)
      {
          tok = prsstk->nodes[stkpos]->sym;
          state = prsstk->nodes[stkpos]->state;
          if(state<0) { stkpos=-1; break; }
          ps = parse_states+state;
          if(!ps->acount) continue;
          mid = 0;
#if NO_COMPRESSED_LR_TABLE
          while(ps->actions[mid].token<errtok) ++mid;
          if( ps->actions[mid].token == errtok && ps->actions[mid].action == SH )
#else
          while( LAST_SYMBOL(ps->actions+mid) < errtok) ++mid;
          if( errtok >= FIRST_SYMBOL(ps->actions+mid) && errtok <= LAST_SYMBOL(ps->actions+mid) && ps->actions[mid].action == SH )
#endif
            break; // found it, stkpos != -1
      }
      if(stkpos==-1)
      {
        // No production we are building handles errors, stop parsing.
        ntnode = typestack_top(instk);
        ob_printf(oberr, "%s:%d:%d: error: parse error\n", buf->fname, ntnode->line, ntnode->col);
        if( err_lc ) {
          err_lc->line = ntnode->line;
          err_lc->col = ntnode->col;
        }
        return 0;
      }
      // This production handles errors, shift the error and carry on.
      action = ps->actions+mid;
      typestack_pop(prsstk, stkpos-typestack_size(prsstk)-1);
      if(trace)
        ob_printf(trace, "parse error: shift to %d\n", ACTION_SYMBOL(action,errtok));
      typestack_alloc(prsstk, 0, errtok, ACTION_SYMBOL(action,errtok));
      errnode = typestack_top(prsstk);
      ntnode = typestack_top(instk);
      errnode->line = ntnode->line;
      errnode->col = ntnode->col;
      continue;
    }
    if( action->action == SH ) {
      if( trace )
        ob_printf(trace, "shift to %d\n", ACTION_SYMBOL(action,tok));
      if( ! typestack_moveone(prsstk, instk) )
        return 0;
      typestack_top(prsstk)->state = ACTION_SYMBOL(action,tok);
      continue;
    }
    for( low = 0, high = ps->acount; low <= high; ++low ) {
      p = productions+ACTION_SYMBOL(action,tok);
      pO = productions+(p->origid-production_adjust_count);
      skips = p->skips; endskips = skips+p->skcount;
      tt = allsymbols[p->nt].tt;
      typestack_alloc(instk, tt, pO->id, -1);
      ntnode = typestack_top(instk);
      dstnode = nodes;
      gotlc = 0;
      *dstnode++ = ntnode;
      curnode = prsstk->nodes+(prsstk->tncount-p->scount);
      for( low = 0, high = pO->scount; low < high; ++low )
        if( skips < endskips && low == *skips )
            *dstnode++ = 0, ++skips;
        else {
            if( ! gotlc ) {
              ntnode->line = (*curnode)->line; ntnode->col = (*curnode)->col; gotlc = 1; }
            *dstnode++ = *curnode++;
        }
      if( ! gotlc ) { ntnode->line = buf->line; ntnode->col = buf->col; }
      toknode_set_subnodes(ntnode, nodes+1, pO->scount);
      if( trace )
        ob_printf(trace, "reduce %d by production %d", p->scount, p->id-production_adjust_count);
      if( ra(nodes, p->origid, buf->fname, ntnode->line, ntnode->col, oberr, pextra) ) {
        if( trace )
          ob_printf(trace, " (ok)\n");
        toknode_keep_subnodes(ntnode);
        prsstk->tncount -= p->scount;
        if( p->nt == starttok ) {
          if( ! typestack_moveone(prsstk, instk) )
            return 0;
          typestack_top(prsstk)->state = acceptstate;
          return 1;
        }
        break;
      }
      if( trace )
        ob_printf(trace, " (failed)\n");
      toknode_unset_subnodes(ntnode, nodes+1, pO->scount);
      typestack_pop(instk, 1);
      ++action;
    }
    if( low > high )
      return 0;
  }
  return 1;
}

GLR_API int parse_any(inbuf *buf, outbuf *obuf, outbuf *trace, line_col *err_lc,
                                tsinfo *tsinfos,
                                lxact **lxactions,
                                parse_state *parse_states,
                                production *productions,
                                int production_adjust_count,
                                int max_production_symbols,
                                symbol *allsymbols,
                                int starttok,
                                int errtok,
                                int eoftok,
                                int acceptstate,
                                int parser_start_state,
                                int initial_tokenset,
                                reduce_action_fnct ra,
                                void *pextra)
{
  size_t i, n;
  lxstack lexstk = NULL_LXSTACK;
  typestack instk = NULL_TYPESTACK;
  typestack prsstk = NULL_TYPESTACK;
  int ret = 1, isws = 0;
  toknode **nodes = (toknode**)vp_realloc(0, (max_production_symbols+1)*sizeof(toknode*));
  if( err_lc ) { err_lc->line = 0; err_lc->col = 0; }
  lxstack_push(&lexstk, initial_tokenset);
  typestack_alloc(&prsstk, &ptr_tt, 0, parser_start_state);
  do {
    if( ! readtok(buf, &lexstk, &instk, trace, &isws, obuf, eoftok, tsinfos, allsymbols, lxactions) ) {
      if( err_lc ) {
        err_lc->line = buf->line;
        err_lc->col = buf->col;
      }
      ret = 0; goto cleanup; }
    if( isws ) {
      //append whitespace to the end of the last token
      prsstk.nodes[prsstk.tncount-1]->wsbottom = makews(prsstk.nodes[prsstk.tncount-1]->wsbottom, instk.nodes[--instk.tncount]);
      continue; }
    //move accumulated whitespace from the end of the last token to the beginning of the next one
    if( prsstk.nodes[prsstk.tncount-1]->wsbottom ) {
      instk.nodes[instk.tncount-1]->wstop = makews(instk.nodes[instk.tncount-1]->wstop, prsstk.nodes[prsstk.tncount-1]->wsbottom);
      prsstk.nodes[prsstk.tncount-1]->wsbottom = 0;
    }
    if( ! update_parse_state(&prsstk, &instk, nodes, buf, trace,
                                        err_lc, parse_states, productions, production_adjust_count,
                                        allsymbols, starttok, errtok, acceptstate, obuf,
                                        ra, pextra) ) {
        ret = 0; goto cleanup; }
    if( trace ) {
      ob_printf(obuf, "state stack:");
      for( i = 0, n = prsstk.tncount; i < n; ++i )
        ob_printf(obuf, " %d", prsstk.nodes[i]->state);
      ob_printf(obuf, "\n");
    }
  } while( typestack_top(&prsstk)->state != acceptstate );
cleanup:
  vp_realloc(nodes, 0);
  typestack_clear(&prsstk); typestack_clear(&instk); lxstack_clear(&lexstk);
  return ret;
}

#ifdef __cplusplus
} /* extern "C" */
#endif
#endif
#define INITIAL_TOKENSET (0)
#define SYMID_LTSTARTGT (0)
#define SYMID_DOL (1)
#define SYMID_LTEGT (2)
#define SYMID_LTERRORGT (3)
#define SYMID_RXNT_TYPE (4)
#define SYMID_RXSYM_TYPE (5)
#define SYMID_RXNT_STR (6)
#define SYMID_RXSYM_STR (7)
#define SYMID_RXNT_NODE (8)
#define SYMID_RXSYM_NODE (9)
#define SYMID_RXNT_OPT (10)
#define SYMID_RXSYM_OPT (11)
#define SYMID_LITDOLEXTRA (12)
#define SYMID_LITDOLFILE (13)
#define SYMID_LITDOLLINE (14)
#define SYMID_LITDOLCOL (15)
#define SYMID_LITDOLLPRNAMERPR (16)
#define SYMID_RXCONTENT (17)
#define SYMID_SRC (18)
#define SYMID_SRC_PARTS (19)
#define SYMID_SRC_PART (20)
#define PRID_LTSTARTGT_SRC (21)
#define PRID_SRC_SRC_PARTS (22)
#define PRID_SRC_PARTS_SRC_PARTS_SRC_PART (24)
#define PRID_SRC_PARTS_SRC_PART (25)
#define PRID_SRC_PART_RXNT_TYPE (26)
#define PRID_SRC_PART_RXSYM_TYPE (27)
#define PRID_SRC_PART_RXNT_STR (28)
#define PRID_SRC_PART_RXSYM_STR (29)
#define PRID_SRC_PART_RXNT_NODE (30)
#define PRID_SRC_PART_RXSYM_NODE (31)
#define PRID_SRC_PART_RXNT_OPT (32)
#define PRID_SRC_PART_RXSYM_OPT (33)
#define PRID_SRC_PART_LITDOLEXTRA (34)
#define PRID_SRC_PART_LITDOLFILE (35)
#define PRID_SRC_PART_LITDOLLINE (36)
#define PRID_SRC_PART_LITDOLCOL (37)
#define PRID_SRC_PART_LITDOLLPRNAMERPR (38)
#define PRID_SRC_PART_RXCONTENT (39)
#define STARTTOK (0)
#define EOFTOK   (1)
#define ERRTOK   (3)
#define ACCEPTSTATE (19)


static symbol allsymbols[] = {
{"<Start>",0},{"$",0},{"<E>",0},{"<error>",0},{"nt_type",0},{"sym_type",0},{"nt_str",0},
{"sym_str",0},{"nt_node",0},{"sym_node",0},{"nt_opt",0},{"sym_opt",0},{"$extra",0},
{"$file",0},{"$line",0},{"$col",0},{"$(NAME)",0},{"content",0},{"src",0},{"src_parts",0},
{"src_part",0},};
static int  ps21[] = {18,-1};
static int  ps22[] = {19,-1};
static int  ps23[] = {-1};
static int skp23[] = {0,};
static int  ps24[] = {19,20,-1};
static int  ps25[] = {20,-1};
static int  ps26[] = {4,-1};
static int  ps27[] = {5,-1};
static int  ps28[] = {6,-1};
static int  ps29[] = {7,-1};
static int  ps30[] = {8,-1};
static int  ps31[] = {9,-1};
static int  ps32[] = {10,-1};
static int  ps33[] = {11,-1};
static int  ps34[] = {12,-1};
static int  ps35[] = {13,-1};
static int  ps36[] = {14,-1};
static int  ps37[] = {15,-1};
static int  ps38[] = {16,-1};
static int  ps39[] = {17,-1};
static production productions[] = {
{21,21,0,1,ps21,0,0},
{22,22,18,1,ps22,0,0},
{23,22,18,0,ps23,SZ(skp23),skp23},
{24,24,19,2,ps24,0,0},
{25,25,19,1,ps25,0,0},
{26,26,20,1,ps26,0,0},
{27,27,20,1,ps27,0,0},
{28,28,20,1,ps28,0,0},
{29,29,20,1,ps29,0,0},
{30,30,20,1,ps30,0,0},
{31,31,20,1,ps31,0,0},
{32,32,20,1,ps32,0,0},
{33,33,20,1,ps33,0,0},
{34,34,20,1,ps34,0,0},
{35,35,20,1,ps35,0,0},
{36,36,20,1,ps36,0,0},
{37,37,20,1,ps37,0,0},
{38,38,20,1,ps38,0,0},
{39,39,20,1,ps39,0,0},
};
static int par_rng_0[] = {1,1,1,};
static int par_rng_1[] = {1,4,17,};
static int par_rng_2[] = {1,22,23,};
static int par_rng_3[] = {1,24,25,};
static int par_rng_4[] = {1,26,39,};
static int par_rng_5[] = {2,1,1,4,17,};
static parse_action_range par0[] = {{RD,2,2,par_rng_0},{SH,1,14,par_rng_1},{SH,15,15,par_rng_2},{SH,16,16,par_rng_3},{SH,17,17,par_rng_4},};
static parse_action_range par1[] = {{RD,5,5,par_rng_5},};
static parse_action_range par2[] = {{RD,6,6,par_rng_5},};
static parse_action_range par3[] = {{RD,7,7,par_rng_5},};
static parse_action_range par4[] = {{RD,8,8,par_rng_5},};
static parse_action_range par5[] = {{RD,9,9,par_rng_5},};
static parse_action_range par6[] = {{RD,10,10,par_rng_5},};
static parse_action_range par7[] = {{RD,11,11,par_rng_5},};
static parse_action_range par8[] = {{RD,12,12,par_rng_5},};
static parse_action_range par9[] = {{RD,13,13,par_rng_5},};
static parse_action_range par10[] = {{RD,14,14,par_rng_5},};
static parse_action_range par11[] = {{RD,15,15,par_rng_5},};
static parse_action_range par12[] = {{RD,16,16,par_rng_5},};
static parse_action_range par13[] = {{RD,17,17,par_rng_5},};
static parse_action_range par14[] = {{RD,18,18,par_rng_5},};
static parse_action_range par15[] = {{RD,0,0,par_rng_0},};
static parse_action_range par16[] = {{RD,1,1,par_rng_0},{SH,1,14,par_rng_1},{SH,18,18,par_rng_4},};
static parse_action_range par17[] = {{RD,4,4,par_rng_5},};
static parse_action_range par18[] = {{RD,3,3,par_rng_5},};
static parse_state parse_states[] = {
{SZ(par0),par0},{SZ(par1),par1},{SZ(par2),par2},{SZ(par3),par3},{SZ(par4),par4},
{SZ(par5),par5},{SZ(par6),par6},{SZ(par7),par7},{SZ(par8),par8},{SZ(par9),par9},
{SZ(par10),par10},{SZ(par11),par11},{SZ(par12),par12},{SZ(par13),par13},{SZ(par14),par14},
{SZ(par15),par15},{SZ(par16),par16},{SZ(par17),par17},{SZ(par18),par18},};

static int brk_INITIAL[] = {0,36,37,40,41,42,48,49,58,63,64,65,66,69,70,77,78,79,
97,98,99,100,101,102,103,105,106,108,109,110,111,112,114,115,116,117,120,121,1114112,
};
static scnitem scn_INITIAL[] = {{0,0,0,0,3},{1,0,0,0,1},{2,0,8,1,2},{11,2,28,8,41},
{40,0,0,0,4},{41,39,1,1,11},{43,39,3,1,5},{47,39,1,1,6},{49,43,10,3,10},{60,47,1,1,7},
{62,0,0,0,8},{63,43,3,3,9},{67,49,12,10,12},{80,49,5,5,13},{86,63,2,2,14},{89,67,28,12,15},
{118,41,1,1,15},{120,119,7,1,41},{128,119,28,8,41},{157,89,44,28,16},{202,201,1,1,41},
{204,157,31,31,17},{236,49,5,5,18},{242,156,67,45,19},{310,157,27,27,20},{338,157,38,38,21},
{377,156,43,43,22},{421,89,24,24,23},{446,242,67,67,24},{514,513,1,1,41},{516,204,31,31,25},
{548,236,5,5,26},{554,516,31,31,15},{586,118,44,44,16},{631,202,39,39,41},{671,377,37,37,27},
{709,708,1,1,41},{711,242,64,64,28},{776,515,31,31,29},{808,157,40,40,30},{849,671,36,36,31},
{886,421,22,22,32},{909,849,33,33,24},{943,514,33,33,41},{977,157,43,43,33},{1021,1020,1,1,41},
{1023,338,36,36,27},{1060,709,64,64,34},{1125,338,28,28,35},{1154,338,38,38,36},
{1193,242,70,67,37},{1264,670,29,29,33},{1294,1021,38,38,41},{1333,1264,11,11,38},
{1345,1193,111,70,39},{1457,1193,68,68,40},{1526,1345,73,73,-1},};
static int accepttoks_INITIAL[] = {-1,17,17,17,4,5,10,-1,-1,-1,-1,-1,6,7,-1,17,5,
10,11,-1,-1,-1,-1,-1,7,8,9,11,-1,-1,-1,15,-1,9,-1,13,14,-1,12,-1,16,};
static tsinfo tsinfos[] = {{SZ(brk_INITIAL),brk_INITIAL,41,accepttoks_INITIAL,SZ(scn_INITIAL),scn_INITIAL},
};

static int reduce_action(toknode **nodes, int pid, const char *fname, int line, int col, outbuf *oberr, src_glb* *pextra)
{
  src_glb* extra = *pextra;
  switch(pid) {
  case 26: {
#line 57 "reducesrc.gg"
 DoNT("SYMBOL", extra->globals, extra->defs, extra->wr, oberr, g_trace); 
#line 1751 "reducesrc.cpp"
  } break;
  case 27: {
#line 58 "reducesrc.gg"
 DoSYM("SYMBOL", (*((char**)nodes[1]->vp)), extra->globals, extra->defs, extra->wr, oberr, g_trace); 
#line 1756 "reducesrc.cpp"
  } break;
  case 28: {
#line 59 "reducesrc.gg"
 DoNT("SYMBOL_STR", extra->globals, extra->defs, extra->wr, oberr, g_trace); 
#line 1761 "reducesrc.cpp"
  } break;
  case 29: {
#line 60 "reducesrc.gg"
 DoSYM("SYMBOL_STR", (*((char**)nodes[1]->vp)), extra->globals, extra->defs, extra->wr, oberr, g_trace); 
#line 1766 "reducesrc.cpp"
  } break;
  case 30: {
#line 61 "reducesrc.gg"
 DoNT("SYMBOL_TREE", extra->globals, extra->defs, extra->wr, oberr, g_trace); 
#line 1771 "reducesrc.cpp"
  } break;
  case 31: {
#line 62 "reducesrc.gg"
 DoSYM("SYMBOL_TREE", (*((char**)nodes[1]->vp)), extra->globals, extra->defs, extra->wr, oberr, g_trace); 
#line 1776 "reducesrc.cpp"
  } break;
  case 32: {
#line 63 "reducesrc.gg"
 DoNT("SYMBOL_CHECK", extra->globals, extra->defs, extra->wr, oberr, g_trace); 
#line 1781 "reducesrc.cpp"
  } break;
  case 33: {
#line 64 "reducesrc.gg"
 DoSYM("SYMBOL_CHECK", (*((char**)nodes[1]->vp)), extra->globals, extra->defs, extra->wr, oberr, g_trace); 
#line 1786 "reducesrc.cpp"
  } break;
  case 34: {
#line 65 "reducesrc.gg"
 extra->globals->m_sk->emit("EXTRA_VAR", extra->globals, extra->defs, extra->wr, oberr, g_trace); 
#line 1791 "reducesrc.cpp"
  } break;
  case 35: {
#line 66 "reducesrc.gg"
 extra->globals->m_sk->emit("FILE_VAR", extra->globals, extra->defs, extra->wr, oberr, g_trace); 
#line 1796 "reducesrc.cpp"
  } break;
  case 36: {
#line 67 "reducesrc.gg"
 extra->globals->m_sk->emit("LINE_VAR", extra->globals, extra->defs, extra->wr, oberr, g_trace); 
#line 1801 "reducesrc.cpp"
  } break;
  case 37: {
#line 68 "reducesrc.gg"
 extra->globals->m_sk->emit("COL_VAR", extra->globals, extra->defs, extra->wr, oberr, g_trace); 
#line 1806 "reducesrc.cpp"
  } break;
  case 38: {
#line 69 "reducesrc.gg"
 ob_puts(extra->wr, extra->globals->m_g->m_name.c_str()); 
#line 1811 "reducesrc.cpp"
  } break;
  case 39: {
#line 70 "reducesrc.gg"
 ob_puts(extra->wr, (*((char**)nodes[1]->vp))); 
#line 1816 "reducesrc.cpp"
  } break;
  default: break;
  }
  return 1;
}

static lxact lxact_INITIAL[] = {
{4,0,-1},{5,0,-1},{6,0,-1},{7,0,-1},{8,0,-1},{9,0,-1},{10,0,-1},{11,0,-1},{12,0,-1},
{13,0,-1},{14,0,-1},{15,0,-1},{16,0,-1},{17,0,-1},{-1,0,0}};
static lxact *lxactions[] = {
lxact_INITIAL,};

static int Parse_reducesrc(inbuf *buf, outbuf *obuf, outbuf *trace, line_col *err_lc, src_glb* extra)
{
    return parse_any(buf, obuf, trace, err_lc,
                                tsinfos,
                                lxactions,
                                parse_states,
                                productions,
                                21,
                                2,
                                allsymbols,
                                STARTTOK,
                                ERRTOK,
                                EOFTOK,
                                ACCEPTSTATE,
                                0,
                                INITIAL_TOKENSET,
                                (reduce_action_fnct)reduce_action,
                                &extra);
}
#line 74 "reducesrc.gg"

int Emit_Reduce_Src(const char *src, EmitGlobals *globals, defines *defs, outbuf *wr, outbuf *err, outbuf *trace)
{
    g_trace = trace;
    inbuf *in = string_inbuf(src, 1);
    src_glb glb = {globals, defs, wr};
    int ret = Parse_reducesrc(in, err, trace, 0, &glb);
    free_inbuf(in);
    g_trace = 0;
    return ret;
}

#line 1861 "reducesrc.cpp"
