#ifdef __cplusplus
extern "C" {
#endif
 struct tag_nodevisitor;
typedef struct tag_nodevisitor nodevisitor;

typedef void (*nvf_destroy)(nodevisitor *self);
// Return true to Visit, but not search, otherwise continue search as usual.
typedef int (*nvf_isvisitmatch)(nodevisitor *self, toknode *node);
// Return the replacement for pnode, or pnode for no replacement.
// callee responsible for decref if returning a replacement
// returns a new reference in that case.  In other words, the
// caller's only responsibility is to replace their old node
// with the returned node, including removing it if the return is null.
typedef int (*nvf_visit)(nodevisitor *self, toknode *node, toknode **newnode);

struct tag_nodevisitor
{
    int ref;
    nvf_destroy destroy;
    nvf_isvisitmatch isvisitmatch;
    nvf_visit visit;
};

GLR_API nodevisitor *nv_steal(nodevisitor *self);
GLR_API void nv_addref(nodevisitor *self);
GLR_API void nv_decref(nodevisitor *self);
GLR_API nodevisitor *new_nv(size_t size, nvf_destroy destroy, nvf_isvisitmatch isvisitmatch, nvf_visit visit);
GLR_API int nv_isvisitmatch(nodevisitor *self, toknode *node);
GLR_API int nv_visit(nodevisitor *self, toknode *node, toknode **newnode);

GLR_API nodevisitor *new_agg_nv();
GLR_API void ag_add_visitor(nodevisitor *self, nodevisitor *nv);
GLR_API nodevisitor *new_match_sym(int sym);
GLR_API nodevisitor *new_with_subnode(int subnode, nodevisitor *visitor);
GLR_API nodevisitor *new_modify_string(const char *str);
GLR_API nodevisitor *new_swap_subnodes(int a, int b, int swapws);

GLR_API int topdown_visit(toknode *node, toknode **newnode, nodevisitor *visitor);
GLR_API void reconstitute(outbuf *buf, toknode *node);
#ifdef __cplusplus
} /* extern "C" */
#endif
