// Copyright (c) 2008-2011 Mighty Heave Software LLC.
// 
// Permission is hereby granted, free of charge, to any person obtaining a copy
// of this software and associated documentation files (the "Software"), to deal
// in the Software without restriction, including without limitation the rights
// to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
// copies of the Software, and to permit persons to whom the Software is
// furnished to do so, subject to the following conditions:
// 
// The above copyright notice and this permission notice shall be included in
// all copies or substantial portions of the Software.
// 
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
// AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
// OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
// THE SOFTWARE.
#include "chsets.h"

const UIntSet &named_charset_alpha()
{
    static UIntSet charset;
    if( charset.count() )
        return charset;
    charset += UIntSetRange(65, 90); // LATIN CAPITAL LETTER A -> LATIN CAPITAL LETTER Z
    charset += UIntSetRange(97, 122); // LATIN SMALL LETTER A -> LATIN SMALL LETTER Z
    charset += UIntSetRange(170, 170); // FEMININE ORDINAL INDICATOR -> FEMININE ORDINAL INDICATOR
    charset += UIntSetRange(181, 181); // MICRO SIGN -> MICRO SIGN
    charset += UIntSetRange(186, 186); // MASCULINE ORDINAL INDICATOR -> MASCULINE ORDINAL INDICATOR
    charset += UIntSetRange(192, 214); // LATIN CAPITAL LETTER A WITH GRAVE -> LATIN CAPITAL LETTER O WITH DIAERESIS
    charset += UIntSetRange(216, 246); // LATIN CAPITAL LETTER O WITH STROKE -> LATIN SMALL LETTER O WITH DIAERESIS
    charset += UIntSetRange(248, 705); // LATIN SMALL LETTER O WITH STROKE -> MODIFIER LETTER REVERSED GLOTTAL STOP
    charset += UIntSetRange(710, 721); // MODIFIER LETTER CIRCUMFLEX ACCENT -> MODIFIER LETTER HALF TRIANGULAR COLON
    charset += UIntSetRange(736, 740); // MODIFIER LETTER SMALL GAMMA -> MODIFIER LETTER SMALL REVERSED GLOTTAL STOP
    charset += UIntSetRange(748, 748); // MODIFIER LETTER VOICING -> MODIFIER LETTER VOICING
    charset += UIntSetRange(750, 750); // MODIFIER LETTER DOUBLE APOSTROPHE -> MODIFIER LETTER DOUBLE APOSTROPHE
    charset += UIntSetRange(880, 884); // GREEK CAPITAL LETTER HETA -> GREEK NUMERAL SIGN
    charset += UIntSetRange(886, 887); // GREEK CAPITAL LETTER PAMPHYLIAN DIGAMMA -> GREEK SMALL LETTER PAMPHYLIAN DIGAMMA
    charset += UIntSetRange(890, 893); // GREEK YPOGEGRAMMENI -> GREEK SMALL REVERSED DOTTED LUNATE SIGMA SYMBOL
    charset += UIntSetRange(902, 902); // GREEK CAPITAL LETTER ALPHA WITH TONOS -> GREEK CAPITAL LETTER ALPHA WITH TONOS
    charset += UIntSetRange(904, 906); // GREEK CAPITAL LETTER EPSILON WITH TONOS -> GREEK CAPITAL LETTER IOTA WITH TONOS
    charset += UIntSetRange(908, 908); // GREEK CAPITAL LETTER OMICRON WITH TONOS -> GREEK CAPITAL LETTER OMICRON WITH TONOS
    charset += UIntSetRange(910, 929); // GREEK CAPITAL LETTER UPSILON WITH TONOS -> GREEK CAPITAL LETTER RHO
    charset += UIntSetRange(931, 1013); // GREEK CAPITAL LETTER SIGMA -> GREEK LUNATE EPSILON SYMBOL
    charset += UIntSetRange(1015, 1153); // GREEK CAPITAL LETTER SHO -> CYRILLIC SMALL LETTER KOPPA
    charset += UIntSetRange(1162, 1315); // CYRILLIC CAPITAL LETTER SHORT I WITH TAIL -> CYRILLIC SMALL LETTER EN WITH MIDDLE HOOK
    charset += UIntSetRange(1329, 1366); // ARMENIAN CAPITAL LETTER AYB -> ARMENIAN CAPITAL LETTER FEH
    charset += UIntSetRange(1369, 1369); // ARMENIAN MODIFIER LETTER LEFT HALF RING -> ARMENIAN MODIFIER LETTER LEFT HALF RING
    charset += UIntSetRange(1377, 1415); // ARMENIAN SMALL LETTER AYB -> ARMENIAN SMALL LIGATURE ECH YIWN
    charset += UIntSetRange(1488, 1514); // HEBREW LETTER ALEF -> HEBREW LETTER TAV
    charset += UIntSetRange(1520, 1522); // HEBREW LIGATURE YIDDISH DOUBLE VAV -> HEBREW LIGATURE YIDDISH DOUBLE YOD
    charset += UIntSetRange(1569, 1610); // ARABIC LETTER HAMZA -> ARABIC LETTER YEH
    charset += UIntSetRange(1646, 1647); // ARABIC LETTER DOTLESS BEH -> ARABIC LETTER DOTLESS QAF
    charset += UIntSetRange(1649, 1747); // ARABIC LETTER ALEF WASLA -> ARABIC LETTER YEH BARREE WITH HAMZA ABOVE
    charset += UIntSetRange(1749, 1749); // ARABIC LETTER AE -> ARABIC LETTER AE
    charset += UIntSetRange(1765, 1766); // ARABIC SMALL WAW -> ARABIC SMALL YEH
    charset += UIntSetRange(1774, 1775); // ARABIC LETTER DAL WITH INVERTED V -> ARABIC LETTER REH WITH INVERTED V
    charset += UIntSetRange(1786, 1788); // ARABIC LETTER SHEEN WITH DOT BELOW -> ARABIC LETTER GHAIN WITH DOT BELOW
    charset += UIntSetRange(1791, 1791); // ARABIC LETTER HEH WITH INVERTED V -> ARABIC LETTER HEH WITH INVERTED V
    charset += UIntSetRange(1808, 1808); // SYRIAC LETTER ALAPH -> SYRIAC LETTER ALAPH
    charset += UIntSetRange(1810, 1839); // SYRIAC LETTER BETH -> SYRIAC LETTER PERSIAN DHALATH
    charset += UIntSetRange(1869, 1957); // SYRIAC LETTER SOGDIAN ZHAIN -> THAANA LETTER WAAVU
    charset += UIntSetRange(1969, 1969); // THAANA LETTER NAA -> THAANA LETTER NAA
    charset += UIntSetRange(1994, 2026); // NKO LETTER A -> NKO LETTER JONA RA
    charset += UIntSetRange(2036, 2037); // NKO HIGH TONE APOSTROPHE -> NKO LOW TONE APOSTROPHE
    charset += UIntSetRange(2042, 2042); // NKO LAJANYALAN -> NKO LAJANYALAN
    charset += UIntSetRange(2308, 2361); // DEVANAGARI LETTER SHORT A -> DEVANAGARI LETTER HA
    charset += UIntSetRange(2365, 2365); // DEVANAGARI SIGN AVAGRAHA -> DEVANAGARI SIGN AVAGRAHA
    charset += UIntSetRange(2384, 2384); // DEVANAGARI OM -> DEVANAGARI OM
    charset += UIntSetRange(2392, 2401); // DEVANAGARI LETTER QA -> DEVANAGARI LETTER VOCALIC LL
    charset += UIntSetRange(2417, 2418); // DEVANAGARI SIGN HIGH SPACING DOT -> DEVANAGARI LETTER CANDRA A
    charset += UIntSetRange(2427, 2431); // DEVANAGARI LETTER GGA -> DEVANAGARI LETTER BBA
    charset += UIntSetRange(2437, 2444); // BENGALI LETTER A -> BENGALI LETTER VOCALIC L
    charset += UIntSetRange(2447, 2448); // BENGALI LETTER E -> BENGALI LETTER AI
    charset += UIntSetRange(2451, 2472); // BENGALI LETTER O -> BENGALI LETTER NA
    charset += UIntSetRange(2474, 2480); // BENGALI LETTER PA -> BENGALI LETTER RA
    charset += UIntSetRange(2482, 2482); // BENGALI LETTER LA -> BENGALI LETTER LA
    charset += UIntSetRange(2486, 2489); // BENGALI LETTER SHA -> BENGALI LETTER HA
    charset += UIntSetRange(2493, 2493); // BENGALI SIGN AVAGRAHA -> BENGALI SIGN AVAGRAHA
    charset += UIntSetRange(2510, 2510); // BENGALI LETTER KHANDA TA -> BENGALI LETTER KHANDA TA
    charset += UIntSetRange(2524, 2525); // BENGALI LETTER RRA -> BENGALI LETTER RHA
    charset += UIntSetRange(2527, 2529); // BENGALI LETTER YYA -> BENGALI LETTER VOCALIC LL
    charset += UIntSetRange(2544, 2545); // BENGALI LETTER RA WITH MIDDLE DIAGONAL -> BENGALI LETTER RA WITH LOWER DIAGONAL
    charset += UIntSetRange(2565, 2570); // GURMUKHI LETTER A -> GURMUKHI LETTER UU
    charset += UIntSetRange(2575, 2576); // GURMUKHI LETTER EE -> GURMUKHI LETTER AI
    charset += UIntSetRange(2579, 2600); // GURMUKHI LETTER OO -> GURMUKHI LETTER NA
    charset += UIntSetRange(2602, 2608); // GURMUKHI LETTER PA -> GURMUKHI LETTER RA
    charset += UIntSetRange(2610, 2611); // GURMUKHI LETTER LA -> GURMUKHI LETTER LLA
    charset += UIntSetRange(2613, 2614); // GURMUKHI LETTER VA -> GURMUKHI LETTER SHA
    charset += UIntSetRange(2616, 2617); // GURMUKHI LETTER SA -> GURMUKHI LETTER HA
    charset += UIntSetRange(2649, 2652); // GURMUKHI LETTER KHHA -> GURMUKHI LETTER RRA
    charset += UIntSetRange(2654, 2654); // GURMUKHI LETTER FA -> GURMUKHI LETTER FA
    charset += UIntSetRange(2674, 2676); // GURMUKHI IRI -> GURMUKHI EK ONKAR
    charset += UIntSetRange(2693, 2701); // GUJARATI LETTER A -> GUJARATI VOWEL CANDRA E
    charset += UIntSetRange(2703, 2705); // GUJARATI LETTER E -> GUJARATI VOWEL CANDRA O
    charset += UIntSetRange(2707, 2728); // GUJARATI LETTER O -> GUJARATI LETTER NA
    charset += UIntSetRange(2730, 2736); // GUJARATI LETTER PA -> GUJARATI LETTER RA
    charset += UIntSetRange(2738, 2739); // GUJARATI LETTER LA -> GUJARATI LETTER LLA
    charset += UIntSetRange(2741, 2745); // GUJARATI LETTER VA -> GUJARATI LETTER HA
    charset += UIntSetRange(2749, 2749); // GUJARATI SIGN AVAGRAHA -> GUJARATI SIGN AVAGRAHA
    charset += UIntSetRange(2768, 2768); // GUJARATI OM -> GUJARATI OM
    charset += UIntSetRange(2784, 2785); // GUJARATI LETTER VOCALIC RR -> GUJARATI LETTER VOCALIC LL
    charset += UIntSetRange(2821, 2828); // ORIYA LETTER A -> ORIYA LETTER VOCALIC L
    charset += UIntSetRange(2831, 2832); // ORIYA LETTER E -> ORIYA LETTER AI
    charset += UIntSetRange(2835, 2856); // ORIYA LETTER O -> ORIYA LETTER NA
    charset += UIntSetRange(2858, 2864); // ORIYA LETTER PA -> ORIYA LETTER RA
    charset += UIntSetRange(2866, 2867); // ORIYA LETTER LA -> ORIYA LETTER LLA
    charset += UIntSetRange(2869, 2873); // ORIYA LETTER VA -> ORIYA LETTER HA
    charset += UIntSetRange(2877, 2877); // ORIYA SIGN AVAGRAHA -> ORIYA SIGN AVAGRAHA
    charset += UIntSetRange(2908, 2909); // ORIYA LETTER RRA -> ORIYA LETTER RHA
    charset += UIntSetRange(2911, 2913); // ORIYA LETTER YYA -> ORIYA LETTER VOCALIC LL
    charset += UIntSetRange(2929, 2929); // ORIYA LETTER WA -> ORIYA LETTER WA
    charset += UIntSetRange(2947, 2947); // TAMIL SIGN VISARGA -> TAMIL SIGN VISARGA
    charset += UIntSetRange(2949, 2954); // TAMIL LETTER A -> TAMIL LETTER UU
    charset += UIntSetRange(2958, 2960); // TAMIL LETTER E -> TAMIL LETTER AI
    charset += UIntSetRange(2962, 2965); // TAMIL LETTER O -> TAMIL LETTER KA
    charset += UIntSetRange(2969, 2970); // TAMIL LETTER NGA -> TAMIL LETTER CA
    charset += UIntSetRange(2972, 2972); // TAMIL LETTER JA -> TAMIL LETTER JA
    charset += UIntSetRange(2974, 2975); // TAMIL LETTER NYA -> TAMIL LETTER TTA
    charset += UIntSetRange(2979, 2980); // TAMIL LETTER NNA -> TAMIL LETTER TA
    charset += UIntSetRange(2984, 2986); // TAMIL LETTER NA -> TAMIL LETTER PA
    charset += UIntSetRange(2990, 3001); // TAMIL LETTER MA -> TAMIL LETTER HA
    charset += UIntSetRange(3024, 3024); // TAMIL OM -> TAMIL OM
    charset += UIntSetRange(3077, 3084); // TELUGU LETTER A -> TELUGU LETTER VOCALIC L
    charset += UIntSetRange(3086, 3088); // TELUGU LETTER E -> TELUGU LETTER AI
    charset += UIntSetRange(3090, 3112); // TELUGU LETTER O -> TELUGU LETTER NA
    charset += UIntSetRange(3114, 3123); // TELUGU LETTER PA -> TELUGU LETTER LLA
    charset += UIntSetRange(3125, 3129); // TELUGU LETTER VA -> TELUGU LETTER HA
    charset += UIntSetRange(3133, 3133); // TELUGU SIGN AVAGRAHA -> TELUGU SIGN AVAGRAHA
    charset += UIntSetRange(3160, 3161); // TELUGU LETTER TSA -> TELUGU LETTER DZA
    charset += UIntSetRange(3168, 3169); // TELUGU LETTER VOCALIC RR -> TELUGU LETTER VOCALIC LL
    charset += UIntSetRange(3205, 3212); // KANNADA LETTER A -> KANNADA LETTER VOCALIC L
    charset += UIntSetRange(3214, 3216); // KANNADA LETTER E -> KANNADA LETTER AI
    charset += UIntSetRange(3218, 3240); // KANNADA LETTER O -> KANNADA LETTER NA
    charset += UIntSetRange(3242, 3251); // KANNADA LETTER PA -> KANNADA LETTER LLA
    charset += UIntSetRange(3253, 3257); // KANNADA LETTER VA -> KANNADA LETTER HA
    charset += UIntSetRange(3261, 3261); // KANNADA SIGN AVAGRAHA -> KANNADA SIGN AVAGRAHA
    charset += UIntSetRange(3294, 3294); // KANNADA LETTER FA -> KANNADA LETTER FA
    charset += UIntSetRange(3296, 3297); // KANNADA LETTER VOCALIC RR -> KANNADA LETTER VOCALIC LL
    charset += UIntSetRange(3333, 3340); // MALAYALAM LETTER A -> MALAYALAM LETTER VOCALIC L
    charset += UIntSetRange(3342, 3344); // MALAYALAM LETTER E -> MALAYALAM LETTER AI
    charset += UIntSetRange(3346, 3368); // MALAYALAM LETTER O -> MALAYALAM LETTER NA
    charset += UIntSetRange(3370, 3385); // MALAYALAM LETTER PA -> MALAYALAM LETTER HA
    charset += UIntSetRange(3389, 3389); // MALAYALAM SIGN AVAGRAHA -> MALAYALAM SIGN AVAGRAHA
    charset += UIntSetRange(3424, 3425); // MALAYALAM LETTER VOCALIC RR -> MALAYALAM LETTER VOCALIC LL
    charset += UIntSetRange(3450, 3455); // MALAYALAM LETTER CHILLU NN -> MALAYALAM LETTER CHILLU K
    charset += UIntSetRange(3461, 3478); // SINHALA LETTER AYANNA -> SINHALA LETTER AUYANNA
    charset += UIntSetRange(3482, 3505); // SINHALA LETTER ALPAPRAANA KAYANNA -> SINHALA LETTER DANTAJA NAYANNA
    charset += UIntSetRange(3507, 3515); // SINHALA LETTER SANYAKA DAYANNA -> SINHALA LETTER RAYANNA
    charset += UIntSetRange(3517, 3517); // SINHALA LETTER DANTAJA LAYANNA -> SINHALA LETTER DANTAJA LAYANNA
    charset += UIntSetRange(3520, 3526); // SINHALA LETTER VAYANNA -> SINHALA LETTER FAYANNA
    charset += UIntSetRange(3585, 3632); // THAI CHARACTER KO KAI -> THAI CHARACTER SARA A
    charset += UIntSetRange(3634, 3635); // THAI CHARACTER SARA AA -> THAI CHARACTER SARA AM
    charset += UIntSetRange(3648, 3654); // THAI CHARACTER SARA E -> THAI CHARACTER MAIYAMOK
    charset += UIntSetRange(3713, 3714); // LAO LETTER KO -> LAO LETTER KHO SUNG
    charset += UIntSetRange(3716, 3716); // LAO LETTER KHO TAM -> LAO LETTER KHO TAM
    charset += UIntSetRange(3719, 3720); // LAO LETTER NGO -> LAO LETTER CO
    charset += UIntSetRange(3722, 3722); // LAO LETTER SO TAM -> LAO LETTER SO TAM
    charset += UIntSetRange(3725, 3725); // LAO LETTER NYO -> LAO LETTER NYO
    charset += UIntSetRange(3732, 3735); // LAO LETTER DO -> LAO LETTER THO TAM
    charset += UIntSetRange(3737, 3743); // LAO LETTER NO -> LAO LETTER FO SUNG
    charset += UIntSetRange(3745, 3747); // LAO LETTER MO -> LAO LETTER LO LING
    charset += UIntSetRange(3749, 3749); // LAO LETTER LO LOOT -> LAO LETTER LO LOOT
    charset += UIntSetRange(3751, 3751); // LAO LETTER WO -> LAO LETTER WO
    charset += UIntSetRange(3754, 3755); // LAO LETTER SO SUNG -> LAO LETTER HO SUNG
    charset += UIntSetRange(3757, 3760); // LAO LETTER O -> LAO VOWEL SIGN A
    charset += UIntSetRange(3762, 3763); // LAO VOWEL SIGN AA -> LAO VOWEL SIGN AM
    charset += UIntSetRange(3773, 3773); // LAO SEMIVOWEL SIGN NYO -> LAO SEMIVOWEL SIGN NYO
    charset += UIntSetRange(3776, 3780); // LAO VOWEL SIGN E -> LAO VOWEL SIGN AI
    charset += UIntSetRange(3782, 3782); // LAO KO LA -> LAO KO LA
    charset += UIntSetRange(3804, 3805); // LAO HO NO -> LAO HO MO
    charset += UIntSetRange(3840, 3840); // TIBETAN SYLLABLE OM -> TIBETAN SYLLABLE OM
    charset += UIntSetRange(3904, 3911); // TIBETAN LETTER KA -> TIBETAN LETTER JA
    charset += UIntSetRange(3913, 3948); // TIBETAN LETTER NYA -> TIBETAN LETTER RRA
    charset += UIntSetRange(3976, 3979); // TIBETAN SIGN LCE TSA CAN -> TIBETAN SIGN GRU MED RGYINGS
    charset += UIntSetRange(4096, 4138); // MYANMAR LETTER KA -> MYANMAR LETTER AU
    charset += UIntSetRange(4159, 4159); // MYANMAR LETTER GREAT SA -> MYANMAR LETTER GREAT SA
    charset += UIntSetRange(4176, 4181); // MYANMAR LETTER SHA -> MYANMAR LETTER VOCALIC LL
    charset += UIntSetRange(4186, 4189); // MYANMAR LETTER MON NGA -> MYANMAR LETTER MON BBE
    charset += UIntSetRange(4193, 4193); // MYANMAR LETTER SGAW KAREN SHA -> MYANMAR LETTER SGAW KAREN SHA
    charset += UIntSetRange(4197, 4198); // MYANMAR LETTER WESTERN PWO KAREN THA -> MYANMAR LETTER WESTERN PWO KAREN PWA
    charset += UIntSetRange(4206, 4208); // MYANMAR LETTER EASTERN PWO KAREN NNA -> MYANMAR LETTER EASTERN PWO KAREN GHWA
    charset += UIntSetRange(4213, 4225); // MYANMAR LETTER SHAN KA -> MYANMAR LETTER SHAN HA
    charset += UIntSetRange(4238, 4238); // MYANMAR LETTER RUMAI PALAUNG FA -> MYANMAR LETTER RUMAI PALAUNG FA
    charset += UIntSetRange(4256, 4293); // GEORGIAN CAPITAL LETTER AN -> GEORGIAN CAPITAL LETTER HOE
    charset += UIntSetRange(4304, 4346); // GEORGIAN LETTER AN -> GEORGIAN LETTER AIN
    charset += UIntSetRange(4348, 4348); // MODIFIER LETTER GEORGIAN NAR -> MODIFIER LETTER GEORGIAN NAR
    charset += UIntSetRange(4352, 4441); // HANGUL CHOSEONG KIYEOK -> HANGUL CHOSEONG YEORINHIEUH
    charset += UIntSetRange(4447, 4514); // HANGUL CHOSEONG FILLER -> HANGUL JUNGSEONG SSANGARAEA
    charset += UIntSetRange(4520, 4601); // HANGUL JONGSEONG KIYEOK -> HANGUL JONGSEONG YEORINHIEUH
    charset += UIntSetRange(4608, 4680); // ETHIOPIC SYLLABLE HA -> ETHIOPIC SYLLABLE QWA
    charset += UIntSetRange(4682, 4685); // ETHIOPIC SYLLABLE QWI -> ETHIOPIC SYLLABLE QWE
    charset += UIntSetRange(4688, 4694); // ETHIOPIC SYLLABLE QHA -> ETHIOPIC SYLLABLE QHO
    charset += UIntSetRange(4696, 4696); // ETHIOPIC SYLLABLE QHWA -> ETHIOPIC SYLLABLE QHWA
    charset += UIntSetRange(4698, 4701); // ETHIOPIC SYLLABLE QHWI -> ETHIOPIC SYLLABLE QHWE
    charset += UIntSetRange(4704, 4744); // ETHIOPIC SYLLABLE BA -> ETHIOPIC SYLLABLE XWA
    charset += UIntSetRange(4746, 4749); // ETHIOPIC SYLLABLE XWI -> ETHIOPIC SYLLABLE XWE
    charset += UIntSetRange(4752, 4784); // ETHIOPIC SYLLABLE NA -> ETHIOPIC SYLLABLE KWA
    charset += UIntSetRange(4786, 4789); // ETHIOPIC SYLLABLE KWI -> ETHIOPIC SYLLABLE KWE
    charset += UIntSetRange(4792, 4798); // ETHIOPIC SYLLABLE KXA -> ETHIOPIC SYLLABLE KXO
    charset += UIntSetRange(4800, 4800); // ETHIOPIC SYLLABLE KXWA -> ETHIOPIC SYLLABLE KXWA
    charset += UIntSetRange(4802, 4805); // ETHIOPIC SYLLABLE KXWI -> ETHIOPIC SYLLABLE KXWE
    charset += UIntSetRange(4808, 4822); // ETHIOPIC SYLLABLE WA -> ETHIOPIC SYLLABLE PHARYNGEAL O
    charset += UIntSetRange(4824, 4880); // ETHIOPIC SYLLABLE ZA -> ETHIOPIC SYLLABLE GWA
    charset += UIntSetRange(4882, 4885); // ETHIOPIC SYLLABLE GWI -> ETHIOPIC SYLLABLE GWE
    charset += UIntSetRange(4888, 4954); // ETHIOPIC SYLLABLE GGA -> ETHIOPIC SYLLABLE FYA
    charset += UIntSetRange(4992, 5007); // ETHIOPIC SYLLABLE SEBATBEIT MWA -> ETHIOPIC SYLLABLE PWE
    charset += UIntSetRange(5024, 5108); // CHEROKEE LETTER A -> CHEROKEE LETTER YV
    charset += UIntSetRange(5121, 5740); // CANADIAN SYLLABICS E -> CANADIAN SYLLABICS CARRIER TTSA
    charset += UIntSetRange(5743, 5750); // CANADIAN SYLLABICS QAI -> CANADIAN SYLLABICS NNGAA
    charset += UIntSetRange(5761, 5786); // OGHAM LETTER BEITH -> OGHAM LETTER PEITH
    charset += UIntSetRange(5792, 5866); // RUNIC LETTER FEHU FEOH FE F -> RUNIC LETTER X
    charset += UIntSetRange(5870, 5872); // RUNIC ARLAUG SYMBOL -> RUNIC BELGTHOR SYMBOL
    charset += UIntSetRange(5888, 5900); // TAGALOG LETTER A -> TAGALOG LETTER YA
    charset += UIntSetRange(5902, 5905); // TAGALOG LETTER LA -> TAGALOG LETTER HA
    charset += UIntSetRange(5920, 5937); // HANUNOO LETTER A -> HANUNOO LETTER HA
    charset += UIntSetRange(5952, 5969); // BUHID LETTER A -> BUHID LETTER HA
    charset += UIntSetRange(5984, 5996); // TAGBANWA LETTER A -> TAGBANWA LETTER YA
    charset += UIntSetRange(5998, 6000); // TAGBANWA LETTER LA -> TAGBANWA LETTER SA
    charset += UIntSetRange(6016, 6067); // KHMER LETTER KA -> KHMER INDEPENDENT VOWEL QAU
    charset += UIntSetRange(6103, 6103); // KHMER SIGN LEK TOO -> KHMER SIGN LEK TOO
    charset += UIntSetRange(6108, 6108); // KHMER SIGN AVAKRAHASANYA -> KHMER SIGN AVAKRAHASANYA
    charset += UIntSetRange(6176, 6263); // MONGOLIAN LETTER A -> MONGOLIAN LETTER MANCHU ZHA
    charset += UIntSetRange(6272, 6312); // MONGOLIAN LETTER ALI GALI ANUSVARA ONE -> MONGOLIAN LETTER MANCHU ALI GALI BHA
    charset += UIntSetRange(6314, 6314); // MONGOLIAN LETTER MANCHU ALI GALI LHA -> MONGOLIAN LETTER MANCHU ALI GALI LHA
    charset += UIntSetRange(6400, 6428); // LIMBU VOWEL-CARRIER LETTER -> LIMBU LETTER HA
    charset += UIntSetRange(6480, 6509); // TAI LE LETTER KA -> TAI LE LETTER AI
    charset += UIntSetRange(6512, 6516); // TAI LE LETTER TONE-2 -> TAI LE LETTER TONE-6
    charset += UIntSetRange(6528, 6569); // NEW TAI LUE LETTER HIGH QA -> NEW TAI LUE LETTER LOW XVA
    charset += UIntSetRange(6593, 6599); // NEW TAI LUE LETTER FINAL V -> NEW TAI LUE LETTER FINAL B
    charset += UIntSetRange(6656, 6678); // BUGINESE LETTER KA -> BUGINESE LETTER HA
    charset += UIntSetRange(6917, 6963); // BALINESE LETTER AKARA -> BALINESE LETTER HA
    charset += UIntSetRange(6981, 6987); // BALINESE LETTER KAF SASAK -> BALINESE LETTER ASYURA SASAK
    charset += UIntSetRange(7043, 7072); // SUNDANESE LETTER A -> SUNDANESE LETTER HA
    charset += UIntSetRange(7086, 7087); // SUNDANESE LETTER KHA -> SUNDANESE LETTER SYA
    charset += UIntSetRange(7168, 7203); // LEPCHA LETTER KA -> LEPCHA LETTER A
    charset += UIntSetRange(7245, 7247); // LEPCHA LETTER TTA -> LEPCHA LETTER DDA
    charset += UIntSetRange(7258, 7293); // OL CHIKI LETTER LA -> OL CHIKI AHAD
    charset += UIntSetRange(7424, 7615); // LATIN LETTER SMALL CAPITAL A -> MODIFIER LETTER SMALL THETA
    charset += UIntSetRange(7680, 7957); // LATIN CAPITAL LETTER A WITH RING BELOW -> GREEK SMALL LETTER EPSILON WITH DASIA AND OXIA
    charset += UIntSetRange(7960, 7965); // GREEK CAPITAL LETTER EPSILON WITH PSILI -> GREEK CAPITAL LETTER EPSILON WITH DASIA AND OXIA
    charset += UIntSetRange(7968, 8005); // GREEK SMALL LETTER ETA WITH PSILI -> GREEK SMALL LETTER OMICRON WITH DASIA AND OXIA
    charset += UIntSetRange(8008, 8013); // GREEK CAPITAL LETTER OMICRON WITH PSILI -> GREEK CAPITAL LETTER OMICRON WITH DASIA AND OXIA
    charset += UIntSetRange(8016, 8023); // GREEK SMALL LETTER UPSILON WITH PSILI -> GREEK SMALL LETTER UPSILON WITH DASIA AND PERISPOMENI
    charset += UIntSetRange(8025, 8025); // GREEK CAPITAL LETTER UPSILON WITH DASIA -> GREEK CAPITAL LETTER UPSILON WITH DASIA
    charset += UIntSetRange(8027, 8027); // GREEK CAPITAL LETTER UPSILON WITH DASIA AND VARIA -> GREEK CAPITAL LETTER UPSILON WITH DASIA AND VARIA
    charset += UIntSetRange(8029, 8029); // GREEK CAPITAL LETTER UPSILON WITH DASIA AND OXIA -> GREEK CAPITAL LETTER UPSILON WITH DASIA AND OXIA
    charset += UIntSetRange(8031, 8061); // GREEK CAPITAL LETTER UPSILON WITH DASIA AND PERISPOMENI -> GREEK SMALL LETTER OMEGA WITH OXIA
    charset += UIntSetRange(8064, 8116); // GREEK SMALL LETTER ALPHA WITH PSILI AND YPOGEGRAMMENI -> GREEK SMALL LETTER ALPHA WITH OXIA AND YPOGEGRAMMENI
    charset += UIntSetRange(8118, 8124); // GREEK SMALL LETTER ALPHA WITH PERISPOMENI -> GREEK CAPITAL LETTER ALPHA WITH PROSGEGRAMMENI
    charset += UIntSetRange(8126, 8126); // GREEK PROSGEGRAMMENI -> GREEK PROSGEGRAMMENI
    charset += UIntSetRange(8130, 8132); // GREEK SMALL LETTER ETA WITH VARIA AND YPOGEGRAMMENI -> GREEK SMALL LETTER ETA WITH OXIA AND YPOGEGRAMMENI
    charset += UIntSetRange(8134, 8140); // GREEK SMALL LETTER ETA WITH PERISPOMENI -> GREEK CAPITAL LETTER ETA WITH PROSGEGRAMMENI
    charset += UIntSetRange(8144, 8147); // GREEK SMALL LETTER IOTA WITH VRACHY -> GREEK SMALL LETTER IOTA WITH DIALYTIKA AND OXIA
    charset += UIntSetRange(8150, 8155); // GREEK SMALL LETTER IOTA WITH PERISPOMENI -> GREEK CAPITAL LETTER IOTA WITH OXIA
    charset += UIntSetRange(8160, 8172); // GREEK SMALL LETTER UPSILON WITH VRACHY -> GREEK CAPITAL LETTER RHO WITH DASIA
    charset += UIntSetRange(8178, 8180); // GREEK SMALL LETTER OMEGA WITH VARIA AND YPOGEGRAMMENI -> GREEK SMALL LETTER OMEGA WITH OXIA AND YPOGEGRAMMENI
    charset += UIntSetRange(8182, 8188); // GREEK SMALL LETTER OMEGA WITH PERISPOMENI -> GREEK CAPITAL LETTER OMEGA WITH PROSGEGRAMMENI
    charset += UIntSetRange(8305, 8305); // SUPERSCRIPT LATIN SMALL LETTER I -> SUPERSCRIPT LATIN SMALL LETTER I
    charset += UIntSetRange(8319, 8319); // SUPERSCRIPT LATIN SMALL LETTER N -> SUPERSCRIPT LATIN SMALL LETTER N
    charset += UIntSetRange(8336, 8340); // LATIN SUBSCRIPT SMALL LETTER A -> LATIN SUBSCRIPT SMALL LETTER SCHWA
    charset += UIntSetRange(8450, 8450); // DOUBLE-STRUCK CAPITAL C -> DOUBLE-STRUCK CAPITAL C
    charset += UIntSetRange(8455, 8455); // EULER CONSTANT -> EULER CONSTANT
    charset += UIntSetRange(8458, 8467); // SCRIPT SMALL G -> SCRIPT SMALL L
    charset += UIntSetRange(8469, 8469); // DOUBLE-STRUCK CAPITAL N -> DOUBLE-STRUCK CAPITAL N
    charset += UIntSetRange(8473, 8477); // DOUBLE-STRUCK CAPITAL P -> DOUBLE-STRUCK CAPITAL R
    charset += UIntSetRange(8484, 8484); // DOUBLE-STRUCK CAPITAL Z -> DOUBLE-STRUCK CAPITAL Z
    charset += UIntSetRange(8486, 8486); // OHM SIGN -> OHM SIGN
    charset += UIntSetRange(8488, 8488); // BLACK-LETTER CAPITAL Z -> BLACK-LETTER CAPITAL Z
    charset += UIntSetRange(8490, 8493); // KELVIN SIGN -> BLACK-LETTER CAPITAL C
    charset += UIntSetRange(8495, 8505); // SCRIPT SMALL E -> INFORMATION SOURCE
    charset += UIntSetRange(8508, 8511); // DOUBLE-STRUCK SMALL PI -> DOUBLE-STRUCK CAPITAL PI
    charset += UIntSetRange(8517, 8521); // DOUBLE-STRUCK ITALIC CAPITAL D -> DOUBLE-STRUCK ITALIC SMALL J
    charset += UIntSetRange(8526, 8526); // TURNED SMALL F -> TURNED SMALL F
    charset += UIntSetRange(8544, 8584); // ROMAN NUMERAL ONE -> ROMAN NUMERAL ONE HUNDRED THOUSAND
    charset += UIntSetRange(11264, 11310); // GLAGOLITIC CAPITAL LETTER AZU -> GLAGOLITIC CAPITAL LETTER LATINATE MYSLITE
    charset += UIntSetRange(11312, 11358); // GLAGOLITIC SMALL LETTER AZU -> GLAGOLITIC SMALL LETTER LATINATE MYSLITE
    charset += UIntSetRange(11360, 11375); // LATIN CAPITAL LETTER L WITH DOUBLE BAR -> LATIN CAPITAL LETTER TURNED A
    charset += UIntSetRange(11377, 11389); // LATIN SMALL LETTER V WITH RIGHT HOOK -> MODIFIER LETTER CAPITAL V
    charset += UIntSetRange(11392, 11492); // COPTIC CAPITAL LETTER ALFA -> COPTIC SYMBOL KAI
    charset += UIntSetRange(11520, 11557); // GEORGIAN SMALL LETTER AN -> GEORGIAN SMALL LETTER HOE
    charset += UIntSetRange(11568, 11621); // TIFINAGH LETTER YA -> TIFINAGH LETTER YAZZ
    charset += UIntSetRange(11631, 11631); // TIFINAGH MODIFIER LETTER LABIALIZATION MARK -> TIFINAGH MODIFIER LETTER LABIALIZATION MARK
    charset += UIntSetRange(11648, 11670); // ETHIOPIC SYLLABLE LOA -> ETHIOPIC SYLLABLE GGWE
    charset += UIntSetRange(11680, 11686); // ETHIOPIC SYLLABLE SSA -> ETHIOPIC SYLLABLE SSO
    charset += UIntSetRange(11688, 11694); // ETHIOPIC SYLLABLE CCA -> ETHIOPIC SYLLABLE CCO
    charset += UIntSetRange(11696, 11702); // ETHIOPIC SYLLABLE ZZA -> ETHIOPIC SYLLABLE ZZO
    charset += UIntSetRange(11704, 11710); // ETHIOPIC SYLLABLE CCHA -> ETHIOPIC SYLLABLE CCHO
    charset += UIntSetRange(11712, 11718); // ETHIOPIC SYLLABLE QYA -> ETHIOPIC SYLLABLE QYO
    charset += UIntSetRange(11720, 11726); // ETHIOPIC SYLLABLE KYA -> ETHIOPIC SYLLABLE KYO
    charset += UIntSetRange(11728, 11734); // ETHIOPIC SYLLABLE XYA -> ETHIOPIC SYLLABLE XYO
    charset += UIntSetRange(11736, 11742); // ETHIOPIC SYLLABLE GYA -> ETHIOPIC SYLLABLE GYO
    charset += UIntSetRange(11823, 11823); // VERTICAL TILDE -> VERTICAL TILDE
    charset += UIntSetRange(12293, 12295); // IDEOGRAPHIC ITERATION MARK -> IDEOGRAPHIC NUMBER ZERO
    charset += UIntSetRange(12321, 12329); // HANGZHOU NUMERAL ONE -> HANGZHOU NUMERAL NINE
    charset += UIntSetRange(12337, 12341); // VERTICAL KANA REPEAT MARK -> VERTICAL KANA REPEAT MARK LOWER HALF
    charset += UIntSetRange(12344, 12348); // HANGZHOU NUMERAL TEN -> MASU MARK
    charset += UIntSetRange(12353, 12438); // HIRAGANA LETTER SMALL A -> HIRAGANA LETTER SMALL KE
    charset += UIntSetRange(12445, 12447); // HIRAGANA ITERATION MARK -> HIRAGANA DIGRAPH YORI
    charset += UIntSetRange(12449, 12538); // KATAKANA LETTER SMALL A -> KATAKANA LETTER VO
    charset += UIntSetRange(12540, 12543); // KATAKANA-HIRAGANA PROLONGED SOUND MARK -> KATAKANA DIGRAPH KOTO
    charset += UIntSetRange(12549, 12589); // BOPOMOFO LETTER B -> BOPOMOFO LETTER IH
    charset += UIntSetRange(12593, 12686); // HANGUL LETTER KIYEOK -> HANGUL LETTER ARAEAE
    charset += UIntSetRange(12704, 12727); // BOPOMOFO LETTER BU -> BOPOMOFO FINAL LETTER H
    charset += UIntSetRange(12784, 12799); // KATAKANA LETTER SMALL KU -> KATAKANA LETTER SMALL RO
    charset += UIntSetRange(13312, 19893); // -3400 -> -4DB5
    charset += UIntSetRange(19968, 40899); // -4E00 -> -9FC3
    charset += UIntSetRange(40960, 42124); // YI SYLLABLE IT -> YI SYLLABLE YYR
    charset += UIntSetRange(42240, 42508); // VAI SYLLABLE EE -> VAI SYLLABLE LENGTHENER
    charset += UIntSetRange(42512, 42527); // VAI SYLLABLE NDOLE FA -> VAI SYMBOL JONG
    charset += UIntSetRange(42538, 42539); // VAI SYLLABLE NDOLE MA -> VAI SYLLABLE NDOLE DO
    charset += UIntSetRange(42560, 42591); // CYRILLIC CAPITAL LETTER ZEMLYA -> CYRILLIC SMALL LETTER YN
    charset += UIntSetRange(42594, 42606); // CYRILLIC CAPITAL LETTER SOFT DE -> CYRILLIC LETTER MULTIOCULAR O
    charset += UIntSetRange(42623, 42647); // CYRILLIC PAYEROK -> CYRILLIC SMALL LETTER SHWE
    charset += UIntSetRange(42775, 42783); // MODIFIER LETTER DOT VERTICAL BAR -> MODIFIER LETTER LOW INVERTED EXCLAMATION MARK
    charset += UIntSetRange(42786, 42888); // LATIN CAPITAL LETTER EGYPTOLOGICAL ALEF -> MODIFIER LETTER LOW CIRCUMFLEX ACCENT
    charset += UIntSetRange(42891, 42892); // LATIN CAPITAL LETTER SALTILLO -> LATIN SMALL LETTER SALTILLO
    charset += UIntSetRange(43003, 43009); // LATIN EPIGRAPHIC LETTER REVERSED F -> SYLOTI NAGRI LETTER I
    charset += UIntSetRange(43011, 43013); // SYLOTI NAGRI LETTER U -> SYLOTI NAGRI LETTER O
    charset += UIntSetRange(43015, 43018); // SYLOTI NAGRI LETTER KO -> SYLOTI NAGRI LETTER GHO
    charset += UIntSetRange(43020, 43042); // SYLOTI NAGRI LETTER CO -> SYLOTI NAGRI LETTER HO
    charset += UIntSetRange(43072, 43123); // PHAGS-PA LETTER KA -> PHAGS-PA LETTER CANDRABINDU
    charset += UIntSetRange(43138, 43187); // SAURASHTRA LETTER A -> SAURASHTRA LETTER LLA
    charset += UIntSetRange(43274, 43301); // KAYAH LI LETTER KA -> KAYAH LI LETTER OO
    charset += UIntSetRange(43312, 43334); // REJANG LETTER KA -> REJANG LETTER A
    charset += UIntSetRange(43520, 43560); // CHAM LETTER A -> CHAM LETTER HA
    charset += UIntSetRange(43584, 43586); // CHAM LETTER FINAL K -> CHAM LETTER FINAL NG
    charset += UIntSetRange(43588, 43595); // CHAM LETTER FINAL CH -> CHAM LETTER FINAL SS
    charset += UIntSetRange(44032, 55203); // -AC00 -> -D7A3
    charset += UIntSetRange(63744, 64045); // CJK COMPATIBILITY IDEOGRAPH-F900 -> CJK COMPATIBILITY IDEOGRAPH-FA2D
    charset += UIntSetRange(64048, 64106); // CJK COMPATIBILITY IDEOGRAPH-FA30 -> CJK COMPATIBILITY IDEOGRAPH-FA6A
    charset += UIntSetRange(64112, 64217); // CJK COMPATIBILITY IDEOGRAPH-FA70 -> CJK COMPATIBILITY IDEOGRAPH-FAD9
    charset += UIntSetRange(64256, 64262); // LATIN SMALL LIGATURE FF -> LATIN SMALL LIGATURE ST
    charset += UIntSetRange(64275, 64279); // ARMENIAN SMALL LIGATURE MEN NOW -> ARMENIAN SMALL LIGATURE MEN XEH
    charset += UIntSetRange(64285, 64285); // HEBREW LETTER YOD WITH HIRIQ -> HEBREW LETTER YOD WITH HIRIQ
    charset += UIntSetRange(64287, 64296); // HEBREW LIGATURE YIDDISH YOD YOD PATAH -> HEBREW LETTER WIDE TAV
    charset += UIntSetRange(64298, 64310); // HEBREW LETTER SHIN WITH SHIN DOT -> HEBREW LETTER ZAYIN WITH DAGESH
    charset += UIntSetRange(64312, 64316); // HEBREW LETTER TET WITH DAGESH -> HEBREW LETTER LAMED WITH DAGESH
    charset += UIntSetRange(64318, 64318); // HEBREW LETTER MEM WITH DAGESH -> HEBREW LETTER MEM WITH DAGESH
    charset += UIntSetRange(64320, 64321); // HEBREW LETTER NUN WITH DAGESH -> HEBREW LETTER SAMEKH WITH DAGESH
    charset += UIntSetRange(64323, 64324); // HEBREW LETTER FINAL PE WITH DAGESH -> HEBREW LETTER PE WITH DAGESH
    charset += UIntSetRange(64326, 64433); // HEBREW LETTER TSADI WITH DAGESH -> ARABIC LETTER YEH BARREE WITH HAMZA ABOVE FINAL FORM
    charset += UIntSetRange(64467, 64829); // ARABIC LETTER NG ISOLATED FORM -> ARABIC LIGATURE ALEF WITH FATHATAN ISOLATED FORM
    charset += UIntSetRange(64848, 64911); // ARABIC LIGATURE TEH WITH JEEM WITH MEEM INITIAL FORM -> ARABIC LIGATURE MEEM WITH KHAH WITH MEEM INITIAL FORM
    charset += UIntSetRange(64914, 64967); // ARABIC LIGATURE MEEM WITH JEEM WITH KHAH INITIAL FORM -> ARABIC LIGATURE NOON WITH JEEM WITH YEH FINAL FORM
    charset += UIntSetRange(65008, 65019); // ARABIC LIGATURE SALLA USED AS KORANIC STOP SIGN ISOLATED FORM -> ARABIC LIGATURE JALLAJALALOUHOU
    charset += UIntSetRange(65136, 65140); // ARABIC FATHATAN ISOLATED FORM -> ARABIC KASRATAN ISOLATED FORM
    charset += UIntSetRange(65142, 65276); // ARABIC FATHA ISOLATED FORM -> ARABIC LIGATURE LAM WITH ALEF FINAL FORM
    charset += UIntSetRange(65313, 65338); // FULLWIDTH LATIN CAPITAL LETTER A -> FULLWIDTH LATIN CAPITAL LETTER Z
    charset += UIntSetRange(65345, 65370); // FULLWIDTH LATIN SMALL LETTER A -> FULLWIDTH LATIN SMALL LETTER Z
    charset += UIntSetRange(65382, 65470); // HALFWIDTH KATAKANA LETTER WO -> HALFWIDTH HANGUL LETTER HIEUH
    charset += UIntSetRange(65474, 65479); // HALFWIDTH HANGUL LETTER A -> HALFWIDTH HANGUL LETTER E
    charset += UIntSetRange(65482, 65487); // HALFWIDTH HANGUL LETTER YEO -> HALFWIDTH HANGUL LETTER OE
    charset += UIntSetRange(65490, 65495); // HALFWIDTH HANGUL LETTER YO -> HALFWIDTH HANGUL LETTER YU
    charset += UIntSetRange(65498, 65500); // HALFWIDTH HANGUL LETTER EU -> HALFWIDTH HANGUL LETTER I
    charset += UIntSetRange(65536, 65547); // LINEAR B SYLLABLE B008 A -> LINEAR B SYLLABLE B046 JE
    charset += UIntSetRange(65549, 65574); // LINEAR B SYLLABLE B036 JO -> LINEAR B SYLLABLE B032 QO
    charset += UIntSetRange(65576, 65594); // LINEAR B SYLLABLE B060 RA -> LINEAR B SYLLABLE B042 WO
    charset += UIntSetRange(65596, 65597); // LINEAR B SYLLABLE B017 ZA -> LINEAR B SYLLABLE B074 ZE
    charset += UIntSetRange(65599, 65613); // LINEAR B SYLLABLE B020 ZO -> LINEAR B SYLLABLE B091 TWO
    charset += UIntSetRange(65616, 65629); // LINEAR B SYMBOL B018 -> LINEAR B SYMBOL B089
    charset += UIntSetRange(65664, 65786); // LINEAR B IDEOGRAM B100 MAN -> LINEAR B IDEOGRAM VESSEL B305
    charset += UIntSetRange(65856, 65908); // GREEK ACROPHONIC ATTIC ONE QUARTER -> GREEK ACROPHONIC STRATIAN FIFTY MNAS
    charset += UIntSetRange(66176, 66204); // LYCIAN LETTER A -> LYCIAN LETTER X
    charset += UIntSetRange(66208, 66256); // CARIAN LETTER A -> CARIAN LETTER UUU3
    charset += UIntSetRange(66304, 66334); // OLD ITALIC LETTER A -> OLD ITALIC LETTER UU
    charset += UIntSetRange(66352, 66378); // GOTHIC LETTER AHSA -> GOTHIC LETTER NINE HUNDRED
    charset += UIntSetRange(66432, 66461); // UGARITIC LETTER ALPA -> UGARITIC LETTER SSU
    charset += UIntSetRange(66464, 66499); // OLD PERSIAN SIGN A -> OLD PERSIAN SIGN HA
    charset += UIntSetRange(66504, 66511); // OLD PERSIAN SIGN AURAMAZDAA -> OLD PERSIAN SIGN BUUMISH
    charset += UIntSetRange(66513, 66517); // OLD PERSIAN NUMBER ONE -> OLD PERSIAN NUMBER HUNDRED
    charset += UIntSetRange(66560, 66717); // DESERET CAPITAL LETTER LONG I -> OSMANYA LETTER OO
    charset += UIntSetRange(67584, 67589); // CYPRIOT SYLLABLE A -> CYPRIOT SYLLABLE JA
    charset += UIntSetRange(67592, 67592); // CYPRIOT SYLLABLE JO -> CYPRIOT SYLLABLE JO
    charset += UIntSetRange(67594, 67637); // CYPRIOT SYLLABLE KA -> CYPRIOT SYLLABLE WO
    charset += UIntSetRange(67639, 67640); // CYPRIOT SYLLABLE XA -> CYPRIOT SYLLABLE XE
    charset += UIntSetRange(67644, 67644); // CYPRIOT SYLLABLE ZA -> CYPRIOT SYLLABLE ZA
    charset += UIntSetRange(67647, 67647); // CYPRIOT SYLLABLE ZO -> CYPRIOT SYLLABLE ZO
    charset += UIntSetRange(67840, 67861); // PHOENICIAN LETTER ALF -> PHOENICIAN LETTER TAU
    charset += UIntSetRange(67872, 67897); // LYDIAN LETTER A -> LYDIAN LETTER C
    charset += UIntSetRange(68096, 68096); // KHAROSHTHI LETTER A -> KHAROSHTHI LETTER A
    charset += UIntSetRange(68112, 68115); // KHAROSHTHI LETTER KA -> KHAROSHTHI LETTER GHA
    charset += UIntSetRange(68117, 68119); // KHAROSHTHI LETTER CA -> KHAROSHTHI LETTER JA
    charset += UIntSetRange(68121, 68147); // KHAROSHTHI LETTER NYA -> KHAROSHTHI LETTER TTTHA
    charset += UIntSetRange(73728, 74606); // CUNEIFORM SIGN A -> CUNEIFORM SIGN ZUM
    charset += UIntSetRange(74752, 74850); // CUNEIFORM NUMERIC SIGN TWO ASH -> CUNEIFORM NUMERIC SIGN OLD ASSYRIAN ONE QUARTER
    charset += UIntSetRange(119808, 119892); // MATHEMATICAL BOLD CAPITAL A -> MATHEMATICAL ITALIC SMALL G
    charset += UIntSetRange(119894, 119964); // MATHEMATICAL ITALIC SMALL I -> MATHEMATICAL SCRIPT CAPITAL A
    charset += UIntSetRange(119966, 119967); // MATHEMATICAL SCRIPT CAPITAL C -> MATHEMATICAL SCRIPT CAPITAL D
    charset += UIntSetRange(119970, 119970); // MATHEMATICAL SCRIPT CAPITAL G -> MATHEMATICAL SCRIPT CAPITAL G
    charset += UIntSetRange(119973, 119974); // MATHEMATICAL SCRIPT CAPITAL J -> MATHEMATICAL SCRIPT CAPITAL K
    charset += UIntSetRange(119977, 119980); // MATHEMATICAL SCRIPT CAPITAL N -> MATHEMATICAL SCRIPT CAPITAL Q
    charset += UIntSetRange(119982, 119993); // MATHEMATICAL SCRIPT CAPITAL S -> MATHEMATICAL SCRIPT SMALL D
    charset += UIntSetRange(119995, 119995); // MATHEMATICAL SCRIPT SMALL F -> MATHEMATICAL SCRIPT SMALL F
    charset += UIntSetRange(119997, 120003); // MATHEMATICAL SCRIPT SMALL H -> MATHEMATICAL SCRIPT SMALL N
    charset += UIntSetRange(120005, 120069); // MATHEMATICAL SCRIPT SMALL P -> MATHEMATICAL FRAKTUR CAPITAL B
    charset += UIntSetRange(120071, 120074); // MATHEMATICAL FRAKTUR CAPITAL D -> MATHEMATICAL FRAKTUR CAPITAL G
    charset += UIntSetRange(120077, 120084); // MATHEMATICAL FRAKTUR CAPITAL J -> MATHEMATICAL FRAKTUR CAPITAL Q
    charset += UIntSetRange(120086, 120092); // MATHEMATICAL FRAKTUR CAPITAL S -> MATHEMATICAL FRAKTUR CAPITAL Y
    charset += UIntSetRange(120094, 120121); // MATHEMATICAL FRAKTUR SMALL A -> MATHEMATICAL DOUBLE-STRUCK CAPITAL B
    charset += UIntSetRange(120123, 120126); // MATHEMATICAL DOUBLE-STRUCK CAPITAL D -> MATHEMATICAL DOUBLE-STRUCK CAPITAL G
    charset += UIntSetRange(120128, 120132); // MATHEMATICAL DOUBLE-STRUCK CAPITAL I -> MATHEMATICAL DOUBLE-STRUCK CAPITAL M
    charset += UIntSetRange(120134, 120134); // MATHEMATICAL DOUBLE-STRUCK CAPITAL O -> MATHEMATICAL DOUBLE-STRUCK CAPITAL O
    charset += UIntSetRange(120138, 120144); // MATHEMATICAL DOUBLE-STRUCK CAPITAL S -> MATHEMATICAL DOUBLE-STRUCK CAPITAL Y
    charset += UIntSetRange(120146, 120485); // MATHEMATICAL DOUBLE-STRUCK SMALL A -> MATHEMATICAL ITALIC SMALL DOTLESS J
    charset += UIntSetRange(120488, 120512); // MATHEMATICAL BOLD CAPITAL ALPHA -> MATHEMATICAL BOLD CAPITAL OMEGA
    charset += UIntSetRange(120514, 120538); // MATHEMATICAL BOLD SMALL ALPHA -> MATHEMATICAL BOLD SMALL OMEGA
    charset += UIntSetRange(120540, 120570); // MATHEMATICAL BOLD EPSILON SYMBOL -> MATHEMATICAL ITALIC CAPITAL OMEGA
    charset += UIntSetRange(120572, 120596); // MATHEMATICAL ITALIC SMALL ALPHA -> MATHEMATICAL ITALIC SMALL OMEGA
    charset += UIntSetRange(120598, 120628); // MATHEMATICAL ITALIC EPSILON SYMBOL -> MATHEMATICAL BOLD ITALIC CAPITAL OMEGA
    charset += UIntSetRange(120630, 120654); // MATHEMATICAL BOLD ITALIC SMALL ALPHA -> MATHEMATICAL BOLD ITALIC SMALL OMEGA
    charset += UIntSetRange(120656, 120686); // MATHEMATICAL BOLD ITALIC EPSILON SYMBOL -> MATHEMATICAL SANS-SERIF BOLD CAPITAL OMEGA
    charset += UIntSetRange(120688, 120712); // MATHEMATICAL SANS-SERIF BOLD SMALL ALPHA -> MATHEMATICAL SANS-SERIF BOLD SMALL OMEGA
    charset += UIntSetRange(120714, 120744); // MATHEMATICAL SANS-SERIF BOLD EPSILON SYMBOL -> MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL OMEGA
    charset += UIntSetRange(120746, 120770); // MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL ALPHA -> MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL OMEGA
    charset += UIntSetRange(120772, 120779); // MATHEMATICAL SANS-SERIF BOLD ITALIC EPSILON SYMBOL -> MATHEMATICAL BOLD SMALL DIGAMMA
    charset += UIntSetRange(131072, 173782); // -20000 -> -2A6D6
    charset += UIntSetRange(194560, 195101); // CJK COMPATIBILITY IDEOGRAPH-2F800 -> CJK COMPATIBILITY IDEOGRAPH-2FA1D
    return charset;
}


const UIntSet &named_charset_lower()
{
    static UIntSet charset;
    if( charset.count() )
        return charset;
    charset += UIntSetRange(97, 122); // LATIN SMALL LETTER A -> LATIN SMALL LETTER Z
    charset += UIntSetRange(170, 170); // FEMININE ORDINAL INDICATOR -> FEMININE ORDINAL INDICATOR
    charset += UIntSetRange(181, 181); // MICRO SIGN -> MICRO SIGN
    charset += UIntSetRange(186, 186); // MASCULINE ORDINAL INDICATOR -> MASCULINE ORDINAL INDICATOR
    charset += UIntSetRange(223, 246); // LATIN SMALL LETTER SHARP S -> LATIN SMALL LETTER O WITH DIAERESIS
    charset += UIntSetRange(248, 255); // LATIN SMALL LETTER O WITH STROKE -> LATIN SMALL LETTER Y WITH DIAERESIS
    charset += UIntSetRange(257, 257); // LATIN SMALL LETTER A WITH MACRON -> LATIN SMALL LETTER A WITH MACRON
    charset += UIntSetRange(259, 259); // LATIN SMALL LETTER A WITH BREVE -> LATIN SMALL LETTER A WITH BREVE
    charset += UIntSetRange(261, 261); // LATIN SMALL LETTER A WITH OGONEK -> LATIN SMALL LETTER A WITH OGONEK
    charset += UIntSetRange(263, 263); // LATIN SMALL LETTER C WITH ACUTE -> LATIN SMALL LETTER C WITH ACUTE
    charset += UIntSetRange(265, 265); // LATIN SMALL LETTER C WITH CIRCUMFLEX -> LATIN SMALL LETTER C WITH CIRCUMFLEX
    charset += UIntSetRange(267, 267); // LATIN SMALL LETTER C WITH DOT ABOVE -> LATIN SMALL LETTER C WITH DOT ABOVE
    charset += UIntSetRange(269, 269); // LATIN SMALL LETTER C WITH CARON -> LATIN SMALL LETTER C WITH CARON
    charset += UIntSetRange(271, 271); // LATIN SMALL LETTER D WITH CARON -> LATIN SMALL LETTER D WITH CARON
    charset += UIntSetRange(273, 273); // LATIN SMALL LETTER D WITH STROKE -> LATIN SMALL LETTER D WITH STROKE
    charset += UIntSetRange(275, 275); // LATIN SMALL LETTER E WITH MACRON -> LATIN SMALL LETTER E WITH MACRON
    charset += UIntSetRange(277, 277); // LATIN SMALL LETTER E WITH BREVE -> LATIN SMALL LETTER E WITH BREVE
    charset += UIntSetRange(279, 279); // LATIN SMALL LETTER E WITH DOT ABOVE -> LATIN SMALL LETTER E WITH DOT ABOVE
    charset += UIntSetRange(281, 281); // LATIN SMALL LETTER E WITH OGONEK -> LATIN SMALL LETTER E WITH OGONEK
    charset += UIntSetRange(283, 283); // LATIN SMALL LETTER E WITH CARON -> LATIN SMALL LETTER E WITH CARON
    charset += UIntSetRange(285, 285); // LATIN SMALL LETTER G WITH CIRCUMFLEX -> LATIN SMALL LETTER G WITH CIRCUMFLEX
    charset += UIntSetRange(287, 287); // LATIN SMALL LETTER G WITH BREVE -> LATIN SMALL LETTER G WITH BREVE
    charset += UIntSetRange(289, 289); // LATIN SMALL LETTER G WITH DOT ABOVE -> LATIN SMALL LETTER G WITH DOT ABOVE
    charset += UIntSetRange(291, 291); // LATIN SMALL LETTER G WITH CEDILLA -> LATIN SMALL LETTER G WITH CEDILLA
    charset += UIntSetRange(293, 293); // LATIN SMALL LETTER H WITH CIRCUMFLEX -> LATIN SMALL LETTER H WITH CIRCUMFLEX
    charset += UIntSetRange(295, 295); // LATIN SMALL LETTER H WITH STROKE -> LATIN SMALL LETTER H WITH STROKE
    charset += UIntSetRange(297, 297); // LATIN SMALL LETTER I WITH TILDE -> LATIN SMALL LETTER I WITH TILDE
    charset += UIntSetRange(299, 299); // LATIN SMALL LETTER I WITH MACRON -> LATIN SMALL LETTER I WITH MACRON
    charset += UIntSetRange(301, 301); // LATIN SMALL LETTER I WITH BREVE -> LATIN SMALL LETTER I WITH BREVE
    charset += UIntSetRange(303, 303); // LATIN SMALL LETTER I WITH OGONEK -> LATIN SMALL LETTER I WITH OGONEK
    charset += UIntSetRange(305, 305); // LATIN SMALL LETTER DOTLESS I -> LATIN SMALL LETTER DOTLESS I
    charset += UIntSetRange(307, 307); // LATIN SMALL LIGATURE IJ -> LATIN SMALL LIGATURE IJ
    charset += UIntSetRange(309, 309); // LATIN SMALL LETTER J WITH CIRCUMFLEX -> LATIN SMALL LETTER J WITH CIRCUMFLEX
    charset += UIntSetRange(311, 312); // LATIN SMALL LETTER K WITH CEDILLA -> LATIN SMALL LETTER KRA
    charset += UIntSetRange(314, 314); // LATIN SMALL LETTER L WITH ACUTE -> LATIN SMALL LETTER L WITH ACUTE
    charset += UIntSetRange(316, 316); // LATIN SMALL LETTER L WITH CEDILLA -> LATIN SMALL LETTER L WITH CEDILLA
    charset += UIntSetRange(318, 318); // LATIN SMALL LETTER L WITH CARON -> LATIN SMALL LETTER L WITH CARON
    charset += UIntSetRange(320, 320); // LATIN SMALL LETTER L WITH MIDDLE DOT -> LATIN SMALL LETTER L WITH MIDDLE DOT
    charset += UIntSetRange(322, 322); // LATIN SMALL LETTER L WITH STROKE -> LATIN SMALL LETTER L WITH STROKE
    charset += UIntSetRange(324, 324); // LATIN SMALL LETTER N WITH ACUTE -> LATIN SMALL LETTER N WITH ACUTE
    charset += UIntSetRange(326, 326); // LATIN SMALL LETTER N WITH CEDILLA -> LATIN SMALL LETTER N WITH CEDILLA
    charset += UIntSetRange(328, 329); // LATIN SMALL LETTER N WITH CARON -> LATIN SMALL LETTER N PRECEDED BY APOSTROPHE
    charset += UIntSetRange(331, 331); // LATIN SMALL LETTER ENG -> LATIN SMALL LETTER ENG
    charset += UIntSetRange(333, 333); // LATIN SMALL LETTER O WITH MACRON -> LATIN SMALL LETTER O WITH MACRON
    charset += UIntSetRange(335, 335); // LATIN SMALL LETTER O WITH BREVE -> LATIN SMALL LETTER O WITH BREVE
    charset += UIntSetRange(337, 337); // LATIN SMALL LETTER O WITH DOUBLE ACUTE -> LATIN SMALL LETTER O WITH DOUBLE ACUTE
    charset += UIntSetRange(339, 339); // LATIN SMALL LIGATURE OE -> LATIN SMALL LIGATURE OE
    charset += UIntSetRange(341, 341); // LATIN SMALL LETTER R WITH ACUTE -> LATIN SMALL LETTER R WITH ACUTE
    charset += UIntSetRange(343, 343); // LATIN SMALL LETTER R WITH CEDILLA -> LATIN SMALL LETTER R WITH CEDILLA
    charset += UIntSetRange(345, 345); // LATIN SMALL LETTER R WITH CARON -> LATIN SMALL LETTER R WITH CARON
    charset += UIntSetRange(347, 347); // LATIN SMALL LETTER S WITH ACUTE -> LATIN SMALL LETTER S WITH ACUTE
    charset += UIntSetRange(349, 349); // LATIN SMALL LETTER S WITH CIRCUMFLEX -> LATIN SMALL LETTER S WITH CIRCUMFLEX
    charset += UIntSetRange(351, 351); // LATIN SMALL LETTER S WITH CEDILLA -> LATIN SMALL LETTER S WITH CEDILLA
    charset += UIntSetRange(353, 353); // LATIN SMALL LETTER S WITH CARON -> LATIN SMALL LETTER S WITH CARON
    charset += UIntSetRange(355, 355); // LATIN SMALL LETTER T WITH CEDILLA -> LATIN SMALL LETTER T WITH CEDILLA
    charset += UIntSetRange(357, 357); // LATIN SMALL LETTER T WITH CARON -> LATIN SMALL LETTER T WITH CARON
    charset += UIntSetRange(359, 359); // LATIN SMALL LETTER T WITH STROKE -> LATIN SMALL LETTER T WITH STROKE
    charset += UIntSetRange(361, 361); // LATIN SMALL LETTER U WITH TILDE -> LATIN SMALL LETTER U WITH TILDE
    charset += UIntSetRange(363, 363); // LATIN SMALL LETTER U WITH MACRON -> LATIN SMALL LETTER U WITH MACRON
    charset += UIntSetRange(365, 365); // LATIN SMALL LETTER U WITH BREVE -> LATIN SMALL LETTER U WITH BREVE
    charset += UIntSetRange(367, 367); // LATIN SMALL LETTER U WITH RING ABOVE -> LATIN SMALL LETTER U WITH RING ABOVE
    charset += UIntSetRange(369, 369); // LATIN SMALL LETTER U WITH DOUBLE ACUTE -> LATIN SMALL LETTER U WITH DOUBLE ACUTE
    charset += UIntSetRange(371, 371); // LATIN SMALL LETTER U WITH OGONEK -> LATIN SMALL LETTER U WITH OGONEK
    charset += UIntSetRange(373, 373); // LATIN SMALL LETTER W WITH CIRCUMFLEX -> LATIN SMALL LETTER W WITH CIRCUMFLEX
    charset += UIntSetRange(375, 375); // LATIN SMALL LETTER Y WITH CIRCUMFLEX -> LATIN SMALL LETTER Y WITH CIRCUMFLEX
    charset += UIntSetRange(378, 378); // LATIN SMALL LETTER Z WITH ACUTE -> LATIN SMALL LETTER Z WITH ACUTE
    charset += UIntSetRange(380, 380); // LATIN SMALL LETTER Z WITH DOT ABOVE -> LATIN SMALL LETTER Z WITH DOT ABOVE
    charset += UIntSetRange(382, 384); // LATIN SMALL LETTER Z WITH CARON -> LATIN SMALL LETTER B WITH STROKE
    charset += UIntSetRange(387, 387); // LATIN SMALL LETTER B WITH TOPBAR -> LATIN SMALL LETTER B WITH TOPBAR
    charset += UIntSetRange(389, 389); // LATIN SMALL LETTER TONE SIX -> LATIN SMALL LETTER TONE SIX
    charset += UIntSetRange(392, 392); // LATIN SMALL LETTER C WITH HOOK -> LATIN SMALL LETTER C WITH HOOK
    charset += UIntSetRange(396, 397); // LATIN SMALL LETTER D WITH TOPBAR -> LATIN SMALL LETTER TURNED DELTA
    charset += UIntSetRange(402, 402); // LATIN SMALL LETTER F WITH HOOK -> LATIN SMALL LETTER F WITH HOOK
    charset += UIntSetRange(405, 405); // LATIN SMALL LETTER HV -> LATIN SMALL LETTER HV
    charset += UIntSetRange(409, 411); // LATIN SMALL LETTER K WITH HOOK -> LATIN SMALL LETTER LAMBDA WITH STROKE
    charset += UIntSetRange(414, 414); // LATIN SMALL LETTER N WITH LONG RIGHT LEG -> LATIN SMALL LETTER N WITH LONG RIGHT LEG
    charset += UIntSetRange(417, 417); // LATIN SMALL LETTER O WITH HORN -> LATIN SMALL LETTER O WITH HORN
    charset += UIntSetRange(419, 419); // LATIN SMALL LETTER OI -> LATIN SMALL LETTER OI
    charset += UIntSetRange(421, 421); // LATIN SMALL LETTER P WITH HOOK -> LATIN SMALL LETTER P WITH HOOK
    charset += UIntSetRange(424, 424); // LATIN SMALL LETTER TONE TWO -> LATIN SMALL LETTER TONE TWO
    charset += UIntSetRange(426, 427); // LATIN LETTER REVERSED ESH LOOP -> LATIN SMALL LETTER T WITH PALATAL HOOK
    charset += UIntSetRange(429, 429); // LATIN SMALL LETTER T WITH HOOK -> LATIN SMALL LETTER T WITH HOOK
    charset += UIntSetRange(432, 432); // LATIN SMALL LETTER U WITH HORN -> LATIN SMALL LETTER U WITH HORN
    charset += UIntSetRange(436, 436); // LATIN SMALL LETTER Y WITH HOOK -> LATIN SMALL LETTER Y WITH HOOK
    charset += UIntSetRange(438, 438); // LATIN SMALL LETTER Z WITH STROKE -> LATIN SMALL LETTER Z WITH STROKE
    charset += UIntSetRange(441, 442); // LATIN SMALL LETTER EZH REVERSED -> LATIN SMALL LETTER EZH WITH TAIL
    charset += UIntSetRange(445, 447); // LATIN SMALL LETTER TONE FIVE -> LATIN LETTER WYNN
    charset += UIntSetRange(454, 454); // LATIN SMALL LETTER DZ WITH CARON -> LATIN SMALL LETTER DZ WITH CARON
    charset += UIntSetRange(457, 457); // LATIN SMALL LETTER LJ -> LATIN SMALL LETTER LJ
    charset += UIntSetRange(460, 460); // LATIN SMALL LETTER NJ -> LATIN SMALL LETTER NJ
    charset += UIntSetRange(462, 462); // LATIN SMALL LETTER A WITH CARON -> LATIN SMALL LETTER A WITH CARON
    charset += UIntSetRange(464, 464); // LATIN SMALL LETTER I WITH CARON -> LATIN SMALL LETTER I WITH CARON
    charset += UIntSetRange(466, 466); // LATIN SMALL LETTER O WITH CARON -> LATIN SMALL LETTER O WITH CARON
    charset += UIntSetRange(468, 468); // LATIN SMALL LETTER U WITH CARON -> LATIN SMALL LETTER U WITH CARON
    charset += UIntSetRange(470, 470); // LATIN SMALL LETTER U WITH DIAERESIS AND MACRON -> LATIN SMALL LETTER U WITH DIAERESIS AND MACRON
    charset += UIntSetRange(472, 472); // LATIN SMALL LETTER U WITH DIAERESIS AND ACUTE -> LATIN SMALL LETTER U WITH DIAERESIS AND ACUTE
    charset += UIntSetRange(474, 474); // LATIN SMALL LETTER U WITH DIAERESIS AND CARON -> LATIN SMALL LETTER U WITH DIAERESIS AND CARON
    charset += UIntSetRange(476, 477); // LATIN SMALL LETTER U WITH DIAERESIS AND GRAVE -> LATIN SMALL LETTER TURNED E
    charset += UIntSetRange(479, 479); // LATIN SMALL LETTER A WITH DIAERESIS AND MACRON -> LATIN SMALL LETTER A WITH DIAERESIS AND MACRON
    charset += UIntSetRange(481, 481); // LATIN SMALL LETTER A WITH DOT ABOVE AND MACRON -> LATIN SMALL LETTER A WITH DOT ABOVE AND MACRON
    charset += UIntSetRange(483, 483); // LATIN SMALL LETTER AE WITH MACRON -> LATIN SMALL LETTER AE WITH MACRON
    charset += UIntSetRange(485, 485); // LATIN SMALL LETTER G WITH STROKE -> LATIN SMALL LETTER G WITH STROKE
    charset += UIntSetRange(487, 487); // LATIN SMALL LETTER G WITH CARON -> LATIN SMALL LETTER G WITH CARON
    charset += UIntSetRange(489, 489); // LATIN SMALL LETTER K WITH CARON -> LATIN SMALL LETTER K WITH CARON
    charset += UIntSetRange(491, 491); // LATIN SMALL LETTER O WITH OGONEK -> LATIN SMALL LETTER O WITH OGONEK
    charset += UIntSetRange(493, 493); // LATIN SMALL LETTER O WITH OGONEK AND MACRON -> LATIN SMALL LETTER O WITH OGONEK AND MACRON
    charset += UIntSetRange(495, 496); // LATIN SMALL LETTER EZH WITH CARON -> LATIN SMALL LETTER J WITH CARON
    charset += UIntSetRange(499, 499); // LATIN SMALL LETTER DZ -> LATIN SMALL LETTER DZ
    charset += UIntSetRange(501, 501); // LATIN SMALL LETTER G WITH ACUTE -> LATIN SMALL LETTER G WITH ACUTE
    charset += UIntSetRange(505, 505); // LATIN SMALL LETTER N WITH GRAVE -> LATIN SMALL LETTER N WITH GRAVE
    charset += UIntSetRange(507, 507); // LATIN SMALL LETTER A WITH RING ABOVE AND ACUTE -> LATIN SMALL LETTER A WITH RING ABOVE AND ACUTE
    charset += UIntSetRange(509, 509); // LATIN SMALL LETTER AE WITH ACUTE -> LATIN SMALL LETTER AE WITH ACUTE
    charset += UIntSetRange(511, 511); // LATIN SMALL LETTER O WITH STROKE AND ACUTE -> LATIN SMALL LETTER O WITH STROKE AND ACUTE
    charset += UIntSetRange(513, 513); // LATIN SMALL LETTER A WITH DOUBLE GRAVE -> LATIN SMALL LETTER A WITH DOUBLE GRAVE
    charset += UIntSetRange(515, 515); // LATIN SMALL LETTER A WITH INVERTED BREVE -> LATIN SMALL LETTER A WITH INVERTED BREVE
    charset += UIntSetRange(517, 517); // LATIN SMALL LETTER E WITH DOUBLE GRAVE -> LATIN SMALL LETTER E WITH DOUBLE GRAVE
    charset += UIntSetRange(519, 519); // LATIN SMALL LETTER E WITH INVERTED BREVE -> LATIN SMALL LETTER E WITH INVERTED BREVE
    charset += UIntSetRange(521, 521); // LATIN SMALL LETTER I WITH DOUBLE GRAVE -> LATIN SMALL LETTER I WITH DOUBLE GRAVE
    charset += UIntSetRange(523, 523); // LATIN SMALL LETTER I WITH INVERTED BREVE -> LATIN SMALL LETTER I WITH INVERTED BREVE
    charset += UIntSetRange(525, 525); // LATIN SMALL LETTER O WITH DOUBLE GRAVE -> LATIN SMALL LETTER O WITH DOUBLE GRAVE
    charset += UIntSetRange(527, 527); // LATIN SMALL LETTER O WITH INVERTED BREVE -> LATIN SMALL LETTER O WITH INVERTED BREVE
    charset += UIntSetRange(529, 529); // LATIN SMALL LETTER R WITH DOUBLE GRAVE -> LATIN SMALL LETTER R WITH DOUBLE GRAVE
    charset += UIntSetRange(531, 531); // LATIN SMALL LETTER R WITH INVERTED BREVE -> LATIN SMALL LETTER R WITH INVERTED BREVE
    charset += UIntSetRange(533, 533); // LATIN SMALL LETTER U WITH DOUBLE GRAVE -> LATIN SMALL LETTER U WITH DOUBLE GRAVE
    charset += UIntSetRange(535, 535); // LATIN SMALL LETTER U WITH INVERTED BREVE -> LATIN SMALL LETTER U WITH INVERTED BREVE
    charset += UIntSetRange(537, 537); // LATIN SMALL LETTER S WITH COMMA BELOW -> LATIN SMALL LETTER S WITH COMMA BELOW
    charset += UIntSetRange(539, 539); // LATIN SMALL LETTER T WITH COMMA BELOW -> LATIN SMALL LETTER T WITH COMMA BELOW
    charset += UIntSetRange(541, 541); // LATIN SMALL LETTER YOGH -> LATIN SMALL LETTER YOGH
    charset += UIntSetRange(543, 543); // LATIN SMALL LETTER H WITH CARON -> LATIN SMALL LETTER H WITH CARON
    charset += UIntSetRange(545, 545); // LATIN SMALL LETTER D WITH CURL -> LATIN SMALL LETTER D WITH CURL
    charset += UIntSetRange(547, 547); // LATIN SMALL LETTER OU -> LATIN SMALL LETTER OU
    charset += UIntSetRange(549, 549); // LATIN SMALL LETTER Z WITH HOOK -> LATIN SMALL LETTER Z WITH HOOK
    charset += UIntSetRange(551, 551); // LATIN SMALL LETTER A WITH DOT ABOVE -> LATIN SMALL LETTER A WITH DOT ABOVE
    charset += UIntSetRange(553, 553); // LATIN SMALL LETTER E WITH CEDILLA -> LATIN SMALL LETTER E WITH CEDILLA
    charset += UIntSetRange(555, 555); // LATIN SMALL LETTER O WITH DIAERESIS AND MACRON -> LATIN SMALL LETTER O WITH DIAERESIS AND MACRON
    charset += UIntSetRange(557, 557); // LATIN SMALL LETTER O WITH TILDE AND MACRON -> LATIN SMALL LETTER O WITH TILDE AND MACRON
    charset += UIntSetRange(559, 559); // LATIN SMALL LETTER O WITH DOT ABOVE -> LATIN SMALL LETTER O WITH DOT ABOVE
    charset += UIntSetRange(561, 561); // LATIN SMALL LETTER O WITH DOT ABOVE AND MACRON -> LATIN SMALL LETTER O WITH DOT ABOVE AND MACRON
    charset += UIntSetRange(563, 569); // LATIN SMALL LETTER Y WITH MACRON -> LATIN SMALL LETTER QP DIGRAPH
    charset += UIntSetRange(572, 572); // LATIN SMALL LETTER C WITH STROKE -> LATIN SMALL LETTER C WITH STROKE
    charset += UIntSetRange(575, 576); // LATIN SMALL LETTER S WITH SWASH TAIL -> LATIN SMALL LETTER Z WITH SWASH TAIL
    charset += UIntSetRange(578, 578); // LATIN SMALL LETTER GLOTTAL STOP -> LATIN SMALL LETTER GLOTTAL STOP
    charset += UIntSetRange(583, 583); // LATIN SMALL LETTER E WITH STROKE -> LATIN SMALL LETTER E WITH STROKE
    charset += UIntSetRange(585, 585); // LATIN SMALL LETTER J WITH STROKE -> LATIN SMALL LETTER J WITH STROKE
    charset += UIntSetRange(587, 587); // LATIN SMALL LETTER Q WITH HOOK TAIL -> LATIN SMALL LETTER Q WITH HOOK TAIL
    charset += UIntSetRange(589, 589); // LATIN SMALL LETTER R WITH STROKE -> LATIN SMALL LETTER R WITH STROKE
    charset += UIntSetRange(591, 659); // LATIN SMALL LETTER Y WITH STROKE -> LATIN SMALL LETTER EZH WITH CURL
    charset += UIntSetRange(661, 687); // LATIN LETTER PHARYNGEAL VOICED FRICATIVE -> LATIN SMALL LETTER TURNED H WITH FISHHOOK AND TAIL
    charset += UIntSetRange(881, 881); // GREEK SMALL LETTER HETA -> GREEK SMALL LETTER HETA
    charset += UIntSetRange(883, 883); // GREEK SMALL LETTER ARCHAIC SAMPI -> GREEK SMALL LETTER ARCHAIC SAMPI
    charset += UIntSetRange(887, 887); // GREEK SMALL LETTER PAMPHYLIAN DIGAMMA -> GREEK SMALL LETTER PAMPHYLIAN DIGAMMA
    charset += UIntSetRange(891, 893); // GREEK SMALL REVERSED LUNATE SIGMA SYMBOL -> GREEK SMALL REVERSED DOTTED LUNATE SIGMA SYMBOL
    charset += UIntSetRange(912, 912); // GREEK SMALL LETTER IOTA WITH DIALYTIKA AND TONOS -> GREEK SMALL LETTER IOTA WITH DIALYTIKA AND TONOS
    charset += UIntSetRange(940, 974); // GREEK SMALL LETTER ALPHA WITH TONOS -> GREEK SMALL LETTER OMEGA WITH TONOS
    charset += UIntSetRange(976, 977); // GREEK BETA SYMBOL -> GREEK THETA SYMBOL
    charset += UIntSetRange(981, 983); // GREEK PHI SYMBOL -> GREEK KAI SYMBOL
    charset += UIntSetRange(985, 985); // GREEK SMALL LETTER ARCHAIC KOPPA -> GREEK SMALL LETTER ARCHAIC KOPPA
    charset += UIntSetRange(987, 987); // GREEK SMALL LETTER STIGMA -> GREEK SMALL LETTER STIGMA
    charset += UIntSetRange(989, 989); // GREEK SMALL LETTER DIGAMMA -> GREEK SMALL LETTER DIGAMMA
    charset += UIntSetRange(991, 991); // GREEK SMALL LETTER KOPPA -> GREEK SMALL LETTER KOPPA
    charset += UIntSetRange(993, 993); // GREEK SMALL LETTER SAMPI -> GREEK SMALL LETTER SAMPI
    charset += UIntSetRange(995, 995); // COPTIC SMALL LETTER SHEI -> COPTIC SMALL LETTER SHEI
    charset += UIntSetRange(997, 997); // COPTIC SMALL LETTER FEI -> COPTIC SMALL LETTER FEI
    charset += UIntSetRange(999, 999); // COPTIC SMALL LETTER KHEI -> COPTIC SMALL LETTER KHEI
    charset += UIntSetRange(1001, 1001); // COPTIC SMALL LETTER HORI -> COPTIC SMALL LETTER HORI
    charset += UIntSetRange(1003, 1003); // COPTIC SMALL LETTER GANGIA -> COPTIC SMALL LETTER GANGIA
    charset += UIntSetRange(1005, 1005); // COPTIC SMALL LETTER SHIMA -> COPTIC SMALL LETTER SHIMA
    charset += UIntSetRange(1007, 1011); // COPTIC SMALL LETTER DEI -> GREEK LETTER YOT
    charset += UIntSetRange(1013, 1013); // GREEK LUNATE EPSILON SYMBOL -> GREEK LUNATE EPSILON SYMBOL
    charset += UIntSetRange(1016, 1016); // GREEK SMALL LETTER SHO -> GREEK SMALL LETTER SHO
    charset += UIntSetRange(1019, 1020); // GREEK SMALL LETTER SAN -> GREEK RHO WITH STROKE SYMBOL
    charset += UIntSetRange(1072, 1119); // CYRILLIC SMALL LETTER A -> CYRILLIC SMALL LETTER DZHE
    charset += UIntSetRange(1121, 1121); // CYRILLIC SMALL LETTER OMEGA -> CYRILLIC SMALL LETTER OMEGA
    charset += UIntSetRange(1123, 1123); // CYRILLIC SMALL LETTER YAT -> CYRILLIC SMALL LETTER YAT
    charset += UIntSetRange(1125, 1125); // CYRILLIC SMALL LETTER IOTIFIED E -> CYRILLIC SMALL LETTER IOTIFIED E
    charset += UIntSetRange(1127, 1127); // CYRILLIC SMALL LETTER LITTLE YUS -> CYRILLIC SMALL LETTER LITTLE YUS
    charset += UIntSetRange(1129, 1129); // CYRILLIC SMALL LETTER IOTIFIED LITTLE YUS -> CYRILLIC SMALL LETTER IOTIFIED LITTLE YUS
    charset += UIntSetRange(1131, 1131); // CYRILLIC SMALL LETTER BIG YUS -> CYRILLIC SMALL LETTER BIG YUS
    charset += UIntSetRange(1133, 1133); // CYRILLIC SMALL LETTER IOTIFIED BIG YUS -> CYRILLIC SMALL LETTER IOTIFIED BIG YUS
    charset += UIntSetRange(1135, 1135); // CYRILLIC SMALL LETTER KSI -> CYRILLIC SMALL LETTER KSI
    charset += UIntSetRange(1137, 1137); // CYRILLIC SMALL LETTER PSI -> CYRILLIC SMALL LETTER PSI
    charset += UIntSetRange(1139, 1139); // CYRILLIC SMALL LETTER FITA -> CYRILLIC SMALL LETTER FITA
    charset += UIntSetRange(1141, 1141); // CYRILLIC SMALL LETTER IZHITSA -> CYRILLIC SMALL LETTER IZHITSA
    charset += UIntSetRange(1143, 1143); // CYRILLIC SMALL LETTER IZHITSA WITH DOUBLE GRAVE ACCENT -> CYRILLIC SMALL LETTER IZHITSA WITH DOUBLE GRAVE ACCENT
    charset += UIntSetRange(1145, 1145); // CYRILLIC SMALL LETTER UK -> CYRILLIC SMALL LETTER UK
    charset += UIntSetRange(1147, 1147); // CYRILLIC SMALL LETTER ROUND OMEGA -> CYRILLIC SMALL LETTER ROUND OMEGA
    charset += UIntSetRange(1149, 1149); // CYRILLIC SMALL LETTER OMEGA WITH TITLO -> CYRILLIC SMALL LETTER OMEGA WITH TITLO
    charset += UIntSetRange(1151, 1151); // CYRILLIC SMALL LETTER OT -> CYRILLIC SMALL LETTER OT
    charset += UIntSetRange(1153, 1153); // CYRILLIC SMALL LETTER KOPPA -> CYRILLIC SMALL LETTER KOPPA
    charset += UIntSetRange(1163, 1163); // CYRILLIC SMALL LETTER SHORT I WITH TAIL -> CYRILLIC SMALL LETTER SHORT I WITH TAIL
    charset += UIntSetRange(1165, 1165); // CYRILLIC SMALL LETTER SEMISOFT SIGN -> CYRILLIC SMALL LETTER SEMISOFT SIGN
    charset += UIntSetRange(1167, 1167); // CYRILLIC SMALL LETTER ER WITH TICK -> CYRILLIC SMALL LETTER ER WITH TICK
    charset += UIntSetRange(1169, 1169); // CYRILLIC SMALL LETTER GHE WITH UPTURN -> CYRILLIC SMALL LETTER GHE WITH UPTURN
    charset += UIntSetRange(1171, 1171); // CYRILLIC SMALL LETTER GHE WITH STROKE -> CYRILLIC SMALL LETTER GHE WITH STROKE
    charset += UIntSetRange(1173, 1173); // CYRILLIC SMALL LETTER GHE WITH MIDDLE HOOK -> CYRILLIC SMALL LETTER GHE WITH MIDDLE HOOK
    charset += UIntSetRange(1175, 1175); // CYRILLIC SMALL LETTER ZHE WITH DESCENDER -> CYRILLIC SMALL LETTER ZHE WITH DESCENDER
    charset += UIntSetRange(1177, 1177); // CYRILLIC SMALL LETTER ZE WITH DESCENDER -> CYRILLIC SMALL LETTER ZE WITH DESCENDER
    charset += UIntSetRange(1179, 1179); // CYRILLIC SMALL LETTER KA WITH DESCENDER -> CYRILLIC SMALL LETTER KA WITH DESCENDER
    charset += UIntSetRange(1181, 1181); // CYRILLIC SMALL LETTER KA WITH VERTICAL STROKE -> CYRILLIC SMALL LETTER KA WITH VERTICAL STROKE
    charset += UIntSetRange(1183, 1183); // CYRILLIC SMALL LETTER KA WITH STROKE -> CYRILLIC SMALL LETTER KA WITH STROKE
    charset += UIntSetRange(1185, 1185); // CYRILLIC SMALL LETTER BASHKIR KA -> CYRILLIC SMALL LETTER BASHKIR KA
    charset += UIntSetRange(1187, 1187); // CYRILLIC SMALL LETTER EN WITH DESCENDER -> CYRILLIC SMALL LETTER EN WITH DESCENDER
    charset += UIntSetRange(1189, 1189); // CYRILLIC SMALL LIGATURE EN GHE -> CYRILLIC SMALL LIGATURE EN GHE
    charset += UIntSetRange(1191, 1191); // CYRILLIC SMALL LETTER PE WITH MIDDLE HOOK -> CYRILLIC SMALL LETTER PE WITH MIDDLE HOOK
    charset += UIntSetRange(1193, 1193); // CYRILLIC SMALL LETTER ABKHASIAN HA -> CYRILLIC SMALL LETTER ABKHASIAN HA
    charset += UIntSetRange(1195, 1195); // CYRILLIC SMALL LETTER ES WITH DESCENDER -> CYRILLIC SMALL LETTER ES WITH DESCENDER
    charset += UIntSetRange(1197, 1197); // CYRILLIC SMALL LETTER TE WITH DESCENDER -> CYRILLIC SMALL LETTER TE WITH DESCENDER
    charset += UIntSetRange(1199, 1199); // CYRILLIC SMALL LETTER STRAIGHT U -> CYRILLIC SMALL LETTER STRAIGHT U
    charset += UIntSetRange(1201, 1201); // CYRILLIC SMALL LETTER STRAIGHT U WITH STROKE -> CYRILLIC SMALL LETTER STRAIGHT U WITH STROKE
    charset += UIntSetRange(1203, 1203); // CYRILLIC SMALL LETTER HA WITH DESCENDER -> CYRILLIC SMALL LETTER HA WITH DESCENDER
    charset += UIntSetRange(1205, 1205); // CYRILLIC SMALL LIGATURE TE TSE -> CYRILLIC SMALL LIGATURE TE TSE
    charset += UIntSetRange(1207, 1207); // CYRILLIC SMALL LETTER CHE WITH DESCENDER -> CYRILLIC SMALL LETTER CHE WITH DESCENDER
    charset += UIntSetRange(1209, 1209); // CYRILLIC SMALL LETTER CHE WITH VERTICAL STROKE -> CYRILLIC SMALL LETTER CHE WITH VERTICAL STROKE
    charset += UIntSetRange(1211, 1211); // CYRILLIC SMALL LETTER SHHA -> CYRILLIC SMALL LETTER SHHA
    charset += UIntSetRange(1213, 1213); // CYRILLIC SMALL LETTER ABKHASIAN CHE -> CYRILLIC SMALL LETTER ABKHASIAN CHE
    charset += UIntSetRange(1215, 1215); // CYRILLIC SMALL LETTER ABKHASIAN CHE WITH DESCENDER -> CYRILLIC SMALL LETTER ABKHASIAN CHE WITH DESCENDER
    charset += UIntSetRange(1218, 1218); // CYRILLIC SMALL LETTER ZHE WITH BREVE -> CYRILLIC SMALL LETTER ZHE WITH BREVE
    charset += UIntSetRange(1220, 1220); // CYRILLIC SMALL LETTER KA WITH HOOK -> CYRILLIC SMALL LETTER KA WITH HOOK
    charset += UIntSetRange(1222, 1222); // CYRILLIC SMALL LETTER EL WITH TAIL -> CYRILLIC SMALL LETTER EL WITH TAIL
    charset += UIntSetRange(1224, 1224); // CYRILLIC SMALL LETTER EN WITH HOOK -> CYRILLIC SMALL LETTER EN WITH HOOK
    charset += UIntSetRange(1226, 1226); // CYRILLIC SMALL LETTER EN WITH TAIL -> CYRILLIC SMALL LETTER EN WITH TAIL
    charset += UIntSetRange(1228, 1228); // CYRILLIC SMALL LETTER KHAKASSIAN CHE -> CYRILLIC SMALL LETTER KHAKASSIAN CHE
    charset += UIntSetRange(1230, 1231); // CYRILLIC SMALL LETTER EM WITH TAIL -> CYRILLIC SMALL LETTER PALOCHKA
    charset += UIntSetRange(1233, 1233); // CYRILLIC SMALL LETTER A WITH BREVE -> CYRILLIC SMALL LETTER A WITH BREVE
    charset += UIntSetRange(1235, 1235); // CYRILLIC SMALL LETTER A WITH DIAERESIS -> CYRILLIC SMALL LETTER A WITH DIAERESIS
    charset += UIntSetRange(1237, 1237); // CYRILLIC SMALL LIGATURE A IE -> CYRILLIC SMALL LIGATURE A IE
    charset += UIntSetRange(1239, 1239); // CYRILLIC SMALL LETTER IE WITH BREVE -> CYRILLIC SMALL LETTER IE WITH BREVE
    charset += UIntSetRange(1241, 1241); // CYRILLIC SMALL LETTER SCHWA -> CYRILLIC SMALL LETTER SCHWA
    charset += UIntSetRange(1243, 1243); // CYRILLIC SMALL LETTER SCHWA WITH DIAERESIS -> CYRILLIC SMALL LETTER SCHWA WITH DIAERESIS
    charset += UIntSetRange(1245, 1245); // CYRILLIC SMALL LETTER ZHE WITH DIAERESIS -> CYRILLIC SMALL LETTER ZHE WITH DIAERESIS
    charset += UIntSetRange(1247, 1247); // CYRILLIC SMALL LETTER ZE WITH DIAERESIS -> CYRILLIC SMALL LETTER ZE WITH DIAERESIS
    charset += UIntSetRange(1249, 1249); // CYRILLIC SMALL LETTER ABKHASIAN DZE -> CYRILLIC SMALL LETTER ABKHASIAN DZE
    charset += UIntSetRange(1251, 1251); // CYRILLIC SMALL LETTER I WITH MACRON -> CYRILLIC SMALL LETTER I WITH MACRON
    charset += UIntSetRange(1253, 1253); // CYRILLIC SMALL LETTER I WITH DIAERESIS -> CYRILLIC SMALL LETTER I WITH DIAERESIS
    charset += UIntSetRange(1255, 1255); // CYRILLIC SMALL LETTER O WITH DIAERESIS -> CYRILLIC SMALL LETTER O WITH DIAERESIS
    charset += UIntSetRange(1257, 1257); // CYRILLIC SMALL LETTER BARRED O -> CYRILLIC SMALL LETTER BARRED O
    charset += UIntSetRange(1259, 1259); // CYRILLIC SMALL LETTER BARRED O WITH DIAERESIS -> CYRILLIC SMALL LETTER BARRED O WITH DIAERESIS
    charset += UIntSetRange(1261, 1261); // CYRILLIC SMALL LETTER E WITH DIAERESIS -> CYRILLIC SMALL LETTER E WITH DIAERESIS
    charset += UIntSetRange(1263, 1263); // CYRILLIC SMALL LETTER U WITH MACRON -> CYRILLIC SMALL LETTER U WITH MACRON
    charset += UIntSetRange(1265, 1265); // CYRILLIC SMALL LETTER U WITH DIAERESIS -> CYRILLIC SMALL LETTER U WITH DIAERESIS
    charset += UIntSetRange(1267, 1267); // CYRILLIC SMALL LETTER U WITH DOUBLE ACUTE -> CYRILLIC SMALL LETTER U WITH DOUBLE ACUTE
    charset += UIntSetRange(1269, 1269); // CYRILLIC SMALL LETTER CHE WITH DIAERESIS -> CYRILLIC SMALL LETTER CHE WITH DIAERESIS
    charset += UIntSetRange(1271, 1271); // CYRILLIC SMALL LETTER GHE WITH DESCENDER -> CYRILLIC SMALL LETTER GHE WITH DESCENDER
    charset += UIntSetRange(1273, 1273); // CYRILLIC SMALL LETTER YERU WITH DIAERESIS -> CYRILLIC SMALL LETTER YERU WITH DIAERESIS
    charset += UIntSetRange(1275, 1275); // CYRILLIC SMALL LETTER GHE WITH STROKE AND HOOK -> CYRILLIC SMALL LETTER GHE WITH STROKE AND HOOK
    charset += UIntSetRange(1277, 1277); // CYRILLIC SMALL LETTER HA WITH HOOK -> CYRILLIC SMALL LETTER HA WITH HOOK
    charset += UIntSetRange(1279, 1279); // CYRILLIC SMALL LETTER HA WITH STROKE -> CYRILLIC SMALL LETTER HA WITH STROKE
    charset += UIntSetRange(1281, 1281); // CYRILLIC SMALL LETTER KOMI DE -> CYRILLIC SMALL LETTER KOMI DE
    charset += UIntSetRange(1283, 1283); // CYRILLIC SMALL LETTER KOMI DJE -> CYRILLIC SMALL LETTER KOMI DJE
    charset += UIntSetRange(1285, 1285); // CYRILLIC SMALL LETTER KOMI ZJE -> CYRILLIC SMALL LETTER KOMI ZJE
    charset += UIntSetRange(1287, 1287); // CYRILLIC SMALL LETTER KOMI DZJE -> CYRILLIC SMALL LETTER KOMI DZJE
    charset += UIntSetRange(1289, 1289); // CYRILLIC SMALL LETTER KOMI LJE -> CYRILLIC SMALL LETTER KOMI LJE
    charset += UIntSetRange(1291, 1291); // CYRILLIC SMALL LETTER KOMI NJE -> CYRILLIC SMALL LETTER KOMI NJE
    charset += UIntSetRange(1293, 1293); // CYRILLIC SMALL LETTER KOMI SJE -> CYRILLIC SMALL LETTER KOMI SJE
    charset += UIntSetRange(1295, 1295); // CYRILLIC SMALL LETTER KOMI TJE -> CYRILLIC SMALL LETTER KOMI TJE
    charset += UIntSetRange(1297, 1297); // CYRILLIC SMALL LETTER REVERSED ZE -> CYRILLIC SMALL LETTER REVERSED ZE
    charset += UIntSetRange(1299, 1299); // CYRILLIC SMALL LETTER EL WITH HOOK -> CYRILLIC SMALL LETTER EL WITH HOOK
    charset += UIntSetRange(1301, 1301); // CYRILLIC SMALL LETTER LHA -> CYRILLIC SMALL LETTER LHA
    charset += UIntSetRange(1303, 1303); // CYRILLIC SMALL LETTER RHA -> CYRILLIC SMALL LETTER RHA
    charset += UIntSetRange(1305, 1305); // CYRILLIC SMALL LETTER YAE -> CYRILLIC SMALL LETTER YAE
    charset += UIntSetRange(1307, 1307); // CYRILLIC SMALL LETTER QA -> CYRILLIC SMALL LETTER QA
    charset += UIntSetRange(1309, 1309); // CYRILLIC SMALL LETTER WE -> CYRILLIC SMALL LETTER WE
    charset += UIntSetRange(1311, 1311); // CYRILLIC SMALL LETTER ALEUT KA -> CYRILLIC SMALL LETTER ALEUT KA
    charset += UIntSetRange(1313, 1313); // CYRILLIC SMALL LETTER EL WITH MIDDLE HOOK -> CYRILLIC SMALL LETTER EL WITH MIDDLE HOOK
    charset += UIntSetRange(1315, 1315); // CYRILLIC SMALL LETTER EN WITH MIDDLE HOOK -> CYRILLIC SMALL LETTER EN WITH MIDDLE HOOK
    charset += UIntSetRange(1377, 1415); // ARMENIAN SMALL LETTER AYB -> ARMENIAN SMALL LIGATURE ECH YIWN
    charset += UIntSetRange(7424, 7467); // LATIN LETTER SMALL CAPITAL A -> CYRILLIC LETTER SMALL CAPITAL EL
    charset += UIntSetRange(7522, 7543); // LATIN SUBSCRIPT SMALL LETTER I -> LATIN SMALL LETTER TURNED G
    charset += UIntSetRange(7545, 7578); // LATIN SMALL LETTER INSULAR G -> LATIN SMALL LETTER EZH WITH RETROFLEX HOOK
    charset += UIntSetRange(7681, 7681); // LATIN SMALL LETTER A WITH RING BELOW -> LATIN SMALL LETTER A WITH RING BELOW
    charset += UIntSetRange(7683, 7683); // LATIN SMALL LETTER B WITH DOT ABOVE -> LATIN SMALL LETTER B WITH DOT ABOVE
    charset += UIntSetRange(7685, 7685); // LATIN SMALL LETTER B WITH DOT BELOW -> LATIN SMALL LETTER B WITH DOT BELOW
    charset += UIntSetRange(7687, 7687); // LATIN SMALL LETTER B WITH LINE BELOW -> LATIN SMALL LETTER B WITH LINE BELOW
    charset += UIntSetRange(7689, 7689); // LATIN SMALL LETTER C WITH CEDILLA AND ACUTE -> LATIN SMALL LETTER C WITH CEDILLA AND ACUTE
    charset += UIntSetRange(7691, 7691); // LATIN SMALL LETTER D WITH DOT ABOVE -> LATIN SMALL LETTER D WITH DOT ABOVE
    charset += UIntSetRange(7693, 7693); // LATIN SMALL LETTER D WITH DOT BELOW -> LATIN SMALL LETTER D WITH DOT BELOW
    charset += UIntSetRange(7695, 7695); // LATIN SMALL LETTER D WITH LINE BELOW -> LATIN SMALL LETTER D WITH LINE BELOW
    charset += UIntSetRange(7697, 7697); // LATIN SMALL LETTER D WITH CEDILLA -> LATIN SMALL LETTER D WITH CEDILLA
    charset += UIntSetRange(7699, 7699); // LATIN SMALL LETTER D WITH CIRCUMFLEX BELOW -> LATIN SMALL LETTER D WITH CIRCUMFLEX BELOW
    charset += UIntSetRange(7701, 7701); // LATIN SMALL LETTER E WITH MACRON AND GRAVE -> LATIN SMALL LETTER E WITH MACRON AND GRAVE
    charset += UIntSetRange(7703, 7703); // LATIN SMALL LETTER E WITH MACRON AND ACUTE -> LATIN SMALL LETTER E WITH MACRON AND ACUTE
    charset += UIntSetRange(7705, 7705); // LATIN SMALL LETTER E WITH CIRCUMFLEX BELOW -> LATIN SMALL LETTER E WITH CIRCUMFLEX BELOW
    charset += UIntSetRange(7707, 7707); // LATIN SMALL LETTER E WITH TILDE BELOW -> LATIN SMALL LETTER E WITH TILDE BELOW
    charset += UIntSetRange(7709, 7709); // LATIN SMALL LETTER E WITH CEDILLA AND BREVE -> LATIN SMALL LETTER E WITH CEDILLA AND BREVE
    charset += UIntSetRange(7711, 7711); // LATIN SMALL LETTER F WITH DOT ABOVE -> LATIN SMALL LETTER F WITH DOT ABOVE
    charset += UIntSetRange(7713, 7713); // LATIN SMALL LETTER G WITH MACRON -> LATIN SMALL LETTER G WITH MACRON
    charset += UIntSetRange(7715, 7715); // LATIN SMALL LETTER H WITH DOT ABOVE -> LATIN SMALL LETTER H WITH DOT ABOVE
    charset += UIntSetRange(7717, 7717); // LATIN SMALL LETTER H WITH DOT BELOW -> LATIN SMALL LETTER H WITH DOT BELOW
    charset += UIntSetRange(7719, 7719); // LATIN SMALL LETTER H WITH DIAERESIS -> LATIN SMALL LETTER H WITH DIAERESIS
    charset += UIntSetRange(7721, 7721); // LATIN SMALL LETTER H WITH CEDILLA -> LATIN SMALL LETTER H WITH CEDILLA
    charset += UIntSetRange(7723, 7723); // LATIN SMALL LETTER H WITH BREVE BELOW -> LATIN SMALL LETTER H WITH BREVE BELOW
    charset += UIntSetRange(7725, 7725); // LATIN SMALL LETTER I WITH TILDE BELOW -> LATIN SMALL LETTER I WITH TILDE BELOW
    charset += UIntSetRange(7727, 7727); // LATIN SMALL LETTER I WITH DIAERESIS AND ACUTE -> LATIN SMALL LETTER I WITH DIAERESIS AND ACUTE
    charset += UIntSetRange(7729, 7729); // LATIN SMALL LETTER K WITH ACUTE -> LATIN SMALL LETTER K WITH ACUTE
    charset += UIntSetRange(7731, 7731); // LATIN SMALL LETTER K WITH DOT BELOW -> LATIN SMALL LETTER K WITH DOT BELOW
    charset += UIntSetRange(7733, 7733); // LATIN SMALL LETTER K WITH LINE BELOW -> LATIN SMALL LETTER K WITH LINE BELOW
    charset += UIntSetRange(7735, 7735); // LATIN SMALL LETTER L WITH DOT BELOW -> LATIN SMALL LETTER L WITH DOT BELOW
    charset += UIntSetRange(7737, 7737); // LATIN SMALL LETTER L WITH DOT BELOW AND MACRON -> LATIN SMALL LETTER L WITH DOT BELOW AND MACRON
    charset += UIntSetRange(7739, 7739); // LATIN SMALL LETTER L WITH LINE BELOW -> LATIN SMALL LETTER L WITH LINE BELOW
    charset += UIntSetRange(7741, 7741); // LATIN SMALL LETTER L WITH CIRCUMFLEX BELOW -> LATIN SMALL LETTER L WITH CIRCUMFLEX BELOW
    charset += UIntSetRange(7743, 7743); // LATIN SMALL LETTER M WITH ACUTE -> LATIN SMALL LETTER M WITH ACUTE
    charset += UIntSetRange(7745, 7745); // LATIN SMALL LETTER M WITH DOT ABOVE -> LATIN SMALL LETTER M WITH DOT ABOVE
    charset += UIntSetRange(7747, 7747); // LATIN SMALL LETTER M WITH DOT BELOW -> LATIN SMALL LETTER M WITH DOT BELOW
    charset += UIntSetRange(7749, 7749); // LATIN SMALL LETTER N WITH DOT ABOVE -> LATIN SMALL LETTER N WITH DOT ABOVE
    charset += UIntSetRange(7751, 7751); // LATIN SMALL LETTER N WITH DOT BELOW -> LATIN SMALL LETTER N WITH DOT BELOW
    charset += UIntSetRange(7753, 7753); // LATIN SMALL LETTER N WITH LINE BELOW -> LATIN SMALL LETTER N WITH LINE BELOW
    charset += UIntSetRange(7755, 7755); // LATIN SMALL LETTER N WITH CIRCUMFLEX BELOW -> LATIN SMALL LETTER N WITH CIRCUMFLEX BELOW
    charset += UIntSetRange(7757, 7757); // LATIN SMALL LETTER O WITH TILDE AND ACUTE -> LATIN SMALL LETTER O WITH TILDE AND ACUTE
    charset += UIntSetRange(7759, 7759); // LATIN SMALL LETTER O WITH TILDE AND DIAERESIS -> LATIN SMALL LETTER O WITH TILDE AND DIAERESIS
    charset += UIntSetRange(7761, 7761); // LATIN SMALL LETTER O WITH MACRON AND GRAVE -> LATIN SMALL LETTER O WITH MACRON AND GRAVE
    charset += UIntSetRange(7763, 7763); // LATIN SMALL LETTER O WITH MACRON AND ACUTE -> LATIN SMALL LETTER O WITH MACRON AND ACUTE
    charset += UIntSetRange(7765, 7765); // LATIN SMALL LETTER P WITH ACUTE -> LATIN SMALL LETTER P WITH ACUTE
    charset += UIntSetRange(7767, 7767); // LATIN SMALL LETTER P WITH DOT ABOVE -> LATIN SMALL LETTER P WITH DOT ABOVE
    charset += UIntSetRange(7769, 7769); // LATIN SMALL LETTER R WITH DOT ABOVE -> LATIN SMALL LETTER R WITH DOT ABOVE
    charset += UIntSetRange(7771, 7771); // LATIN SMALL LETTER R WITH DOT BELOW -> LATIN SMALL LETTER R WITH DOT BELOW
    charset += UIntSetRange(7773, 7773); // LATIN SMALL LETTER R WITH DOT BELOW AND MACRON -> LATIN SMALL LETTER R WITH DOT BELOW AND MACRON
    charset += UIntSetRange(7775, 7775); // LATIN SMALL LETTER R WITH LINE BELOW -> LATIN SMALL LETTER R WITH LINE BELOW
    charset += UIntSetRange(7777, 7777); // LATIN SMALL LETTER S WITH DOT ABOVE -> LATIN SMALL LETTER S WITH DOT ABOVE
    charset += UIntSetRange(7779, 7779); // LATIN SMALL LETTER S WITH DOT BELOW -> LATIN SMALL LETTER S WITH DOT BELOW
    charset += UIntSetRange(7781, 7781); // LATIN SMALL LETTER S WITH ACUTE AND DOT ABOVE -> LATIN SMALL LETTER S WITH ACUTE AND DOT ABOVE
    charset += UIntSetRange(7783, 7783); // LATIN SMALL LETTER S WITH CARON AND DOT ABOVE -> LATIN SMALL LETTER S WITH CARON AND DOT ABOVE
    charset += UIntSetRange(7785, 7785); // LATIN SMALL LETTER S WITH DOT BELOW AND DOT ABOVE -> LATIN SMALL LETTER S WITH DOT BELOW AND DOT ABOVE
    charset += UIntSetRange(7787, 7787); // LATIN SMALL LETTER T WITH DOT ABOVE -> LATIN SMALL LETTER T WITH DOT ABOVE
    charset += UIntSetRange(7789, 7789); // LATIN SMALL LETTER T WITH DOT BELOW -> LATIN SMALL LETTER T WITH DOT BELOW
    charset += UIntSetRange(7791, 7791); // LATIN SMALL LETTER T WITH LINE BELOW -> LATIN SMALL LETTER T WITH LINE BELOW
    charset += UIntSetRange(7793, 7793); // LATIN SMALL LETTER T WITH CIRCUMFLEX BELOW -> LATIN SMALL LETTER T WITH CIRCUMFLEX BELOW
    charset += UIntSetRange(7795, 7795); // LATIN SMALL LETTER U WITH DIAERESIS BELOW -> LATIN SMALL LETTER U WITH DIAERESIS BELOW
    charset += UIntSetRange(7797, 7797); // LATIN SMALL LETTER U WITH TILDE BELOW -> LATIN SMALL LETTER U WITH TILDE BELOW
    charset += UIntSetRange(7799, 7799); // LATIN SMALL LETTER U WITH CIRCUMFLEX BELOW -> LATIN SMALL LETTER U WITH CIRCUMFLEX BELOW
    charset += UIntSetRange(7801, 7801); // LATIN SMALL LETTER U WITH TILDE AND ACUTE -> LATIN SMALL LETTER U WITH TILDE AND ACUTE
    charset += UIntSetRange(7803, 7803); // LATIN SMALL LETTER U WITH MACRON AND DIAERESIS -> LATIN SMALL LETTER U WITH MACRON AND DIAERESIS
    charset += UIntSetRange(7805, 7805); // LATIN SMALL LETTER V WITH TILDE -> LATIN SMALL LETTER V WITH TILDE
    charset += UIntSetRange(7807, 7807); // LATIN SMALL LETTER V WITH DOT BELOW -> LATIN SMALL LETTER V WITH DOT BELOW
    charset += UIntSetRange(7809, 7809); // LATIN SMALL LETTER W WITH GRAVE -> LATIN SMALL LETTER W WITH GRAVE
    charset += UIntSetRange(7811, 7811); // LATIN SMALL LETTER W WITH ACUTE -> LATIN SMALL LETTER W WITH ACUTE
    charset += UIntSetRange(7813, 7813); // LATIN SMALL LETTER W WITH DIAERESIS -> LATIN SMALL LETTER W WITH DIAERESIS
    charset += UIntSetRange(7815, 7815); // LATIN SMALL LETTER W WITH DOT ABOVE -> LATIN SMALL LETTER W WITH DOT ABOVE
    charset += UIntSetRange(7817, 7817); // LATIN SMALL LETTER W WITH DOT BELOW -> LATIN SMALL LETTER W WITH DOT BELOW
    charset += UIntSetRange(7819, 7819); // LATIN SMALL LETTER X WITH DOT ABOVE -> LATIN SMALL LETTER X WITH DOT ABOVE
    charset += UIntSetRange(7821, 7821); // LATIN SMALL LETTER X WITH DIAERESIS -> LATIN SMALL LETTER X WITH DIAERESIS
    charset += UIntSetRange(7823, 7823); // LATIN SMALL LETTER Y WITH DOT ABOVE -> LATIN SMALL LETTER Y WITH DOT ABOVE
    charset += UIntSetRange(7825, 7825); // LATIN SMALL LETTER Z WITH CIRCUMFLEX -> LATIN SMALL LETTER Z WITH CIRCUMFLEX
    charset += UIntSetRange(7827, 7827); // LATIN SMALL LETTER Z WITH DOT BELOW -> LATIN SMALL LETTER Z WITH DOT BELOW
    charset += UIntSetRange(7829, 7837); // LATIN SMALL LETTER Z WITH LINE BELOW -> LATIN SMALL LETTER LONG S WITH HIGH STROKE
    charset += UIntSetRange(7839, 7839); // LATIN SMALL LETTER DELTA -> LATIN SMALL LETTER DELTA
    charset += UIntSetRange(7841, 7841); // LATIN SMALL LETTER A WITH DOT BELOW -> LATIN SMALL LETTER A WITH DOT BELOW
    charset += UIntSetRange(7843, 7843); // LATIN SMALL LETTER A WITH HOOK ABOVE -> LATIN SMALL LETTER A WITH HOOK ABOVE
    charset += UIntSetRange(7845, 7845); // LATIN SMALL LETTER A WITH CIRCUMFLEX AND ACUTE -> LATIN SMALL LETTER A WITH CIRCUMFLEX AND ACUTE
    charset += UIntSetRange(7847, 7847); // LATIN SMALL LETTER A WITH CIRCUMFLEX AND GRAVE -> LATIN SMALL LETTER A WITH CIRCUMFLEX AND GRAVE
    charset += UIntSetRange(7849, 7849); // LATIN SMALL LETTER A WITH CIRCUMFLEX AND HOOK ABOVE -> LATIN SMALL LETTER A WITH CIRCUMFLEX AND HOOK ABOVE
    charset += UIntSetRange(7851, 7851); // LATIN SMALL LETTER A WITH CIRCUMFLEX AND TILDE -> LATIN SMALL LETTER A WITH CIRCUMFLEX AND TILDE
    charset += UIntSetRange(7853, 7853); // LATIN SMALL LETTER A WITH CIRCUMFLEX AND DOT BELOW -> LATIN SMALL LETTER A WITH CIRCUMFLEX AND DOT BELOW
    charset += UIntSetRange(7855, 7855); // LATIN SMALL LETTER A WITH BREVE AND ACUTE -> LATIN SMALL LETTER A WITH BREVE AND ACUTE
    charset += UIntSetRange(7857, 7857); // LATIN SMALL LETTER A WITH BREVE AND GRAVE -> LATIN SMALL LETTER A WITH BREVE AND GRAVE
    charset += UIntSetRange(7859, 7859); // LATIN SMALL LETTER A WITH BREVE AND HOOK ABOVE -> LATIN SMALL LETTER A WITH BREVE AND HOOK ABOVE
    charset += UIntSetRange(7861, 7861); // LATIN SMALL LETTER A WITH BREVE AND TILDE -> LATIN SMALL LETTER A WITH BREVE AND TILDE
    charset += UIntSetRange(7863, 7863); // LATIN SMALL LETTER A WITH BREVE AND DOT BELOW -> LATIN SMALL LETTER A WITH BREVE AND DOT BELOW
    charset += UIntSetRange(7865, 7865); // LATIN SMALL LETTER E WITH DOT BELOW -> LATIN SMALL LETTER E WITH DOT BELOW
    charset += UIntSetRange(7867, 7867); // LATIN SMALL LETTER E WITH HOOK ABOVE -> LATIN SMALL LETTER E WITH HOOK ABOVE
    charset += UIntSetRange(7869, 7869); // LATIN SMALL LETTER E WITH TILDE -> LATIN SMALL LETTER E WITH TILDE
    charset += UIntSetRange(7871, 7871); // LATIN SMALL LETTER E WITH CIRCUMFLEX AND ACUTE -> LATIN SMALL LETTER E WITH CIRCUMFLEX AND ACUTE
    charset += UIntSetRange(7873, 7873); // LATIN SMALL LETTER E WITH CIRCUMFLEX AND GRAVE -> LATIN SMALL LETTER E WITH CIRCUMFLEX AND GRAVE
    charset += UIntSetRange(7875, 7875); // LATIN SMALL LETTER E WITH CIRCUMFLEX AND HOOK ABOVE -> LATIN SMALL LETTER E WITH CIRCUMFLEX AND HOOK ABOVE
    charset += UIntSetRange(7877, 7877); // LATIN SMALL LETTER E WITH CIRCUMFLEX AND TILDE -> LATIN SMALL LETTER E WITH CIRCUMFLEX AND TILDE
    charset += UIntSetRange(7879, 7879); // LATIN SMALL LETTER E WITH CIRCUMFLEX AND DOT BELOW -> LATIN SMALL LETTER E WITH CIRCUMFLEX AND DOT BELOW
    charset += UIntSetRange(7881, 7881); // LATIN SMALL LETTER I WITH HOOK ABOVE -> LATIN SMALL LETTER I WITH HOOK ABOVE
    charset += UIntSetRange(7883, 7883); // LATIN SMALL LETTER I WITH DOT BELOW -> LATIN SMALL LETTER I WITH DOT BELOW
    charset += UIntSetRange(7885, 7885); // LATIN SMALL LETTER O WITH DOT BELOW -> LATIN SMALL LETTER O WITH DOT BELOW
    charset += UIntSetRange(7887, 7887); // LATIN SMALL LETTER O WITH HOOK ABOVE -> LATIN SMALL LETTER O WITH HOOK ABOVE
    charset += UIntSetRange(7889, 7889); // LATIN SMALL LETTER O WITH CIRCUMFLEX AND ACUTE -> LATIN SMALL LETTER O WITH CIRCUMFLEX AND ACUTE
    charset += UIntSetRange(7891, 7891); // LATIN SMALL LETTER O WITH CIRCUMFLEX AND GRAVE -> LATIN SMALL LETTER O WITH CIRCUMFLEX AND GRAVE
    charset += UIntSetRange(7893, 7893); // LATIN SMALL LETTER O WITH CIRCUMFLEX AND HOOK ABOVE -> LATIN SMALL LETTER O WITH CIRCUMFLEX AND HOOK ABOVE
    charset += UIntSetRange(7895, 7895); // LATIN SMALL LETTER O WITH CIRCUMFLEX AND TILDE -> LATIN SMALL LETTER O WITH CIRCUMFLEX AND TILDE
    charset += UIntSetRange(7897, 7897); // LATIN SMALL LETTER O WITH CIRCUMFLEX AND DOT BELOW -> LATIN SMALL LETTER O WITH CIRCUMFLEX AND DOT BELOW
    charset += UIntSetRange(7899, 7899); // LATIN SMALL LETTER O WITH HORN AND ACUTE -> LATIN SMALL LETTER O WITH HORN AND ACUTE
    charset += UIntSetRange(7901, 7901); // LATIN SMALL LETTER O WITH HORN AND GRAVE -> LATIN SMALL LETTER O WITH HORN AND GRAVE
    charset += UIntSetRange(7903, 7903); // LATIN SMALL LETTER O WITH HORN AND HOOK ABOVE -> LATIN SMALL LETTER O WITH HORN AND HOOK ABOVE
    charset += UIntSetRange(7905, 7905); // LATIN SMALL LETTER O WITH HORN AND TILDE -> LATIN SMALL LETTER O WITH HORN AND TILDE
    charset += UIntSetRange(7907, 7907); // LATIN SMALL LETTER O WITH HORN AND DOT BELOW -> LATIN SMALL LETTER O WITH HORN AND DOT BELOW
    charset += UIntSetRange(7909, 7909); // LATIN SMALL LETTER U WITH DOT BELOW -> LATIN SMALL LETTER U WITH DOT BELOW
    charset += UIntSetRange(7911, 7911); // LATIN SMALL LETTER U WITH HOOK ABOVE -> LATIN SMALL LETTER U WITH HOOK ABOVE
    charset += UIntSetRange(7913, 7913); // LATIN SMALL LETTER U WITH HORN AND ACUTE -> LATIN SMALL LETTER U WITH HORN AND ACUTE
    charset += UIntSetRange(7915, 7915); // LATIN SMALL LETTER U WITH HORN AND GRAVE -> LATIN SMALL LETTER U WITH HORN AND GRAVE
    charset += UIntSetRange(7917, 7917); // LATIN SMALL LETTER U WITH HORN AND HOOK ABOVE -> LATIN SMALL LETTER U WITH HORN AND HOOK ABOVE
    charset += UIntSetRange(7919, 7919); // LATIN SMALL LETTER U WITH HORN AND TILDE -> LATIN SMALL LETTER U WITH HORN AND TILDE
    charset += UIntSetRange(7921, 7921); // LATIN SMALL LETTER U WITH HORN AND DOT BELOW -> LATIN SMALL LETTER U WITH HORN AND DOT BELOW
    charset += UIntSetRange(7923, 7923); // LATIN SMALL LETTER Y WITH GRAVE -> LATIN SMALL LETTER Y WITH GRAVE
    charset += UIntSetRange(7925, 7925); // LATIN SMALL LETTER Y WITH DOT BELOW -> LATIN SMALL LETTER Y WITH DOT BELOW
    charset += UIntSetRange(7927, 7927); // LATIN SMALL LETTER Y WITH HOOK ABOVE -> LATIN SMALL LETTER Y WITH HOOK ABOVE
    charset += UIntSetRange(7929, 7929); // LATIN SMALL LETTER Y WITH TILDE -> LATIN SMALL LETTER Y WITH TILDE
    charset += UIntSetRange(7931, 7931); // LATIN SMALL LETTER MIDDLE-WELSH LL -> LATIN SMALL LETTER MIDDLE-WELSH LL
    charset += UIntSetRange(7933, 7933); // LATIN SMALL LETTER MIDDLE-WELSH V -> LATIN SMALL LETTER MIDDLE-WELSH V
    charset += UIntSetRange(7935, 7943); // LATIN SMALL LETTER Y WITH LOOP -> GREEK SMALL LETTER ALPHA WITH DASIA AND PERISPOMENI
    charset += UIntSetRange(7952, 7957); // GREEK SMALL LETTER EPSILON WITH PSILI -> GREEK SMALL LETTER EPSILON WITH DASIA AND OXIA
    charset += UIntSetRange(7968, 7975); // GREEK SMALL LETTER ETA WITH PSILI -> GREEK SMALL LETTER ETA WITH DASIA AND PERISPOMENI
    charset += UIntSetRange(7984, 7991); // GREEK SMALL LETTER IOTA WITH PSILI -> GREEK SMALL LETTER IOTA WITH DASIA AND PERISPOMENI
    charset += UIntSetRange(8000, 8005); // GREEK SMALL LETTER OMICRON WITH PSILI -> GREEK SMALL LETTER OMICRON WITH DASIA AND OXIA
    charset += UIntSetRange(8016, 8023); // GREEK SMALL LETTER UPSILON WITH PSILI -> GREEK SMALL LETTER UPSILON WITH DASIA AND PERISPOMENI
    charset += UIntSetRange(8032, 8039); // GREEK SMALL LETTER OMEGA WITH PSILI -> GREEK SMALL LETTER OMEGA WITH DASIA AND PERISPOMENI
    charset += UIntSetRange(8048, 8061); // GREEK SMALL LETTER ALPHA WITH VARIA -> GREEK SMALL LETTER OMEGA WITH OXIA
    charset += UIntSetRange(8064, 8071); // GREEK SMALL LETTER ALPHA WITH PSILI AND YPOGEGRAMMENI -> GREEK SMALL LETTER ALPHA WITH DASIA AND PERISPOMENI AND YPOGEGRAMMENI
    charset += UIntSetRange(8080, 8087); // GREEK SMALL LETTER ETA WITH PSILI AND YPOGEGRAMMENI -> GREEK SMALL LETTER ETA WITH DASIA AND PERISPOMENI AND YPOGEGRAMMENI
    charset += UIntSetRange(8096, 8103); // GREEK SMALL LETTER OMEGA WITH PSILI AND YPOGEGRAMMENI -> GREEK SMALL LETTER OMEGA WITH DASIA AND PERISPOMENI AND YPOGEGRAMMENI
    charset += UIntSetRange(8112, 8116); // GREEK SMALL LETTER ALPHA WITH VRACHY -> GREEK SMALL LETTER ALPHA WITH OXIA AND YPOGEGRAMMENI
    charset += UIntSetRange(8118, 8119); // GREEK SMALL LETTER ALPHA WITH PERISPOMENI -> GREEK SMALL LETTER ALPHA WITH PERISPOMENI AND YPOGEGRAMMENI
    charset += UIntSetRange(8126, 8126); // GREEK PROSGEGRAMMENI -> GREEK PROSGEGRAMMENI
    charset += UIntSetRange(8130, 8132); // GREEK SMALL LETTER ETA WITH VARIA AND YPOGEGRAMMENI -> GREEK SMALL LETTER ETA WITH OXIA AND YPOGEGRAMMENI
    charset += UIntSetRange(8134, 8135); // GREEK SMALL LETTER ETA WITH PERISPOMENI -> GREEK SMALL LETTER ETA WITH PERISPOMENI AND YPOGEGRAMMENI
    charset += UIntSetRange(8144, 8147); // GREEK SMALL LETTER IOTA WITH VRACHY -> GREEK SMALL LETTER IOTA WITH DIALYTIKA AND OXIA
    charset += UIntSetRange(8150, 8151); // GREEK SMALL LETTER IOTA WITH PERISPOMENI -> GREEK SMALL LETTER IOTA WITH DIALYTIKA AND PERISPOMENI
    charset += UIntSetRange(8160, 8167); // GREEK SMALL LETTER UPSILON WITH VRACHY -> GREEK SMALL LETTER UPSILON WITH DIALYTIKA AND PERISPOMENI
    charset += UIntSetRange(8178, 8180); // GREEK SMALL LETTER OMEGA WITH VARIA AND YPOGEGRAMMENI -> GREEK SMALL LETTER OMEGA WITH OXIA AND YPOGEGRAMMENI
    charset += UIntSetRange(8182, 8183); // GREEK SMALL LETTER OMEGA WITH PERISPOMENI -> GREEK SMALL LETTER OMEGA WITH PERISPOMENI AND YPOGEGRAMMENI
    charset += UIntSetRange(8305, 8305); // SUPERSCRIPT LATIN SMALL LETTER I -> SUPERSCRIPT LATIN SMALL LETTER I
    charset += UIntSetRange(8319, 8319); // SUPERSCRIPT LATIN SMALL LETTER N -> SUPERSCRIPT LATIN SMALL LETTER N
    charset += UIntSetRange(8458, 8458); // SCRIPT SMALL G -> SCRIPT SMALL G
    charset += UIntSetRange(8462, 8463); // PLANCK CONSTANT -> PLANCK CONSTANT OVER TWO PI
    charset += UIntSetRange(8467, 8467); // SCRIPT SMALL L -> SCRIPT SMALL L
    charset += UIntSetRange(8495, 8495); // SCRIPT SMALL E -> SCRIPT SMALL E
    charset += UIntSetRange(8500, 8500); // SCRIPT SMALL O -> SCRIPT SMALL O
    charset += UIntSetRange(8505, 8505); // INFORMATION SOURCE -> INFORMATION SOURCE
    charset += UIntSetRange(8508, 8509); // DOUBLE-STRUCK SMALL PI -> DOUBLE-STRUCK SMALL GAMMA
    charset += UIntSetRange(8518, 8521); // DOUBLE-STRUCK ITALIC SMALL D -> DOUBLE-STRUCK ITALIC SMALL J
    charset += UIntSetRange(8526, 8526); // TURNED SMALL F -> TURNED SMALL F
    charset += UIntSetRange(8580, 8580); // LATIN SMALL LETTER REVERSED C -> LATIN SMALL LETTER REVERSED C
    charset += UIntSetRange(11312, 11358); // GLAGOLITIC SMALL LETTER AZU -> GLAGOLITIC SMALL LETTER LATINATE MYSLITE
    charset += UIntSetRange(11361, 11361); // LATIN SMALL LETTER L WITH DOUBLE BAR -> LATIN SMALL LETTER L WITH DOUBLE BAR
    charset += UIntSetRange(11365, 11366); // LATIN SMALL LETTER A WITH STROKE -> LATIN SMALL LETTER T WITH DIAGONAL STROKE
    charset += UIntSetRange(11368, 11368); // LATIN SMALL LETTER H WITH DESCENDER -> LATIN SMALL LETTER H WITH DESCENDER
    charset += UIntSetRange(11370, 11370); // LATIN SMALL LETTER K WITH DESCENDER -> LATIN SMALL LETTER K WITH DESCENDER
    charset += UIntSetRange(11372, 11372); // LATIN SMALL LETTER Z WITH DESCENDER -> LATIN SMALL LETTER Z WITH DESCENDER
    charset += UIntSetRange(11377, 11377); // LATIN SMALL LETTER V WITH RIGHT HOOK -> LATIN SMALL LETTER V WITH RIGHT HOOK
    charset += UIntSetRange(11379, 11380); // LATIN SMALL LETTER W WITH HOOK -> LATIN SMALL LETTER V WITH CURL
    charset += UIntSetRange(11382, 11388); // LATIN SMALL LETTER HALF H -> LATIN SUBSCRIPT SMALL LETTER J
    charset += UIntSetRange(11393, 11393); // COPTIC SMALL LETTER ALFA -> COPTIC SMALL LETTER ALFA
    charset += UIntSetRange(11395, 11395); // COPTIC SMALL LETTER VIDA -> COPTIC SMALL LETTER VIDA
    charset += UIntSetRange(11397, 11397); // COPTIC SMALL LETTER GAMMA -> COPTIC SMALL LETTER GAMMA
    charset += UIntSetRange(11399, 11399); // COPTIC SMALL LETTER DALDA -> COPTIC SMALL LETTER DALDA
    charset += UIntSetRange(11401, 11401); // COPTIC SMALL LETTER EIE -> COPTIC SMALL LETTER EIE
    charset += UIntSetRange(11403, 11403); // COPTIC SMALL LETTER SOU -> COPTIC SMALL LETTER SOU
    charset += UIntSetRange(11405, 11405); // COPTIC SMALL LETTER ZATA -> COPTIC SMALL LETTER ZATA
    charset += UIntSetRange(11407, 11407); // COPTIC SMALL LETTER HATE -> COPTIC SMALL LETTER HATE
    charset += UIntSetRange(11409, 11409); // COPTIC SMALL LETTER THETHE -> COPTIC SMALL LETTER THETHE
    charset += UIntSetRange(11411, 11411); // COPTIC SMALL LETTER IAUDA -> COPTIC SMALL LETTER IAUDA
    charset += UIntSetRange(11413, 11413); // COPTIC SMALL LETTER KAPA -> COPTIC SMALL LETTER KAPA
    charset += UIntSetRange(11415, 11415); // COPTIC SMALL LETTER LAULA -> COPTIC SMALL LETTER LAULA
    charset += UIntSetRange(11417, 11417); // COPTIC SMALL LETTER MI -> COPTIC SMALL LETTER MI
    charset += UIntSetRange(11419, 11419); // COPTIC SMALL LETTER NI -> COPTIC SMALL LETTER NI
    charset += UIntSetRange(11421, 11421); // COPTIC SMALL LETTER KSI -> COPTIC SMALL LETTER KSI
    charset += UIntSetRange(11423, 11423); // COPTIC SMALL LETTER O -> COPTIC SMALL LETTER O
    charset += UIntSetRange(11425, 11425); // COPTIC SMALL LETTER PI -> COPTIC SMALL LETTER PI
    charset += UIntSetRange(11427, 11427); // COPTIC SMALL LETTER RO -> COPTIC SMALL LETTER RO
    charset += UIntSetRange(11429, 11429); // COPTIC SMALL LETTER SIMA -> COPTIC SMALL LETTER SIMA
    charset += UIntSetRange(11431, 11431); // COPTIC SMALL LETTER TAU -> COPTIC SMALL LETTER TAU
    charset += UIntSetRange(11433, 11433); // COPTIC SMALL LETTER UA -> COPTIC SMALL LETTER UA
    charset += UIntSetRange(11435, 11435); // COPTIC SMALL LETTER FI -> COPTIC SMALL LETTER FI
    charset += UIntSetRange(11437, 11437); // COPTIC SMALL LETTER KHI -> COPTIC SMALL LETTER KHI
    charset += UIntSetRange(11439, 11439); // COPTIC SMALL LETTER PSI -> COPTIC SMALL LETTER PSI
    charset += UIntSetRange(11441, 11441); // COPTIC SMALL LETTER OOU -> COPTIC SMALL LETTER OOU
    charset += UIntSetRange(11443, 11443); // COPTIC SMALL LETTER DIALECT-P ALEF -> COPTIC SMALL LETTER DIALECT-P ALEF
    charset += UIntSetRange(11445, 11445); // COPTIC SMALL LETTER OLD COPTIC AIN -> COPTIC SMALL LETTER OLD COPTIC AIN
    charset += UIntSetRange(11447, 11447); // COPTIC SMALL LETTER CRYPTOGRAMMIC EIE -> COPTIC SMALL LETTER CRYPTOGRAMMIC EIE
    charset += UIntSetRange(11449, 11449); // COPTIC SMALL LETTER DIALECT-P KAPA -> COPTIC SMALL LETTER DIALECT-P KAPA
    charset += UIntSetRange(11451, 11451); // COPTIC SMALL LETTER DIALECT-P NI -> COPTIC SMALL LETTER DIALECT-P NI
    charset += UIntSetRange(11453, 11453); // COPTIC SMALL LETTER CRYPTOGRAMMIC NI -> COPTIC SMALL LETTER CRYPTOGRAMMIC NI
    charset += UIntSetRange(11455, 11455); // COPTIC SMALL LETTER OLD COPTIC OOU -> COPTIC SMALL LETTER OLD COPTIC OOU
    charset += UIntSetRange(11457, 11457); // COPTIC SMALL LETTER SAMPI -> COPTIC SMALL LETTER SAMPI
    charset += UIntSetRange(11459, 11459); // COPTIC SMALL LETTER CROSSED SHEI -> COPTIC SMALL LETTER CROSSED SHEI
    charset += UIntSetRange(11461, 11461); // COPTIC SMALL LETTER OLD COPTIC SHEI -> COPTIC SMALL LETTER OLD COPTIC SHEI
    charset += UIntSetRange(11463, 11463); // COPTIC SMALL LETTER OLD COPTIC ESH -> COPTIC SMALL LETTER OLD COPTIC ESH
    charset += UIntSetRange(11465, 11465); // COPTIC SMALL LETTER AKHMIMIC KHEI -> COPTIC SMALL LETTER AKHMIMIC KHEI
    charset += UIntSetRange(11467, 11467); // COPTIC SMALL LETTER DIALECT-P HORI -> COPTIC SMALL LETTER DIALECT-P HORI
    charset += UIntSetRange(11469, 11469); // COPTIC SMALL LETTER OLD COPTIC HORI -> COPTIC SMALL LETTER OLD COPTIC HORI
    charset += UIntSetRange(11471, 11471); // COPTIC SMALL LETTER OLD COPTIC HA -> COPTIC SMALL LETTER OLD COPTIC HA
    charset += UIntSetRange(11473, 11473); // COPTIC SMALL LETTER L-SHAPED HA -> COPTIC SMALL LETTER L-SHAPED HA
    charset += UIntSetRange(11475, 11475); // COPTIC SMALL LETTER OLD COPTIC HEI -> COPTIC SMALL LETTER OLD COPTIC HEI
    charset += UIntSetRange(11477, 11477); // COPTIC SMALL LETTER OLD COPTIC HAT -> COPTIC SMALL LETTER OLD COPTIC HAT
    charset += UIntSetRange(11479, 11479); // COPTIC SMALL LETTER OLD COPTIC GANGIA -> COPTIC SMALL LETTER OLD COPTIC GANGIA
    charset += UIntSetRange(11481, 11481); // COPTIC SMALL LETTER OLD COPTIC DJA -> COPTIC SMALL LETTER OLD COPTIC DJA
    charset += UIntSetRange(11483, 11483); // COPTIC SMALL LETTER OLD COPTIC SHIMA -> COPTIC SMALL LETTER OLD COPTIC SHIMA
    charset += UIntSetRange(11485, 11485); // COPTIC SMALL LETTER OLD NUBIAN SHIMA -> COPTIC SMALL LETTER OLD NUBIAN SHIMA
    charset += UIntSetRange(11487, 11487); // COPTIC SMALL LETTER OLD NUBIAN NGI -> COPTIC SMALL LETTER OLD NUBIAN NGI
    charset += UIntSetRange(11489, 11489); // COPTIC SMALL LETTER OLD NUBIAN NYI -> COPTIC SMALL LETTER OLD NUBIAN NYI
    charset += UIntSetRange(11491, 11492); // COPTIC SMALL LETTER OLD NUBIAN WAU -> COPTIC SYMBOL KAI
    charset += UIntSetRange(11520, 11557); // GEORGIAN SMALL LETTER AN -> GEORGIAN SMALL LETTER HOE
    charset += UIntSetRange(42561, 42561); // CYRILLIC SMALL LETTER ZEMLYA -> CYRILLIC SMALL LETTER ZEMLYA
    charset += UIntSetRange(42563, 42563); // CYRILLIC SMALL LETTER DZELO -> CYRILLIC SMALL LETTER DZELO
    charset += UIntSetRange(42565, 42565); // CYRILLIC SMALL LETTER REVERSED DZE -> CYRILLIC SMALL LETTER REVERSED DZE
    charset += UIntSetRange(42567, 42567); // CYRILLIC SMALL LETTER IOTA -> CYRILLIC SMALL LETTER IOTA
    charset += UIntSetRange(42569, 42569); // CYRILLIC SMALL LETTER DJERV -> CYRILLIC SMALL LETTER DJERV
    charset += UIntSetRange(42571, 42571); // CYRILLIC SMALL LETTER MONOGRAPH UK -> CYRILLIC SMALL LETTER MONOGRAPH UK
    charset += UIntSetRange(42573, 42573); // CYRILLIC SMALL LETTER BROAD OMEGA -> CYRILLIC SMALL LETTER BROAD OMEGA
    charset += UIntSetRange(42575, 42575); // CYRILLIC SMALL LETTER NEUTRAL YER -> CYRILLIC SMALL LETTER NEUTRAL YER
    charset += UIntSetRange(42577, 42577); // CYRILLIC SMALL LETTER YERU WITH BACK YER -> CYRILLIC SMALL LETTER YERU WITH BACK YER
    charset += UIntSetRange(42579, 42579); // CYRILLIC SMALL LETTER IOTIFIED YAT -> CYRILLIC SMALL LETTER IOTIFIED YAT
    charset += UIntSetRange(42581, 42581); // CYRILLIC SMALL LETTER REVERSED YU -> CYRILLIC SMALL LETTER REVERSED YU
    charset += UIntSetRange(42583, 42583); // CYRILLIC SMALL LETTER IOTIFIED A -> CYRILLIC SMALL LETTER IOTIFIED A
    charset += UIntSetRange(42585, 42585); // CYRILLIC SMALL LETTER CLOSED LITTLE YUS -> CYRILLIC SMALL LETTER CLOSED LITTLE YUS
    charset += UIntSetRange(42587, 42587); // CYRILLIC SMALL LETTER BLENDED YUS -> CYRILLIC SMALL LETTER BLENDED YUS
    charset += UIntSetRange(42589, 42589); // CYRILLIC SMALL LETTER IOTIFIED CLOSED LITTLE YUS -> CYRILLIC SMALL LETTER IOTIFIED CLOSED LITTLE YUS
    charset += UIntSetRange(42591, 42591); // CYRILLIC SMALL LETTER YN -> CYRILLIC SMALL LETTER YN
    charset += UIntSetRange(42595, 42595); // CYRILLIC SMALL LETTER SOFT DE -> CYRILLIC SMALL LETTER SOFT DE
    charset += UIntSetRange(42597, 42597); // CYRILLIC SMALL LETTER SOFT EL -> CYRILLIC SMALL LETTER SOFT EL
    charset += UIntSetRange(42599, 42599); // CYRILLIC SMALL LETTER SOFT EM -> CYRILLIC SMALL LETTER SOFT EM
    charset += UIntSetRange(42601, 42601); // CYRILLIC SMALL LETTER MONOCULAR O -> CYRILLIC SMALL LETTER MONOCULAR O
    charset += UIntSetRange(42603, 42603); // CYRILLIC SMALL LETTER BINOCULAR O -> CYRILLIC SMALL LETTER BINOCULAR O
    charset += UIntSetRange(42605, 42605); // CYRILLIC SMALL LETTER DOUBLE MONOCULAR O -> CYRILLIC SMALL LETTER DOUBLE MONOCULAR O
    charset += UIntSetRange(42625, 42625); // CYRILLIC SMALL LETTER DWE -> CYRILLIC SMALL LETTER DWE
    charset += UIntSetRange(42627, 42627); // CYRILLIC SMALL LETTER DZWE -> CYRILLIC SMALL LETTER DZWE
    charset += UIntSetRange(42629, 42629); // CYRILLIC SMALL LETTER ZHWE -> CYRILLIC SMALL LETTER ZHWE
    charset += UIntSetRange(42631, 42631); // CYRILLIC SMALL LETTER CCHE -> CYRILLIC SMALL LETTER CCHE
    charset += UIntSetRange(42633, 42633); // CYRILLIC SMALL LETTER DZZE -> CYRILLIC SMALL LETTER DZZE
    charset += UIntSetRange(42635, 42635); // CYRILLIC SMALL LETTER TE WITH MIDDLE HOOK -> CYRILLIC SMALL LETTER TE WITH MIDDLE HOOK
    charset += UIntSetRange(42637, 42637); // CYRILLIC SMALL LETTER TWE -> CYRILLIC SMALL LETTER TWE
    charset += UIntSetRange(42639, 42639); // CYRILLIC SMALL LETTER TSWE -> CYRILLIC SMALL LETTER TSWE
    charset += UIntSetRange(42641, 42641); // CYRILLIC SMALL LETTER TSSE -> CYRILLIC SMALL LETTER TSSE
    charset += UIntSetRange(42643, 42643); // CYRILLIC SMALL LETTER TCHE -> CYRILLIC SMALL LETTER TCHE
    charset += UIntSetRange(42645, 42645); // CYRILLIC SMALL LETTER HWE -> CYRILLIC SMALL LETTER HWE
    charset += UIntSetRange(42647, 42647); // CYRILLIC SMALL LETTER SHWE -> CYRILLIC SMALL LETTER SHWE
    charset += UIntSetRange(42787, 42787); // LATIN SMALL LETTER EGYPTOLOGICAL ALEF -> LATIN SMALL LETTER EGYPTOLOGICAL ALEF
    charset += UIntSetRange(42789, 42789); // LATIN SMALL LETTER EGYPTOLOGICAL AIN -> LATIN SMALL LETTER EGYPTOLOGICAL AIN
    charset += UIntSetRange(42791, 42791); // LATIN SMALL LETTER HENG -> LATIN SMALL LETTER HENG
    charset += UIntSetRange(42793, 42793); // LATIN SMALL LETTER TZ -> LATIN SMALL LETTER TZ
    charset += UIntSetRange(42795, 42795); // LATIN SMALL LETTER TRESILLO -> LATIN SMALL LETTER TRESILLO
    charset += UIntSetRange(42797, 42797); // LATIN SMALL LETTER CUATRILLO -> LATIN SMALL LETTER CUATRILLO
    charset += UIntSetRange(42799, 42801); // LATIN SMALL LETTER CUATRILLO WITH COMMA -> LATIN LETTER SMALL CAPITAL S
    charset += UIntSetRange(42803, 42803); // LATIN SMALL LETTER AA -> LATIN SMALL LETTER AA
    charset += UIntSetRange(42805, 42805); // LATIN SMALL LETTER AO -> LATIN SMALL LETTER AO
    charset += UIntSetRange(42807, 42807); // LATIN SMALL LETTER AU -> LATIN SMALL LETTER AU
    charset += UIntSetRange(42809, 42809); // LATIN SMALL LETTER AV -> LATIN SMALL LETTER AV
    charset += UIntSetRange(42811, 42811); // LATIN SMALL LETTER AV WITH HORIZONTAL BAR -> LATIN SMALL LETTER AV WITH HORIZONTAL BAR
    charset += UIntSetRange(42813, 42813); // LATIN SMALL LETTER AY -> LATIN SMALL LETTER AY
    charset += UIntSetRange(42815, 42815); // LATIN SMALL LETTER REVERSED C WITH DOT -> LATIN SMALL LETTER REVERSED C WITH DOT
    charset += UIntSetRange(42817, 42817); // LATIN SMALL LETTER K WITH STROKE -> LATIN SMALL LETTER K WITH STROKE
    charset += UIntSetRange(42819, 42819); // LATIN SMALL LETTER K WITH DIAGONAL STROKE -> LATIN SMALL LETTER K WITH DIAGONAL STROKE
    charset += UIntSetRange(42821, 42821); // LATIN SMALL LETTER K WITH STROKE AND DIAGONAL STROKE -> LATIN SMALL LETTER K WITH STROKE AND DIAGONAL STROKE
    charset += UIntSetRange(42823, 42823); // LATIN SMALL LETTER BROKEN L -> LATIN SMALL LETTER BROKEN L
    charset += UIntSetRange(42825, 42825); // LATIN SMALL LETTER L WITH HIGH STROKE -> LATIN SMALL LETTER L WITH HIGH STROKE
    charset += UIntSetRange(42827, 42827); // LATIN SMALL LETTER O WITH LONG STROKE OVERLAY -> LATIN SMALL LETTER O WITH LONG STROKE OVERLAY
    charset += UIntSetRange(42829, 42829); // LATIN SMALL LETTER O WITH LOOP -> LATIN SMALL LETTER O WITH LOOP
    charset += UIntSetRange(42831, 42831); // LATIN SMALL LETTER OO -> LATIN SMALL LETTER OO
    charset += UIntSetRange(42833, 42833); // LATIN SMALL LETTER P WITH STROKE THROUGH DESCENDER -> LATIN SMALL LETTER P WITH STROKE THROUGH DESCENDER
    charset += UIntSetRange(42835, 42835); // LATIN SMALL LETTER P WITH FLOURISH -> LATIN SMALL LETTER P WITH FLOURISH
    charset += UIntSetRange(42837, 42837); // LATIN SMALL LETTER P WITH SQUIRREL TAIL -> LATIN SMALL LETTER P WITH SQUIRREL TAIL
    charset += UIntSetRange(42839, 42839); // LATIN SMALL LETTER Q WITH STROKE THROUGH DESCENDER -> LATIN SMALL LETTER Q WITH STROKE THROUGH DESCENDER
    charset += UIntSetRange(42841, 42841); // LATIN SMALL LETTER Q WITH DIAGONAL STROKE -> LATIN SMALL LETTER Q WITH DIAGONAL STROKE
    charset += UIntSetRange(42843, 42843); // LATIN SMALL LETTER R ROTUNDA -> LATIN SMALL LETTER R ROTUNDA
    charset += UIntSetRange(42845, 42845); // LATIN SMALL LETTER RUM ROTUNDA -> LATIN SMALL LETTER RUM ROTUNDA
    charset += UIntSetRange(42847, 42847); // LATIN SMALL LETTER V WITH DIAGONAL STROKE -> LATIN SMALL LETTER V WITH DIAGONAL STROKE
    charset += UIntSetRange(42849, 42849); // LATIN SMALL LETTER VY -> LATIN SMALL LETTER VY
    charset += UIntSetRange(42851, 42851); // LATIN SMALL LETTER VISIGOTHIC Z -> LATIN SMALL LETTER VISIGOTHIC Z
    charset += UIntSetRange(42853, 42853); // LATIN SMALL LETTER THORN WITH STROKE -> LATIN SMALL LETTER THORN WITH STROKE
    charset += UIntSetRange(42855, 42855); // LATIN SMALL LETTER THORN WITH STROKE THROUGH DESCENDER -> LATIN SMALL LETTER THORN WITH STROKE THROUGH DESCENDER
    charset += UIntSetRange(42857, 42857); // LATIN SMALL LETTER VEND -> LATIN SMALL LETTER VEND
    charset += UIntSetRange(42859, 42859); // LATIN SMALL LETTER ET -> LATIN SMALL LETTER ET
    charset += UIntSetRange(42861, 42861); // LATIN SMALL LETTER IS -> LATIN SMALL LETTER IS
    charset += UIntSetRange(42863, 42863); // LATIN SMALL LETTER CON -> LATIN SMALL LETTER CON
    charset += UIntSetRange(42865, 42872); // LATIN SMALL LETTER DUM -> LATIN SMALL LETTER UM
    charset += UIntSetRange(42874, 42874); // LATIN SMALL LETTER INSULAR D -> LATIN SMALL LETTER INSULAR D
    charset += UIntSetRange(42876, 42876); // LATIN SMALL LETTER INSULAR F -> LATIN SMALL LETTER INSULAR F
    charset += UIntSetRange(42879, 42879); // LATIN SMALL LETTER TURNED INSULAR G -> LATIN SMALL LETTER TURNED INSULAR G
    charset += UIntSetRange(42881, 42881); // LATIN SMALL LETTER TURNED L -> LATIN SMALL LETTER TURNED L
    charset += UIntSetRange(42883, 42883); // LATIN SMALL LETTER INSULAR R -> LATIN SMALL LETTER INSULAR R
    charset += UIntSetRange(42885, 42885); // LATIN SMALL LETTER INSULAR S -> LATIN SMALL LETTER INSULAR S
    charset += UIntSetRange(42887, 42887); // LATIN SMALL LETTER INSULAR T -> LATIN SMALL LETTER INSULAR T
    charset += UIntSetRange(42892, 42892); // LATIN SMALL LETTER SALTILLO -> LATIN SMALL LETTER SALTILLO
    charset += UIntSetRange(64256, 64262); // LATIN SMALL LIGATURE FF -> LATIN SMALL LIGATURE ST
    charset += UIntSetRange(64275, 64279); // ARMENIAN SMALL LIGATURE MEN NOW -> ARMENIAN SMALL LIGATURE MEN XEH
    charset += UIntSetRange(65345, 65370); // FULLWIDTH LATIN SMALL LETTER A -> FULLWIDTH LATIN SMALL LETTER Z
    charset += UIntSetRange(66600, 66639); // DESERET SMALL LETTER LONG I -> DESERET SMALL LETTER EW
    charset += UIntSetRange(119834, 119859); // MATHEMATICAL BOLD SMALL A -> MATHEMATICAL BOLD SMALL Z
    charset += UIntSetRange(119886, 119892); // MATHEMATICAL ITALIC SMALL A -> MATHEMATICAL ITALIC SMALL G
    charset += UIntSetRange(119894, 119911); // MATHEMATICAL ITALIC SMALL I -> MATHEMATICAL ITALIC SMALL Z
    charset += UIntSetRange(119938, 119963); // MATHEMATICAL BOLD ITALIC SMALL A -> MATHEMATICAL BOLD ITALIC SMALL Z
    charset += UIntSetRange(119990, 119993); // MATHEMATICAL SCRIPT SMALL A -> MATHEMATICAL SCRIPT SMALL D
    charset += UIntSetRange(119995, 119995); // MATHEMATICAL SCRIPT SMALL F -> MATHEMATICAL SCRIPT SMALL F
    charset += UIntSetRange(119997, 120003); // MATHEMATICAL SCRIPT SMALL H -> MATHEMATICAL SCRIPT SMALL N
    charset += UIntSetRange(120005, 120015); // MATHEMATICAL SCRIPT SMALL P -> MATHEMATICAL SCRIPT SMALL Z
    charset += UIntSetRange(120042, 120067); // MATHEMATICAL BOLD SCRIPT SMALL A -> MATHEMATICAL BOLD SCRIPT SMALL Z
    charset += UIntSetRange(120094, 120119); // MATHEMATICAL FRAKTUR SMALL A -> MATHEMATICAL FRAKTUR SMALL Z
    charset += UIntSetRange(120146, 120171); // MATHEMATICAL DOUBLE-STRUCK SMALL A -> MATHEMATICAL DOUBLE-STRUCK SMALL Z
    charset += UIntSetRange(120198, 120223); // MATHEMATICAL BOLD FRAKTUR SMALL A -> MATHEMATICAL BOLD FRAKTUR SMALL Z
    charset += UIntSetRange(120250, 120275); // MATHEMATICAL SANS-SERIF SMALL A -> MATHEMATICAL SANS-SERIF SMALL Z
    charset += UIntSetRange(120302, 120327); // MATHEMATICAL SANS-SERIF BOLD SMALL A -> MATHEMATICAL SANS-SERIF BOLD SMALL Z
    charset += UIntSetRange(120354, 120379); // MATHEMATICAL SANS-SERIF ITALIC SMALL A -> MATHEMATICAL SANS-SERIF ITALIC SMALL Z
    charset += UIntSetRange(120406, 120431); // MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL A -> MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL Z
    charset += UIntSetRange(120458, 120485); // MATHEMATICAL MONOSPACE SMALL A -> MATHEMATICAL ITALIC SMALL DOTLESS J
    charset += UIntSetRange(120514, 120538); // MATHEMATICAL BOLD SMALL ALPHA -> MATHEMATICAL BOLD SMALL OMEGA
    charset += UIntSetRange(120540, 120545); // MATHEMATICAL BOLD EPSILON SYMBOL -> MATHEMATICAL BOLD PI SYMBOL
    charset += UIntSetRange(120572, 120596); // MATHEMATICAL ITALIC SMALL ALPHA -> MATHEMATICAL ITALIC SMALL OMEGA
    charset += UIntSetRange(120598, 120603); // MATHEMATICAL ITALIC EPSILON SYMBOL -> MATHEMATICAL ITALIC PI SYMBOL
    charset += UIntSetRange(120630, 120654); // MATHEMATICAL BOLD ITALIC SMALL ALPHA -> MATHEMATICAL BOLD ITALIC SMALL OMEGA
    charset += UIntSetRange(120656, 120661); // MATHEMATICAL BOLD ITALIC EPSILON SYMBOL -> MATHEMATICAL BOLD ITALIC PI SYMBOL
    charset += UIntSetRange(120688, 120712); // MATHEMATICAL SANS-SERIF BOLD SMALL ALPHA -> MATHEMATICAL SANS-SERIF BOLD SMALL OMEGA
    charset += UIntSetRange(120714, 120719); // MATHEMATICAL SANS-SERIF BOLD EPSILON SYMBOL -> MATHEMATICAL SANS-SERIF BOLD PI SYMBOL
    charset += UIntSetRange(120746, 120770); // MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL ALPHA -> MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL OMEGA
    charset += UIntSetRange(120772, 120777); // MATHEMATICAL SANS-SERIF BOLD ITALIC EPSILON SYMBOL -> MATHEMATICAL SANS-SERIF BOLD ITALIC PI SYMBOL
    charset += UIntSetRange(120779, 120779); // MATHEMATICAL BOLD SMALL DIGAMMA -> MATHEMATICAL BOLD SMALL DIGAMMA
    return charset;
}


const UIntSet &named_charset_upper()
{
    static UIntSet charset;
    if( charset.count() )
        return charset;
    charset += UIntSetRange(65, 90); // LATIN CAPITAL LETTER A -> LATIN CAPITAL LETTER Z
    charset += UIntSetRange(192, 214); // LATIN CAPITAL LETTER A WITH GRAVE -> LATIN CAPITAL LETTER O WITH DIAERESIS
    charset += UIntSetRange(216, 222); // LATIN CAPITAL LETTER O WITH STROKE -> LATIN CAPITAL LETTER THORN
    charset += UIntSetRange(256, 256); // LATIN CAPITAL LETTER A WITH MACRON -> LATIN CAPITAL LETTER A WITH MACRON
    charset += UIntSetRange(258, 258); // LATIN CAPITAL LETTER A WITH BREVE -> LATIN CAPITAL LETTER A WITH BREVE
    charset += UIntSetRange(260, 260); // LATIN CAPITAL LETTER A WITH OGONEK -> LATIN CAPITAL LETTER A WITH OGONEK
    charset += UIntSetRange(262, 262); // LATIN CAPITAL LETTER C WITH ACUTE -> LATIN CAPITAL LETTER C WITH ACUTE
    charset += UIntSetRange(264, 264); // LATIN CAPITAL LETTER C WITH CIRCUMFLEX -> LATIN CAPITAL LETTER C WITH CIRCUMFLEX
    charset += UIntSetRange(266, 266); // LATIN CAPITAL LETTER C WITH DOT ABOVE -> LATIN CAPITAL LETTER C WITH DOT ABOVE
    charset += UIntSetRange(268, 268); // LATIN CAPITAL LETTER C WITH CARON -> LATIN CAPITAL LETTER C WITH CARON
    charset += UIntSetRange(270, 270); // LATIN CAPITAL LETTER D WITH CARON -> LATIN CAPITAL LETTER D WITH CARON
    charset += UIntSetRange(272, 272); // LATIN CAPITAL LETTER D WITH STROKE -> LATIN CAPITAL LETTER D WITH STROKE
    charset += UIntSetRange(274, 274); // LATIN CAPITAL LETTER E WITH MACRON -> LATIN CAPITAL LETTER E WITH MACRON
    charset += UIntSetRange(276, 276); // LATIN CAPITAL LETTER E WITH BREVE -> LATIN CAPITAL LETTER E WITH BREVE
    charset += UIntSetRange(278, 278); // LATIN CAPITAL LETTER E WITH DOT ABOVE -> LATIN CAPITAL LETTER E WITH DOT ABOVE
    charset += UIntSetRange(280, 280); // LATIN CAPITAL LETTER E WITH OGONEK -> LATIN CAPITAL LETTER E WITH OGONEK
    charset += UIntSetRange(282, 282); // LATIN CAPITAL LETTER E WITH CARON -> LATIN CAPITAL LETTER E WITH CARON
    charset += UIntSetRange(284, 284); // LATIN CAPITAL LETTER G WITH CIRCUMFLEX -> LATIN CAPITAL LETTER G WITH CIRCUMFLEX
    charset += UIntSetRange(286, 286); // LATIN CAPITAL LETTER G WITH BREVE -> LATIN CAPITAL LETTER G WITH BREVE
    charset += UIntSetRange(288, 288); // LATIN CAPITAL LETTER G WITH DOT ABOVE -> LATIN CAPITAL LETTER G WITH DOT ABOVE
    charset += UIntSetRange(290, 290); // LATIN CAPITAL LETTER G WITH CEDILLA -> LATIN CAPITAL LETTER G WITH CEDILLA
    charset += UIntSetRange(292, 292); // LATIN CAPITAL LETTER H WITH CIRCUMFLEX -> LATIN CAPITAL LETTER H WITH CIRCUMFLEX
    charset += UIntSetRange(294, 294); // LATIN CAPITAL LETTER H WITH STROKE -> LATIN CAPITAL LETTER H WITH STROKE
    charset += UIntSetRange(296, 296); // LATIN CAPITAL LETTER I WITH TILDE -> LATIN CAPITAL LETTER I WITH TILDE
    charset += UIntSetRange(298, 298); // LATIN CAPITAL LETTER I WITH MACRON -> LATIN CAPITAL LETTER I WITH MACRON
    charset += UIntSetRange(300, 300); // LATIN CAPITAL LETTER I WITH BREVE -> LATIN CAPITAL LETTER I WITH BREVE
    charset += UIntSetRange(302, 302); // LATIN CAPITAL LETTER I WITH OGONEK -> LATIN CAPITAL LETTER I WITH OGONEK
    charset += UIntSetRange(304, 304); // LATIN CAPITAL LETTER I WITH DOT ABOVE -> LATIN CAPITAL LETTER I WITH DOT ABOVE
    charset += UIntSetRange(306, 306); // LATIN CAPITAL LIGATURE IJ -> LATIN CAPITAL LIGATURE IJ
    charset += UIntSetRange(308, 308); // LATIN CAPITAL LETTER J WITH CIRCUMFLEX -> LATIN CAPITAL LETTER J WITH CIRCUMFLEX
    charset += UIntSetRange(310, 310); // LATIN CAPITAL LETTER K WITH CEDILLA -> LATIN CAPITAL LETTER K WITH CEDILLA
    charset += UIntSetRange(313, 313); // LATIN CAPITAL LETTER L WITH ACUTE -> LATIN CAPITAL LETTER L WITH ACUTE
    charset += UIntSetRange(315, 315); // LATIN CAPITAL LETTER L WITH CEDILLA -> LATIN CAPITAL LETTER L WITH CEDILLA
    charset += UIntSetRange(317, 317); // LATIN CAPITAL LETTER L WITH CARON -> LATIN CAPITAL LETTER L WITH CARON
    charset += UIntSetRange(319, 319); // LATIN CAPITAL LETTER L WITH MIDDLE DOT -> LATIN CAPITAL LETTER L WITH MIDDLE DOT
    charset += UIntSetRange(321, 321); // LATIN CAPITAL LETTER L WITH STROKE -> LATIN CAPITAL LETTER L WITH STROKE
    charset += UIntSetRange(323, 323); // LATIN CAPITAL LETTER N WITH ACUTE -> LATIN CAPITAL LETTER N WITH ACUTE
    charset += UIntSetRange(325, 325); // LATIN CAPITAL LETTER N WITH CEDILLA -> LATIN CAPITAL LETTER N WITH CEDILLA
    charset += UIntSetRange(327, 327); // LATIN CAPITAL LETTER N WITH CARON -> LATIN CAPITAL LETTER N WITH CARON
    charset += UIntSetRange(330, 330); // LATIN CAPITAL LETTER ENG -> LATIN CAPITAL LETTER ENG
    charset += UIntSetRange(332, 332); // LATIN CAPITAL LETTER O WITH MACRON -> LATIN CAPITAL LETTER O WITH MACRON
    charset += UIntSetRange(334, 334); // LATIN CAPITAL LETTER O WITH BREVE -> LATIN CAPITAL LETTER O WITH BREVE
    charset += UIntSetRange(336, 336); // LATIN CAPITAL LETTER O WITH DOUBLE ACUTE -> LATIN CAPITAL LETTER O WITH DOUBLE ACUTE
    charset += UIntSetRange(338, 338); // LATIN CAPITAL LIGATURE OE -> LATIN CAPITAL LIGATURE OE
    charset += UIntSetRange(340, 340); // LATIN CAPITAL LETTER R WITH ACUTE -> LATIN CAPITAL LETTER R WITH ACUTE
    charset += UIntSetRange(342, 342); // LATIN CAPITAL LETTER R WITH CEDILLA -> LATIN CAPITAL LETTER R WITH CEDILLA
    charset += UIntSetRange(344, 344); // LATIN CAPITAL LETTER R WITH CARON -> LATIN CAPITAL LETTER R WITH CARON
    charset += UIntSetRange(346, 346); // LATIN CAPITAL LETTER S WITH ACUTE -> LATIN CAPITAL LETTER S WITH ACUTE
    charset += UIntSetRange(348, 348); // LATIN CAPITAL LETTER S WITH CIRCUMFLEX -> LATIN CAPITAL LETTER S WITH CIRCUMFLEX
    charset += UIntSetRange(350, 350); // LATIN CAPITAL LETTER S WITH CEDILLA -> LATIN CAPITAL LETTER S WITH CEDILLA
    charset += UIntSetRange(352, 352); // LATIN CAPITAL LETTER S WITH CARON -> LATIN CAPITAL LETTER S WITH CARON
    charset += UIntSetRange(354, 354); // LATIN CAPITAL LETTER T WITH CEDILLA -> LATIN CAPITAL LETTER T WITH CEDILLA
    charset += UIntSetRange(356, 356); // LATIN CAPITAL LETTER T WITH CARON -> LATIN CAPITAL LETTER T WITH CARON
    charset += UIntSetRange(358, 358); // LATIN CAPITAL LETTER T WITH STROKE -> LATIN CAPITAL LETTER T WITH STROKE
    charset += UIntSetRange(360, 360); // LATIN CAPITAL LETTER U WITH TILDE -> LATIN CAPITAL LETTER U WITH TILDE
    charset += UIntSetRange(362, 362); // LATIN CAPITAL LETTER U WITH MACRON -> LATIN CAPITAL LETTER U WITH MACRON
    charset += UIntSetRange(364, 364); // LATIN CAPITAL LETTER U WITH BREVE -> LATIN CAPITAL LETTER U WITH BREVE
    charset += UIntSetRange(366, 366); // LATIN CAPITAL LETTER U WITH RING ABOVE -> LATIN CAPITAL LETTER U WITH RING ABOVE
    charset += UIntSetRange(368, 368); // LATIN CAPITAL LETTER U WITH DOUBLE ACUTE -> LATIN CAPITAL LETTER U WITH DOUBLE ACUTE
    charset += UIntSetRange(370, 370); // LATIN CAPITAL LETTER U WITH OGONEK -> LATIN CAPITAL LETTER U WITH OGONEK
    charset += UIntSetRange(372, 372); // LATIN CAPITAL LETTER W WITH CIRCUMFLEX -> LATIN CAPITAL LETTER W WITH CIRCUMFLEX
    charset += UIntSetRange(374, 374); // LATIN CAPITAL LETTER Y WITH CIRCUMFLEX -> LATIN CAPITAL LETTER Y WITH CIRCUMFLEX
    charset += UIntSetRange(376, 377); // LATIN CAPITAL LETTER Y WITH DIAERESIS -> LATIN CAPITAL LETTER Z WITH ACUTE
    charset += UIntSetRange(379, 379); // LATIN CAPITAL LETTER Z WITH DOT ABOVE -> LATIN CAPITAL LETTER Z WITH DOT ABOVE
    charset += UIntSetRange(381, 381); // LATIN CAPITAL LETTER Z WITH CARON -> LATIN CAPITAL LETTER Z WITH CARON
    charset += UIntSetRange(385, 386); // LATIN CAPITAL LETTER B WITH HOOK -> LATIN CAPITAL LETTER B WITH TOPBAR
    charset += UIntSetRange(388, 388); // LATIN CAPITAL LETTER TONE SIX -> LATIN CAPITAL LETTER TONE SIX
    charset += UIntSetRange(390, 391); // LATIN CAPITAL LETTER OPEN O -> LATIN CAPITAL LETTER C WITH HOOK
    charset += UIntSetRange(393, 395); // LATIN CAPITAL LETTER AFRICAN D -> LATIN CAPITAL LETTER D WITH TOPBAR
    charset += UIntSetRange(398, 401); // LATIN CAPITAL LETTER REVERSED E -> LATIN CAPITAL LETTER F WITH HOOK
    charset += UIntSetRange(403, 404); // LATIN CAPITAL LETTER G WITH HOOK -> LATIN CAPITAL LETTER GAMMA
    charset += UIntSetRange(406, 408); // LATIN CAPITAL LETTER IOTA -> LATIN CAPITAL LETTER K WITH HOOK
    charset += UIntSetRange(412, 413); // LATIN CAPITAL LETTER TURNED M -> LATIN CAPITAL LETTER N WITH LEFT HOOK
    charset += UIntSetRange(415, 416); // LATIN CAPITAL LETTER O WITH MIDDLE TILDE -> LATIN CAPITAL LETTER O WITH HORN
    charset += UIntSetRange(418, 418); // LATIN CAPITAL LETTER OI -> LATIN CAPITAL LETTER OI
    charset += UIntSetRange(420, 420); // LATIN CAPITAL LETTER P WITH HOOK -> LATIN CAPITAL LETTER P WITH HOOK
    charset += UIntSetRange(422, 423); // LATIN LETTER YR -> LATIN CAPITAL LETTER TONE TWO
    charset += UIntSetRange(425, 425); // LATIN CAPITAL LETTER ESH -> LATIN CAPITAL LETTER ESH
    charset += UIntSetRange(428, 428); // LATIN CAPITAL LETTER T WITH HOOK -> LATIN CAPITAL LETTER T WITH HOOK
    charset += UIntSetRange(430, 431); // LATIN CAPITAL LETTER T WITH RETROFLEX HOOK -> LATIN CAPITAL LETTER U WITH HORN
    charset += UIntSetRange(433, 435); // LATIN CAPITAL LETTER UPSILON -> LATIN CAPITAL LETTER Y WITH HOOK
    charset += UIntSetRange(437, 437); // LATIN CAPITAL LETTER Z WITH STROKE -> LATIN CAPITAL LETTER Z WITH STROKE
    charset += UIntSetRange(439, 440); // LATIN CAPITAL LETTER EZH -> LATIN CAPITAL LETTER EZH REVERSED
    charset += UIntSetRange(444, 444); // LATIN CAPITAL LETTER TONE FIVE -> LATIN CAPITAL LETTER TONE FIVE
    charset += UIntSetRange(452, 452); // LATIN CAPITAL LETTER DZ WITH CARON -> LATIN CAPITAL LETTER DZ WITH CARON
    charset += UIntSetRange(455, 455); // LATIN CAPITAL LETTER LJ -> LATIN CAPITAL LETTER LJ
    charset += UIntSetRange(458, 458); // LATIN CAPITAL LETTER NJ -> LATIN CAPITAL LETTER NJ
    charset += UIntSetRange(461, 461); // LATIN CAPITAL LETTER A WITH CARON -> LATIN CAPITAL LETTER A WITH CARON
    charset += UIntSetRange(463, 463); // LATIN CAPITAL LETTER I WITH CARON -> LATIN CAPITAL LETTER I WITH CARON
    charset += UIntSetRange(465, 465); // LATIN CAPITAL LETTER O WITH CARON -> LATIN CAPITAL LETTER O WITH CARON
    charset += UIntSetRange(467, 467); // LATIN CAPITAL LETTER U WITH CARON -> LATIN CAPITAL LETTER U WITH CARON
    charset += UIntSetRange(469, 469); // LATIN CAPITAL LETTER U WITH DIAERESIS AND MACRON -> LATIN CAPITAL LETTER U WITH DIAERESIS AND MACRON
    charset += UIntSetRange(471, 471); // LATIN CAPITAL LETTER U WITH DIAERESIS AND ACUTE -> LATIN CAPITAL LETTER U WITH DIAERESIS AND ACUTE
    charset += UIntSetRange(473, 473); // LATIN CAPITAL LETTER U WITH DIAERESIS AND CARON -> LATIN CAPITAL LETTER U WITH DIAERESIS AND CARON
    charset += UIntSetRange(475, 475); // LATIN CAPITAL LETTER U WITH DIAERESIS AND GRAVE -> LATIN CAPITAL LETTER U WITH DIAERESIS AND GRAVE
    charset += UIntSetRange(478, 478); // LATIN CAPITAL LETTER A WITH DIAERESIS AND MACRON -> LATIN CAPITAL LETTER A WITH DIAERESIS AND MACRON
    charset += UIntSetRange(480, 480); // LATIN CAPITAL LETTER A WITH DOT ABOVE AND MACRON -> LATIN CAPITAL LETTER A WITH DOT ABOVE AND MACRON
    charset += UIntSetRange(482, 482); // LATIN CAPITAL LETTER AE WITH MACRON -> LATIN CAPITAL LETTER AE WITH MACRON
    charset += UIntSetRange(484, 484); // LATIN CAPITAL LETTER G WITH STROKE -> LATIN CAPITAL LETTER G WITH STROKE
    charset += UIntSetRange(486, 486); // LATIN CAPITAL LETTER G WITH CARON -> LATIN CAPITAL LETTER G WITH CARON
    charset += UIntSetRange(488, 488); // LATIN CAPITAL LETTER K WITH CARON -> LATIN CAPITAL LETTER K WITH CARON
    charset += UIntSetRange(490, 490); // LATIN CAPITAL LETTER O WITH OGONEK -> LATIN CAPITAL LETTER O WITH OGONEK
    charset += UIntSetRange(492, 492); // LATIN CAPITAL LETTER O WITH OGONEK AND MACRON -> LATIN CAPITAL LETTER O WITH OGONEK AND MACRON
    charset += UIntSetRange(494, 494); // LATIN CAPITAL LETTER EZH WITH CARON -> LATIN CAPITAL LETTER EZH WITH CARON
    charset += UIntSetRange(497, 497); // LATIN CAPITAL LETTER DZ -> LATIN CAPITAL LETTER DZ
    charset += UIntSetRange(500, 500); // LATIN CAPITAL LETTER G WITH ACUTE -> LATIN CAPITAL LETTER G WITH ACUTE
    charset += UIntSetRange(502, 504); // LATIN CAPITAL LETTER HWAIR -> LATIN CAPITAL LETTER N WITH GRAVE
    charset += UIntSetRange(506, 506); // LATIN CAPITAL LETTER A WITH RING ABOVE AND ACUTE -> LATIN CAPITAL LETTER A WITH RING ABOVE AND ACUTE
    charset += UIntSetRange(508, 508); // LATIN CAPITAL LETTER AE WITH ACUTE -> LATIN CAPITAL LETTER AE WITH ACUTE
    charset += UIntSetRange(510, 510); // LATIN CAPITAL LETTER O WITH STROKE AND ACUTE -> LATIN CAPITAL LETTER O WITH STROKE AND ACUTE
    charset += UIntSetRange(512, 512); // LATIN CAPITAL LETTER A WITH DOUBLE GRAVE -> LATIN CAPITAL LETTER A WITH DOUBLE GRAVE
    charset += UIntSetRange(514, 514); // LATIN CAPITAL LETTER A WITH INVERTED BREVE -> LATIN CAPITAL LETTER A WITH INVERTED BREVE
    charset += UIntSetRange(516, 516); // LATIN CAPITAL LETTER E WITH DOUBLE GRAVE -> LATIN CAPITAL LETTER E WITH DOUBLE GRAVE
    charset += UIntSetRange(518, 518); // LATIN CAPITAL LETTER E WITH INVERTED BREVE -> LATIN CAPITAL LETTER E WITH INVERTED BREVE
    charset += UIntSetRange(520, 520); // LATIN CAPITAL LETTER I WITH DOUBLE GRAVE -> LATIN CAPITAL LETTER I WITH DOUBLE GRAVE
    charset += UIntSetRange(522, 522); // LATIN CAPITAL LETTER I WITH INVERTED BREVE -> LATIN CAPITAL LETTER I WITH INVERTED BREVE
    charset += UIntSetRange(524, 524); // LATIN CAPITAL LETTER O WITH DOUBLE GRAVE -> LATIN CAPITAL LETTER O WITH DOUBLE GRAVE
    charset += UIntSetRange(526, 526); // LATIN CAPITAL LETTER O WITH INVERTED BREVE -> LATIN CAPITAL LETTER O WITH INVERTED BREVE
    charset += UIntSetRange(528, 528); // LATIN CAPITAL LETTER R WITH DOUBLE GRAVE -> LATIN CAPITAL LETTER R WITH DOUBLE GRAVE
    charset += UIntSetRange(530, 530); // LATIN CAPITAL LETTER R WITH INVERTED BREVE -> LATIN CAPITAL LETTER R WITH INVERTED BREVE
    charset += UIntSetRange(532, 532); // LATIN CAPITAL LETTER U WITH DOUBLE GRAVE -> LATIN CAPITAL LETTER U WITH DOUBLE GRAVE
    charset += UIntSetRange(534, 534); // LATIN CAPITAL LETTER U WITH INVERTED BREVE -> LATIN CAPITAL LETTER U WITH INVERTED BREVE
    charset += UIntSetRange(536, 536); // LATIN CAPITAL LETTER S WITH COMMA BELOW -> LATIN CAPITAL LETTER S WITH COMMA BELOW
    charset += UIntSetRange(538, 538); // LATIN CAPITAL LETTER T WITH COMMA BELOW -> LATIN CAPITAL LETTER T WITH COMMA BELOW
    charset += UIntSetRange(540, 540); // LATIN CAPITAL LETTER YOGH -> LATIN CAPITAL LETTER YOGH
    charset += UIntSetRange(542, 542); // LATIN CAPITAL LETTER H WITH CARON -> LATIN CAPITAL LETTER H WITH CARON
    charset += UIntSetRange(544, 544); // LATIN CAPITAL LETTER N WITH LONG RIGHT LEG -> LATIN CAPITAL LETTER N WITH LONG RIGHT LEG
    charset += UIntSetRange(546, 546); // LATIN CAPITAL LETTER OU -> LATIN CAPITAL LETTER OU
    charset += UIntSetRange(548, 548); // LATIN CAPITAL LETTER Z WITH HOOK -> LATIN CAPITAL LETTER Z WITH HOOK
    charset += UIntSetRange(550, 550); // LATIN CAPITAL LETTER A WITH DOT ABOVE -> LATIN CAPITAL LETTER A WITH DOT ABOVE
    charset += UIntSetRange(552, 552); // LATIN CAPITAL LETTER E WITH CEDILLA -> LATIN CAPITAL LETTER E WITH CEDILLA
    charset += UIntSetRange(554, 554); // LATIN CAPITAL LETTER O WITH DIAERESIS AND MACRON -> LATIN CAPITAL LETTER O WITH DIAERESIS AND MACRON
    charset += UIntSetRange(556, 556); // LATIN CAPITAL LETTER O WITH TILDE AND MACRON -> LATIN CAPITAL LETTER O WITH TILDE AND MACRON
    charset += UIntSetRange(558, 558); // LATIN CAPITAL LETTER O WITH DOT ABOVE -> LATIN CAPITAL LETTER O WITH DOT ABOVE
    charset += UIntSetRange(560, 560); // LATIN CAPITAL LETTER O WITH DOT ABOVE AND MACRON -> LATIN CAPITAL LETTER O WITH DOT ABOVE AND MACRON
    charset += UIntSetRange(562, 562); // LATIN CAPITAL LETTER Y WITH MACRON -> LATIN CAPITAL LETTER Y WITH MACRON
    charset += UIntSetRange(570, 571); // LATIN CAPITAL LETTER A WITH STROKE -> LATIN CAPITAL LETTER C WITH STROKE
    charset += UIntSetRange(573, 574); // LATIN CAPITAL LETTER L WITH BAR -> LATIN CAPITAL LETTER T WITH DIAGONAL STROKE
    charset += UIntSetRange(577, 577); // LATIN CAPITAL LETTER GLOTTAL STOP -> LATIN CAPITAL LETTER GLOTTAL STOP
    charset += UIntSetRange(579, 582); // LATIN CAPITAL LETTER B WITH STROKE -> LATIN CAPITAL LETTER E WITH STROKE
    charset += UIntSetRange(584, 584); // LATIN CAPITAL LETTER J WITH STROKE -> LATIN CAPITAL LETTER J WITH STROKE
    charset += UIntSetRange(586, 586); // LATIN CAPITAL LETTER SMALL Q WITH HOOK TAIL -> LATIN CAPITAL LETTER SMALL Q WITH HOOK TAIL
    charset += UIntSetRange(588, 588); // LATIN CAPITAL LETTER R WITH STROKE -> LATIN CAPITAL LETTER R WITH STROKE
    charset += UIntSetRange(590, 590); // LATIN CAPITAL LETTER Y WITH STROKE -> LATIN CAPITAL LETTER Y WITH STROKE
    charset += UIntSetRange(880, 880); // GREEK CAPITAL LETTER HETA -> GREEK CAPITAL LETTER HETA
    charset += UIntSetRange(882, 882); // GREEK CAPITAL LETTER ARCHAIC SAMPI -> GREEK CAPITAL LETTER ARCHAIC SAMPI
    charset += UIntSetRange(886, 886); // GREEK CAPITAL LETTER PAMPHYLIAN DIGAMMA -> GREEK CAPITAL LETTER PAMPHYLIAN DIGAMMA
    charset += UIntSetRange(902, 902); // GREEK CAPITAL LETTER ALPHA WITH TONOS -> GREEK CAPITAL LETTER ALPHA WITH TONOS
    charset += UIntSetRange(904, 906); // GREEK CAPITAL LETTER EPSILON WITH TONOS -> GREEK CAPITAL LETTER IOTA WITH TONOS
    charset += UIntSetRange(908, 908); // GREEK CAPITAL LETTER OMICRON WITH TONOS -> GREEK CAPITAL LETTER OMICRON WITH TONOS
    charset += UIntSetRange(910, 911); // GREEK CAPITAL LETTER UPSILON WITH TONOS -> GREEK CAPITAL LETTER OMEGA WITH TONOS
    charset += UIntSetRange(913, 929); // GREEK CAPITAL LETTER ALPHA -> GREEK CAPITAL LETTER RHO
    charset += UIntSetRange(931, 939); // GREEK CAPITAL LETTER SIGMA -> GREEK CAPITAL LETTER UPSILON WITH DIALYTIKA
    charset += UIntSetRange(975, 975); // GREEK CAPITAL KAI SYMBOL -> GREEK CAPITAL KAI SYMBOL
    charset += UIntSetRange(978, 980); // GREEK UPSILON WITH HOOK SYMBOL -> GREEK UPSILON WITH DIAERESIS AND HOOK SYMBOL
    charset += UIntSetRange(984, 984); // GREEK LETTER ARCHAIC KOPPA -> GREEK LETTER ARCHAIC KOPPA
    charset += UIntSetRange(986, 986); // GREEK LETTER STIGMA -> GREEK LETTER STIGMA
    charset += UIntSetRange(988, 988); // GREEK LETTER DIGAMMA -> GREEK LETTER DIGAMMA
    charset += UIntSetRange(990, 990); // GREEK LETTER KOPPA -> GREEK LETTER KOPPA
    charset += UIntSetRange(992, 992); // GREEK LETTER SAMPI -> GREEK LETTER SAMPI
    charset += UIntSetRange(994, 994); // COPTIC CAPITAL LETTER SHEI -> COPTIC CAPITAL LETTER SHEI
    charset += UIntSetRange(996, 996); // COPTIC CAPITAL LETTER FEI -> COPTIC CAPITAL LETTER FEI
    charset += UIntSetRange(998, 998); // COPTIC CAPITAL LETTER KHEI -> COPTIC CAPITAL LETTER KHEI
    charset += UIntSetRange(1000, 1000); // COPTIC CAPITAL LETTER HORI -> COPTIC CAPITAL LETTER HORI
    charset += UIntSetRange(1002, 1002); // COPTIC CAPITAL LETTER GANGIA -> COPTIC CAPITAL LETTER GANGIA
    charset += UIntSetRange(1004, 1004); // COPTIC CAPITAL LETTER SHIMA -> COPTIC CAPITAL LETTER SHIMA
    charset += UIntSetRange(1006, 1006); // COPTIC CAPITAL LETTER DEI -> COPTIC CAPITAL LETTER DEI
    charset += UIntSetRange(1012, 1012); // GREEK CAPITAL THETA SYMBOL -> GREEK CAPITAL THETA SYMBOL
    charset += UIntSetRange(1015, 1015); // GREEK CAPITAL LETTER SHO -> GREEK CAPITAL LETTER SHO
    charset += UIntSetRange(1017, 1018); // GREEK CAPITAL LUNATE SIGMA SYMBOL -> GREEK CAPITAL LETTER SAN
    charset += UIntSetRange(1021, 1071); // GREEK CAPITAL REVERSED LUNATE SIGMA SYMBOL -> CYRILLIC CAPITAL LETTER YA
    charset += UIntSetRange(1120, 1120); // CYRILLIC CAPITAL LETTER OMEGA -> CYRILLIC CAPITAL LETTER OMEGA
    charset += UIntSetRange(1122, 1122); // CYRILLIC CAPITAL LETTER YAT -> CYRILLIC CAPITAL LETTER YAT
    charset += UIntSetRange(1124, 1124); // CYRILLIC CAPITAL LETTER IOTIFIED E -> CYRILLIC CAPITAL LETTER IOTIFIED E
    charset += UIntSetRange(1126, 1126); // CYRILLIC CAPITAL LETTER LITTLE YUS -> CYRILLIC CAPITAL LETTER LITTLE YUS
    charset += UIntSetRange(1128, 1128); // CYRILLIC CAPITAL LETTER IOTIFIED LITTLE YUS -> CYRILLIC CAPITAL LETTER IOTIFIED LITTLE YUS
    charset += UIntSetRange(1130, 1130); // CYRILLIC CAPITAL LETTER BIG YUS -> CYRILLIC CAPITAL LETTER BIG YUS
    charset += UIntSetRange(1132, 1132); // CYRILLIC CAPITAL LETTER IOTIFIED BIG YUS -> CYRILLIC CAPITAL LETTER IOTIFIED BIG YUS
    charset += UIntSetRange(1134, 1134); // CYRILLIC CAPITAL LETTER KSI -> CYRILLIC CAPITAL LETTER KSI
    charset += UIntSetRange(1136, 1136); // CYRILLIC CAPITAL LETTER PSI -> CYRILLIC CAPITAL LETTER PSI
    charset += UIntSetRange(1138, 1138); // CYRILLIC CAPITAL LETTER FITA -> CYRILLIC CAPITAL LETTER FITA
    charset += UIntSetRange(1140, 1140); // CYRILLIC CAPITAL LETTER IZHITSA -> CYRILLIC CAPITAL LETTER IZHITSA
    charset += UIntSetRange(1142, 1142); // CYRILLIC CAPITAL LETTER IZHITSA WITH DOUBLE GRAVE ACCENT -> CYRILLIC CAPITAL LETTER IZHITSA WITH DOUBLE GRAVE ACCENT
    charset += UIntSetRange(1144, 1144); // CYRILLIC CAPITAL LETTER UK -> CYRILLIC CAPITAL LETTER UK
    charset += UIntSetRange(1146, 1146); // CYRILLIC CAPITAL LETTER ROUND OMEGA -> CYRILLIC CAPITAL LETTER ROUND OMEGA
    charset += UIntSetRange(1148, 1148); // CYRILLIC CAPITAL LETTER OMEGA WITH TITLO -> CYRILLIC CAPITAL LETTER OMEGA WITH TITLO
    charset += UIntSetRange(1150, 1150); // CYRILLIC CAPITAL LETTER OT -> CYRILLIC CAPITAL LETTER OT
    charset += UIntSetRange(1152, 1152); // CYRILLIC CAPITAL LETTER KOPPA -> CYRILLIC CAPITAL LETTER KOPPA
    charset += UIntSetRange(1162, 1162); // CYRILLIC CAPITAL LETTER SHORT I WITH TAIL -> CYRILLIC CAPITAL LETTER SHORT I WITH TAIL
    charset += UIntSetRange(1164, 1164); // CYRILLIC CAPITAL LETTER SEMISOFT SIGN -> CYRILLIC CAPITAL LETTER SEMISOFT SIGN
    charset += UIntSetRange(1166, 1166); // CYRILLIC CAPITAL LETTER ER WITH TICK -> CYRILLIC CAPITAL LETTER ER WITH TICK
    charset += UIntSetRange(1168, 1168); // CYRILLIC CAPITAL LETTER GHE WITH UPTURN -> CYRILLIC CAPITAL LETTER GHE WITH UPTURN
    charset += UIntSetRange(1170, 1170); // CYRILLIC CAPITAL LETTER GHE WITH STROKE -> CYRILLIC CAPITAL LETTER GHE WITH STROKE
    charset += UIntSetRange(1172, 1172); // CYRILLIC CAPITAL LETTER GHE WITH MIDDLE HOOK -> CYRILLIC CAPITAL LETTER GHE WITH MIDDLE HOOK
    charset += UIntSetRange(1174, 1174); // CYRILLIC CAPITAL LETTER ZHE WITH DESCENDER -> CYRILLIC CAPITAL LETTER ZHE WITH DESCENDER
    charset += UIntSetRange(1176, 1176); // CYRILLIC CAPITAL LETTER ZE WITH DESCENDER -> CYRILLIC CAPITAL LETTER ZE WITH DESCENDER
    charset += UIntSetRange(1178, 1178); // CYRILLIC CAPITAL LETTER KA WITH DESCENDER -> CYRILLIC CAPITAL LETTER KA WITH DESCENDER
    charset += UIntSetRange(1180, 1180); // CYRILLIC CAPITAL LETTER KA WITH VERTICAL STROKE -> CYRILLIC CAPITAL LETTER KA WITH VERTICAL STROKE
    charset += UIntSetRange(1182, 1182); // CYRILLIC CAPITAL LETTER KA WITH STROKE -> CYRILLIC CAPITAL LETTER KA WITH STROKE
    charset += UIntSetRange(1184, 1184); // CYRILLIC CAPITAL LETTER BASHKIR KA -> CYRILLIC CAPITAL LETTER BASHKIR KA
    charset += UIntSetRange(1186, 1186); // CYRILLIC CAPITAL LETTER EN WITH DESCENDER -> CYRILLIC CAPITAL LETTER EN WITH DESCENDER
    charset += UIntSetRange(1188, 1188); // CYRILLIC CAPITAL LIGATURE EN GHE -> CYRILLIC CAPITAL LIGATURE EN GHE
    charset += UIntSetRange(1190, 1190); // CYRILLIC CAPITAL LETTER PE WITH MIDDLE HOOK -> CYRILLIC CAPITAL LETTER PE WITH MIDDLE HOOK
    charset += UIntSetRange(1192, 1192); // CYRILLIC CAPITAL LETTER ABKHASIAN HA -> CYRILLIC CAPITAL LETTER ABKHASIAN HA
    charset += UIntSetRange(1194, 1194); // CYRILLIC CAPITAL LETTER ES WITH DESCENDER -> CYRILLIC CAPITAL LETTER ES WITH DESCENDER
    charset += UIntSetRange(1196, 1196); // CYRILLIC CAPITAL LETTER TE WITH DESCENDER -> CYRILLIC CAPITAL LETTER TE WITH DESCENDER
    charset += UIntSetRange(1198, 1198); // CYRILLIC CAPITAL LETTER STRAIGHT U -> CYRILLIC CAPITAL LETTER STRAIGHT U
    charset += UIntSetRange(1200, 1200); // CYRILLIC CAPITAL LETTER STRAIGHT U WITH STROKE -> CYRILLIC CAPITAL LETTER STRAIGHT U WITH STROKE
    charset += UIntSetRange(1202, 1202); // CYRILLIC CAPITAL LETTER HA WITH DESCENDER -> CYRILLIC CAPITAL LETTER HA WITH DESCENDER
    charset += UIntSetRange(1204, 1204); // CYRILLIC CAPITAL LIGATURE TE TSE -> CYRILLIC CAPITAL LIGATURE TE TSE
    charset += UIntSetRange(1206, 1206); // CYRILLIC CAPITAL LETTER CHE WITH DESCENDER -> CYRILLIC CAPITAL LETTER CHE WITH DESCENDER
    charset += UIntSetRange(1208, 1208); // CYRILLIC CAPITAL LETTER CHE WITH VERTICAL STROKE -> CYRILLIC CAPITAL LETTER CHE WITH VERTICAL STROKE
    charset += UIntSetRange(1210, 1210); // CYRILLIC CAPITAL LETTER SHHA -> CYRILLIC CAPITAL LETTER SHHA
    charset += UIntSetRange(1212, 1212); // CYRILLIC CAPITAL LETTER ABKHASIAN CHE -> CYRILLIC CAPITAL LETTER ABKHASIAN CHE
    charset += UIntSetRange(1214, 1214); // CYRILLIC CAPITAL LETTER ABKHASIAN CHE WITH DESCENDER -> CYRILLIC CAPITAL LETTER ABKHASIAN CHE WITH DESCENDER
    charset += UIntSetRange(1216, 1217); // CYRILLIC LETTER PALOCHKA -> CYRILLIC CAPITAL LETTER ZHE WITH BREVE
    charset += UIntSetRange(1219, 1219); // CYRILLIC CAPITAL LETTER KA WITH HOOK -> CYRILLIC CAPITAL LETTER KA WITH HOOK
    charset += UIntSetRange(1221, 1221); // CYRILLIC CAPITAL LETTER EL WITH TAIL -> CYRILLIC CAPITAL LETTER EL WITH TAIL
    charset += UIntSetRange(1223, 1223); // CYRILLIC CAPITAL LETTER EN WITH HOOK -> CYRILLIC CAPITAL LETTER EN WITH HOOK
    charset += UIntSetRange(1225, 1225); // CYRILLIC CAPITAL LETTER EN WITH TAIL -> CYRILLIC CAPITAL LETTER EN WITH TAIL
    charset += UIntSetRange(1227, 1227); // CYRILLIC CAPITAL LETTER KHAKASSIAN CHE -> CYRILLIC CAPITAL LETTER KHAKASSIAN CHE
    charset += UIntSetRange(1229, 1229); // CYRILLIC CAPITAL LETTER EM WITH TAIL -> CYRILLIC CAPITAL LETTER EM WITH TAIL
    charset += UIntSetRange(1232, 1232); // CYRILLIC CAPITAL LETTER A WITH BREVE -> CYRILLIC CAPITAL LETTER A WITH BREVE
    charset += UIntSetRange(1234, 1234); // CYRILLIC CAPITAL LETTER A WITH DIAERESIS -> CYRILLIC CAPITAL LETTER A WITH DIAERESIS
    charset += UIntSetRange(1236, 1236); // CYRILLIC CAPITAL LIGATURE A IE -> CYRILLIC CAPITAL LIGATURE A IE
    charset += UIntSetRange(1238, 1238); // CYRILLIC CAPITAL LETTER IE WITH BREVE -> CYRILLIC CAPITAL LETTER IE WITH BREVE
    charset += UIntSetRange(1240, 1240); // CYRILLIC CAPITAL LETTER SCHWA -> CYRILLIC CAPITAL LETTER SCHWA
    charset += UIntSetRange(1242, 1242); // CYRILLIC CAPITAL LETTER SCHWA WITH DIAERESIS -> CYRILLIC CAPITAL LETTER SCHWA WITH DIAERESIS
    charset += UIntSetRange(1244, 1244); // CYRILLIC CAPITAL LETTER ZHE WITH DIAERESIS -> CYRILLIC CAPITAL LETTER ZHE WITH DIAERESIS
    charset += UIntSetRange(1246, 1246); // CYRILLIC CAPITAL LETTER ZE WITH DIAERESIS -> CYRILLIC CAPITAL LETTER ZE WITH DIAERESIS
    charset += UIntSetRange(1248, 1248); // CYRILLIC CAPITAL LETTER ABKHASIAN DZE -> CYRILLIC CAPITAL LETTER ABKHASIAN DZE
    charset += UIntSetRange(1250, 1250); // CYRILLIC CAPITAL LETTER I WITH MACRON -> CYRILLIC CAPITAL LETTER I WITH MACRON
    charset += UIntSetRange(1252, 1252); // CYRILLIC CAPITAL LETTER I WITH DIAERESIS -> CYRILLIC CAPITAL LETTER I WITH DIAERESIS
    charset += UIntSetRange(1254, 1254); // CYRILLIC CAPITAL LETTER O WITH DIAERESIS -> CYRILLIC CAPITAL LETTER O WITH DIAERESIS
    charset += UIntSetRange(1256, 1256); // CYRILLIC CAPITAL LETTER BARRED O -> CYRILLIC CAPITAL LETTER BARRED O
    charset += UIntSetRange(1258, 1258); // CYRILLIC CAPITAL LETTER BARRED O WITH DIAERESIS -> CYRILLIC CAPITAL LETTER BARRED O WITH DIAERESIS
    charset += UIntSetRange(1260, 1260); // CYRILLIC CAPITAL LETTER E WITH DIAERESIS -> CYRILLIC CAPITAL LETTER E WITH DIAERESIS
    charset += UIntSetRange(1262, 1262); // CYRILLIC CAPITAL LETTER U WITH MACRON -> CYRILLIC CAPITAL LETTER U WITH MACRON
    charset += UIntSetRange(1264, 1264); // CYRILLIC CAPITAL LETTER U WITH DIAERESIS -> CYRILLIC CAPITAL LETTER U WITH DIAERESIS
    charset += UIntSetRange(1266, 1266); // CYRILLIC CAPITAL LETTER U WITH DOUBLE ACUTE -> CYRILLIC CAPITAL LETTER U WITH DOUBLE ACUTE
    charset += UIntSetRange(1268, 1268); // CYRILLIC CAPITAL LETTER CHE WITH DIAERESIS -> CYRILLIC CAPITAL LETTER CHE WITH DIAERESIS
    charset += UIntSetRange(1270, 1270); // CYRILLIC CAPITAL LETTER GHE WITH DESCENDER -> CYRILLIC CAPITAL LETTER GHE WITH DESCENDER
    charset += UIntSetRange(1272, 1272); // CYRILLIC CAPITAL LETTER YERU WITH DIAERESIS -> CYRILLIC CAPITAL LETTER YERU WITH DIAERESIS
    charset += UIntSetRange(1274, 1274); // CYRILLIC CAPITAL LETTER GHE WITH STROKE AND HOOK -> CYRILLIC CAPITAL LETTER GHE WITH STROKE AND HOOK
    charset += UIntSetRange(1276, 1276); // CYRILLIC CAPITAL LETTER HA WITH HOOK -> CYRILLIC CAPITAL LETTER HA WITH HOOK
    charset += UIntSetRange(1278, 1278); // CYRILLIC CAPITAL LETTER HA WITH STROKE -> CYRILLIC CAPITAL LETTER HA WITH STROKE
    charset += UIntSetRange(1280, 1280); // CYRILLIC CAPITAL LETTER KOMI DE -> CYRILLIC CAPITAL LETTER KOMI DE
    charset += UIntSetRange(1282, 1282); // CYRILLIC CAPITAL LETTER KOMI DJE -> CYRILLIC CAPITAL LETTER KOMI DJE
    charset += UIntSetRange(1284, 1284); // CYRILLIC CAPITAL LETTER KOMI ZJE -> CYRILLIC CAPITAL LETTER KOMI ZJE
    charset += UIntSetRange(1286, 1286); // CYRILLIC CAPITAL LETTER KOMI DZJE -> CYRILLIC CAPITAL LETTER KOMI DZJE
    charset += UIntSetRange(1288, 1288); // CYRILLIC CAPITAL LETTER KOMI LJE -> CYRILLIC CAPITAL LETTER KOMI LJE
    charset += UIntSetRange(1290, 1290); // CYRILLIC CAPITAL LETTER KOMI NJE -> CYRILLIC CAPITAL LETTER KOMI NJE
    charset += UIntSetRange(1292, 1292); // CYRILLIC CAPITAL LETTER KOMI SJE -> CYRILLIC CAPITAL LETTER KOMI SJE
    charset += UIntSetRange(1294, 1294); // CYRILLIC CAPITAL LETTER KOMI TJE -> CYRILLIC CAPITAL LETTER KOMI TJE
    charset += UIntSetRange(1296, 1296); // CYRILLIC CAPITAL LETTER REVERSED ZE -> CYRILLIC CAPITAL LETTER REVERSED ZE
    charset += UIntSetRange(1298, 1298); // CYRILLIC CAPITAL LETTER EL WITH HOOK -> CYRILLIC CAPITAL LETTER EL WITH HOOK
    charset += UIntSetRange(1300, 1300); // CYRILLIC CAPITAL LETTER LHA -> CYRILLIC CAPITAL LETTER LHA
    charset += UIntSetRange(1302, 1302); // CYRILLIC CAPITAL LETTER RHA -> CYRILLIC CAPITAL LETTER RHA
    charset += UIntSetRange(1304, 1304); // CYRILLIC CAPITAL LETTER YAE -> CYRILLIC CAPITAL LETTER YAE
    charset += UIntSetRange(1306, 1306); // CYRILLIC CAPITAL LETTER QA -> CYRILLIC CAPITAL LETTER QA
    charset += UIntSetRange(1308, 1308); // CYRILLIC CAPITAL LETTER WE -> CYRILLIC CAPITAL LETTER WE
    charset += UIntSetRange(1310, 1310); // CYRILLIC CAPITAL LETTER ALEUT KA -> CYRILLIC CAPITAL LETTER ALEUT KA
    charset += UIntSetRange(1312, 1312); // CYRILLIC CAPITAL LETTER EL WITH MIDDLE HOOK -> CYRILLIC CAPITAL LETTER EL WITH MIDDLE HOOK
    charset += UIntSetRange(1314, 1314); // CYRILLIC CAPITAL LETTER EN WITH MIDDLE HOOK -> CYRILLIC CAPITAL LETTER EN WITH MIDDLE HOOK
    charset += UIntSetRange(1329, 1366); // ARMENIAN CAPITAL LETTER AYB -> ARMENIAN CAPITAL LETTER FEH
    charset += UIntSetRange(4256, 4293); // GEORGIAN CAPITAL LETTER AN -> GEORGIAN CAPITAL LETTER HOE
    charset += UIntSetRange(7680, 7680); // LATIN CAPITAL LETTER A WITH RING BELOW -> LATIN CAPITAL LETTER A WITH RING BELOW
    charset += UIntSetRange(7682, 7682); // LATIN CAPITAL LETTER B WITH DOT ABOVE -> LATIN CAPITAL LETTER B WITH DOT ABOVE
    charset += UIntSetRange(7684, 7684); // LATIN CAPITAL LETTER B WITH DOT BELOW -> LATIN CAPITAL LETTER B WITH DOT BELOW
    charset += UIntSetRange(7686, 7686); // LATIN CAPITAL LETTER B WITH LINE BELOW -> LATIN CAPITAL LETTER B WITH LINE BELOW
    charset += UIntSetRange(7688, 7688); // LATIN CAPITAL LETTER C WITH CEDILLA AND ACUTE -> LATIN CAPITAL LETTER C WITH CEDILLA AND ACUTE
    charset += UIntSetRange(7690, 7690); // LATIN CAPITAL LETTER D WITH DOT ABOVE -> LATIN CAPITAL LETTER D WITH DOT ABOVE
    charset += UIntSetRange(7692, 7692); // LATIN CAPITAL LETTER D WITH DOT BELOW -> LATIN CAPITAL LETTER D WITH DOT BELOW
    charset += UIntSetRange(7694, 7694); // LATIN CAPITAL LETTER D WITH LINE BELOW -> LATIN CAPITAL LETTER D WITH LINE BELOW
    charset += UIntSetRange(7696, 7696); // LATIN CAPITAL LETTER D WITH CEDILLA -> LATIN CAPITAL LETTER D WITH CEDILLA
    charset += UIntSetRange(7698, 7698); // LATIN CAPITAL LETTER D WITH CIRCUMFLEX BELOW -> LATIN CAPITAL LETTER D WITH CIRCUMFLEX BELOW
    charset += UIntSetRange(7700, 7700); // LATIN CAPITAL LETTER E WITH MACRON AND GRAVE -> LATIN CAPITAL LETTER E WITH MACRON AND GRAVE
    charset += UIntSetRange(7702, 7702); // LATIN CAPITAL LETTER E WITH MACRON AND ACUTE -> LATIN CAPITAL LETTER E WITH MACRON AND ACUTE
    charset += UIntSetRange(7704, 7704); // LATIN CAPITAL LETTER E WITH CIRCUMFLEX BELOW -> LATIN CAPITAL LETTER E WITH CIRCUMFLEX BELOW
    charset += UIntSetRange(7706, 7706); // LATIN CAPITAL LETTER E WITH TILDE BELOW -> LATIN CAPITAL LETTER E WITH TILDE BELOW
    charset += UIntSetRange(7708, 7708); // LATIN CAPITAL LETTER E WITH CEDILLA AND BREVE -> LATIN CAPITAL LETTER E WITH CEDILLA AND BREVE
    charset += UIntSetRange(7710, 7710); // LATIN CAPITAL LETTER F WITH DOT ABOVE -> LATIN CAPITAL LETTER F WITH DOT ABOVE
    charset += UIntSetRange(7712, 7712); // LATIN CAPITAL LETTER G WITH MACRON -> LATIN CAPITAL LETTER G WITH MACRON
    charset += UIntSetRange(7714, 7714); // LATIN CAPITAL LETTER H WITH DOT ABOVE -> LATIN CAPITAL LETTER H WITH DOT ABOVE
    charset += UIntSetRange(7716, 7716); // LATIN CAPITAL LETTER H WITH DOT BELOW -> LATIN CAPITAL LETTER H WITH DOT BELOW
    charset += UIntSetRange(7718, 7718); // LATIN CAPITAL LETTER H WITH DIAERESIS -> LATIN CAPITAL LETTER H WITH DIAERESIS
    charset += UIntSetRange(7720, 7720); // LATIN CAPITAL LETTER H WITH CEDILLA -> LATIN CAPITAL LETTER H WITH CEDILLA
    charset += UIntSetRange(7722, 7722); // LATIN CAPITAL LETTER H WITH BREVE BELOW -> LATIN CAPITAL LETTER H WITH BREVE BELOW
    charset += UIntSetRange(7724, 7724); // LATIN CAPITAL LETTER I WITH TILDE BELOW -> LATIN CAPITAL LETTER I WITH TILDE BELOW
    charset += UIntSetRange(7726, 7726); // LATIN CAPITAL LETTER I WITH DIAERESIS AND ACUTE -> LATIN CAPITAL LETTER I WITH DIAERESIS AND ACUTE
    charset += UIntSetRange(7728, 7728); // LATIN CAPITAL LETTER K WITH ACUTE -> LATIN CAPITAL LETTER K WITH ACUTE
    charset += UIntSetRange(7730, 7730); // LATIN CAPITAL LETTER K WITH DOT BELOW -> LATIN CAPITAL LETTER K WITH DOT BELOW
    charset += UIntSetRange(7732, 7732); // LATIN CAPITAL LETTER K WITH LINE BELOW -> LATIN CAPITAL LETTER K WITH LINE BELOW
    charset += UIntSetRange(7734, 7734); // LATIN CAPITAL LETTER L WITH DOT BELOW -> LATIN CAPITAL LETTER L WITH DOT BELOW
    charset += UIntSetRange(7736, 7736); // LATIN CAPITAL LETTER L WITH DOT BELOW AND MACRON -> LATIN CAPITAL LETTER L WITH DOT BELOW AND MACRON
    charset += UIntSetRange(7738, 7738); // LATIN CAPITAL LETTER L WITH LINE BELOW -> LATIN CAPITAL LETTER L WITH LINE BELOW
    charset += UIntSetRange(7740, 7740); // LATIN CAPITAL LETTER L WITH CIRCUMFLEX BELOW -> LATIN CAPITAL LETTER L WITH CIRCUMFLEX BELOW
    charset += UIntSetRange(7742, 7742); // LATIN CAPITAL LETTER M WITH ACUTE -> LATIN CAPITAL LETTER M WITH ACUTE
    charset += UIntSetRange(7744, 7744); // LATIN CAPITAL LETTER M WITH DOT ABOVE -> LATIN CAPITAL LETTER M WITH DOT ABOVE
    charset += UIntSetRange(7746, 7746); // LATIN CAPITAL LETTER M WITH DOT BELOW -> LATIN CAPITAL LETTER M WITH DOT BELOW
    charset += UIntSetRange(7748, 7748); // LATIN CAPITAL LETTER N WITH DOT ABOVE -> LATIN CAPITAL LETTER N WITH DOT ABOVE
    charset += UIntSetRange(7750, 7750); // LATIN CAPITAL LETTER N WITH DOT BELOW -> LATIN CAPITAL LETTER N WITH DOT BELOW
    charset += UIntSetRange(7752, 7752); // LATIN CAPITAL LETTER N WITH LINE BELOW -> LATIN CAPITAL LETTER N WITH LINE BELOW
    charset += UIntSetRange(7754, 7754); // LATIN CAPITAL LETTER N WITH CIRCUMFLEX BELOW -> LATIN CAPITAL LETTER N WITH CIRCUMFLEX BELOW
    charset += UIntSetRange(7756, 7756); // LATIN CAPITAL LETTER O WITH TILDE AND ACUTE -> LATIN CAPITAL LETTER O WITH TILDE AND ACUTE
    charset += UIntSetRange(7758, 7758); // LATIN CAPITAL LETTER O WITH TILDE AND DIAERESIS -> LATIN CAPITAL LETTER O WITH TILDE AND DIAERESIS
    charset += UIntSetRange(7760, 7760); // LATIN CAPITAL LETTER O WITH MACRON AND GRAVE -> LATIN CAPITAL LETTER O WITH MACRON AND GRAVE
    charset += UIntSetRange(7762, 7762); // LATIN CAPITAL LETTER O WITH MACRON AND ACUTE -> LATIN CAPITAL LETTER O WITH MACRON AND ACUTE
    charset += UIntSetRange(7764, 7764); // LATIN CAPITAL LETTER P WITH ACUTE -> LATIN CAPITAL LETTER P WITH ACUTE
    charset += UIntSetRange(7766, 7766); // LATIN CAPITAL LETTER P WITH DOT ABOVE -> LATIN CAPITAL LETTER P WITH DOT ABOVE
    charset += UIntSetRange(7768, 7768); // LATIN CAPITAL LETTER R WITH DOT ABOVE -> LATIN CAPITAL LETTER R WITH DOT ABOVE
    charset += UIntSetRange(7770, 7770); // LATIN CAPITAL LETTER R WITH DOT BELOW -> LATIN CAPITAL LETTER R WITH DOT BELOW
    charset += UIntSetRange(7772, 7772); // LATIN CAPITAL LETTER R WITH DOT BELOW AND MACRON -> LATIN CAPITAL LETTER R WITH DOT BELOW AND MACRON
    charset += UIntSetRange(7774, 7774); // LATIN CAPITAL LETTER R WITH LINE BELOW -> LATIN CAPITAL LETTER R WITH LINE BELOW
    charset += UIntSetRange(7776, 7776); // LATIN CAPITAL LETTER S WITH DOT ABOVE -> LATIN CAPITAL LETTER S WITH DOT ABOVE
    charset += UIntSetRange(7778, 7778); // LATIN CAPITAL LETTER S WITH DOT BELOW -> LATIN CAPITAL LETTER S WITH DOT BELOW
    charset += UIntSetRange(7780, 7780); // LATIN CAPITAL LETTER S WITH ACUTE AND DOT ABOVE -> LATIN CAPITAL LETTER S WITH ACUTE AND DOT ABOVE
    charset += UIntSetRange(7782, 7782); // LATIN CAPITAL LETTER S WITH CARON AND DOT ABOVE -> LATIN CAPITAL LETTER S WITH CARON AND DOT ABOVE
    charset += UIntSetRange(7784, 7784); // LATIN CAPITAL LETTER S WITH DOT BELOW AND DOT ABOVE -> LATIN CAPITAL LETTER S WITH DOT BELOW AND DOT ABOVE
    charset += UIntSetRange(7786, 7786); // LATIN CAPITAL LETTER T WITH DOT ABOVE -> LATIN CAPITAL LETTER T WITH DOT ABOVE
    charset += UIntSetRange(7788, 7788); // LATIN CAPITAL LETTER T WITH DOT BELOW -> LATIN CAPITAL LETTER T WITH DOT BELOW
    charset += UIntSetRange(7790, 7790); // LATIN CAPITAL LETTER T WITH LINE BELOW -> LATIN CAPITAL LETTER T WITH LINE BELOW
    charset += UIntSetRange(7792, 7792); // LATIN CAPITAL LETTER T WITH CIRCUMFLEX BELOW -> LATIN CAPITAL LETTER T WITH CIRCUMFLEX BELOW
    charset += UIntSetRange(7794, 7794); // LATIN CAPITAL LETTER U WITH DIAERESIS BELOW -> LATIN CAPITAL LETTER U WITH DIAERESIS BELOW
    charset += UIntSetRange(7796, 7796); // LATIN CAPITAL LETTER U WITH TILDE BELOW -> LATIN CAPITAL LETTER U WITH TILDE BELOW
    charset += UIntSetRange(7798, 7798); // LATIN CAPITAL LETTER U WITH CIRCUMFLEX BELOW -> LATIN CAPITAL LETTER U WITH CIRCUMFLEX BELOW
    charset += UIntSetRange(7800, 7800); // LATIN CAPITAL LETTER U WITH TILDE AND ACUTE -> LATIN CAPITAL LETTER U WITH TILDE AND ACUTE
    charset += UIntSetRange(7802, 7802); // LATIN CAPITAL LETTER U WITH MACRON AND DIAERESIS -> LATIN CAPITAL LETTER U WITH MACRON AND DIAERESIS
    charset += UIntSetRange(7804, 7804); // LATIN CAPITAL LETTER V WITH TILDE -> LATIN CAPITAL LETTER V WITH TILDE
    charset += UIntSetRange(7806, 7806); // LATIN CAPITAL LETTER V WITH DOT BELOW -> LATIN CAPITAL LETTER V WITH DOT BELOW
    charset += UIntSetRange(7808, 7808); // LATIN CAPITAL LETTER W WITH GRAVE -> LATIN CAPITAL LETTER W WITH GRAVE
    charset += UIntSetRange(7810, 7810); // LATIN CAPITAL LETTER W WITH ACUTE -> LATIN CAPITAL LETTER W WITH ACUTE
    charset += UIntSetRange(7812, 7812); // LATIN CAPITAL LETTER W WITH DIAERESIS -> LATIN CAPITAL LETTER W WITH DIAERESIS
    charset += UIntSetRange(7814, 7814); // LATIN CAPITAL LETTER W WITH DOT ABOVE -> LATIN CAPITAL LETTER W WITH DOT ABOVE
    charset += UIntSetRange(7816, 7816); // LATIN CAPITAL LETTER W WITH DOT BELOW -> LATIN CAPITAL LETTER W WITH DOT BELOW
    charset += UIntSetRange(7818, 7818); // LATIN CAPITAL LETTER X WITH DOT ABOVE -> LATIN CAPITAL LETTER X WITH DOT ABOVE
    charset += UIntSetRange(7820, 7820); // LATIN CAPITAL LETTER X WITH DIAERESIS -> LATIN CAPITAL LETTER X WITH DIAERESIS
    charset += UIntSetRange(7822, 7822); // LATIN CAPITAL LETTER Y WITH DOT ABOVE -> LATIN CAPITAL LETTER Y WITH DOT ABOVE
    charset += UIntSetRange(7824, 7824); // LATIN CAPITAL LETTER Z WITH CIRCUMFLEX -> LATIN CAPITAL LETTER Z WITH CIRCUMFLEX
    charset += UIntSetRange(7826, 7826); // LATIN CAPITAL LETTER Z WITH DOT BELOW -> LATIN CAPITAL LETTER Z WITH DOT BELOW
    charset += UIntSetRange(7828, 7828); // LATIN CAPITAL LETTER Z WITH LINE BELOW -> LATIN CAPITAL LETTER Z WITH LINE BELOW
    charset += UIntSetRange(7838, 7838); // LATIN CAPITAL LETTER SHARP S -> LATIN CAPITAL LETTER SHARP S
    charset += UIntSetRange(7840, 7840); // LATIN CAPITAL LETTER A WITH DOT BELOW -> LATIN CAPITAL LETTER A WITH DOT BELOW
    charset += UIntSetRange(7842, 7842); // LATIN CAPITAL LETTER A WITH HOOK ABOVE -> LATIN CAPITAL LETTER A WITH HOOK ABOVE
    charset += UIntSetRange(7844, 7844); // LATIN CAPITAL LETTER A WITH CIRCUMFLEX AND ACUTE -> LATIN CAPITAL LETTER A WITH CIRCUMFLEX AND ACUTE
    charset += UIntSetRange(7846, 7846); // LATIN CAPITAL LETTER A WITH CIRCUMFLEX AND GRAVE -> LATIN CAPITAL LETTER A WITH CIRCUMFLEX AND GRAVE
    charset += UIntSetRange(7848, 7848); // LATIN CAPITAL LETTER A WITH CIRCUMFLEX AND HOOK ABOVE -> LATIN CAPITAL LETTER A WITH CIRCUMFLEX AND HOOK ABOVE
    charset += UIntSetRange(7850, 7850); // LATIN CAPITAL LETTER A WITH CIRCUMFLEX AND TILDE -> LATIN CAPITAL LETTER A WITH CIRCUMFLEX AND TILDE
    charset += UIntSetRange(7852, 7852); // LATIN CAPITAL LETTER A WITH CIRCUMFLEX AND DOT BELOW -> LATIN CAPITAL LETTER A WITH CIRCUMFLEX AND DOT BELOW
    charset += UIntSetRange(7854, 7854); // LATIN CAPITAL LETTER A WITH BREVE AND ACUTE -> LATIN CAPITAL LETTER A WITH BREVE AND ACUTE
    charset += UIntSetRange(7856, 7856); // LATIN CAPITAL LETTER A WITH BREVE AND GRAVE -> LATIN CAPITAL LETTER A WITH BREVE AND GRAVE
    charset += UIntSetRange(7858, 7858); // LATIN CAPITAL LETTER A WITH BREVE AND HOOK ABOVE -> LATIN CAPITAL LETTER A WITH BREVE AND HOOK ABOVE
    charset += UIntSetRange(7860, 7860); // LATIN CAPITAL LETTER A WITH BREVE AND TILDE -> LATIN CAPITAL LETTER A WITH BREVE AND TILDE
    charset += UIntSetRange(7862, 7862); // LATIN CAPITAL LETTER A WITH BREVE AND DOT BELOW -> LATIN CAPITAL LETTER A WITH BREVE AND DOT BELOW
    charset += UIntSetRange(7864, 7864); // LATIN CAPITAL LETTER E WITH DOT BELOW -> LATIN CAPITAL LETTER E WITH DOT BELOW
    charset += UIntSetRange(7866, 7866); // LATIN CAPITAL LETTER E WITH HOOK ABOVE -> LATIN CAPITAL LETTER E WITH HOOK ABOVE
    charset += UIntSetRange(7868, 7868); // LATIN CAPITAL LETTER E WITH TILDE -> LATIN CAPITAL LETTER E WITH TILDE
    charset += UIntSetRange(7870, 7870); // LATIN CAPITAL LETTER E WITH CIRCUMFLEX AND ACUTE -> LATIN CAPITAL LETTER E WITH CIRCUMFLEX AND ACUTE
    charset += UIntSetRange(7872, 7872); // LATIN CAPITAL LETTER E WITH CIRCUMFLEX AND GRAVE -> LATIN CAPITAL LETTER E WITH CIRCUMFLEX AND GRAVE
    charset += UIntSetRange(7874, 7874); // LATIN CAPITAL LETTER E WITH CIRCUMFLEX AND HOOK ABOVE -> LATIN CAPITAL LETTER E WITH CIRCUMFLEX AND HOOK ABOVE
    charset += UIntSetRange(7876, 7876); // LATIN CAPITAL LETTER E WITH CIRCUMFLEX AND TILDE -> LATIN CAPITAL LETTER E WITH CIRCUMFLEX AND TILDE
    charset += UIntSetRange(7878, 7878); // LATIN CAPITAL LETTER E WITH CIRCUMFLEX AND DOT BELOW -> LATIN CAPITAL LETTER E WITH CIRCUMFLEX AND DOT BELOW
    charset += UIntSetRange(7880, 7880); // LATIN CAPITAL LETTER I WITH HOOK ABOVE -> LATIN CAPITAL LETTER I WITH HOOK ABOVE
    charset += UIntSetRange(7882, 7882); // LATIN CAPITAL LETTER I WITH DOT BELOW -> LATIN CAPITAL LETTER I WITH DOT BELOW
    charset += UIntSetRange(7884, 7884); // LATIN CAPITAL LETTER O WITH DOT BELOW -> LATIN CAPITAL LETTER O WITH DOT BELOW
    charset += UIntSetRange(7886, 7886); // LATIN CAPITAL LETTER O WITH HOOK ABOVE -> LATIN CAPITAL LETTER O WITH HOOK ABOVE
    charset += UIntSetRange(7888, 7888); // LATIN CAPITAL LETTER O WITH CIRCUMFLEX AND ACUTE -> LATIN CAPITAL LETTER O WITH CIRCUMFLEX AND ACUTE
    charset += UIntSetRange(7890, 7890); // LATIN CAPITAL LETTER O WITH CIRCUMFLEX AND GRAVE -> LATIN CAPITAL LETTER O WITH CIRCUMFLEX AND GRAVE
    charset += UIntSetRange(7892, 7892); // LATIN CAPITAL LETTER O WITH CIRCUMFLEX AND HOOK ABOVE -> LATIN CAPITAL LETTER O WITH CIRCUMFLEX AND HOOK ABOVE
    charset += UIntSetRange(7894, 7894); // LATIN CAPITAL LETTER O WITH CIRCUMFLEX AND TILDE -> LATIN CAPITAL LETTER O WITH CIRCUMFLEX AND TILDE
    charset += UIntSetRange(7896, 7896); // LATIN CAPITAL LETTER O WITH CIRCUMFLEX AND DOT BELOW -> LATIN CAPITAL LETTER O WITH CIRCUMFLEX AND DOT BELOW
    charset += UIntSetRange(7898, 7898); // LATIN CAPITAL LETTER O WITH HORN AND ACUTE -> LATIN CAPITAL LETTER O WITH HORN AND ACUTE
    charset += UIntSetRange(7900, 7900); // LATIN CAPITAL LETTER O WITH HORN AND GRAVE -> LATIN CAPITAL LETTER O WITH HORN AND GRAVE
    charset += UIntSetRange(7902, 7902); // LATIN CAPITAL LETTER O WITH HORN AND HOOK ABOVE -> LATIN CAPITAL LETTER O WITH HORN AND HOOK ABOVE
    charset += UIntSetRange(7904, 7904); // LATIN CAPITAL LETTER O WITH HORN AND TILDE -> LATIN CAPITAL LETTER O WITH HORN AND TILDE
    charset += UIntSetRange(7906, 7906); // LATIN CAPITAL LETTER O WITH HORN AND DOT BELOW -> LATIN CAPITAL LETTER O WITH HORN AND DOT BELOW
    charset += UIntSetRange(7908, 7908); // LATIN CAPITAL LETTER U WITH DOT BELOW -> LATIN CAPITAL LETTER U WITH DOT BELOW
    charset += UIntSetRange(7910, 7910); // LATIN CAPITAL LETTER U WITH HOOK ABOVE -> LATIN CAPITAL LETTER U WITH HOOK ABOVE
    charset += UIntSetRange(7912, 7912); // LATIN CAPITAL LETTER U WITH HORN AND ACUTE -> LATIN CAPITAL LETTER U WITH HORN AND ACUTE
    charset += UIntSetRange(7914, 7914); // LATIN CAPITAL LETTER U WITH HORN AND GRAVE -> LATIN CAPITAL LETTER U WITH HORN AND GRAVE
    charset += UIntSetRange(7916, 7916); // LATIN CAPITAL LETTER U WITH HORN AND HOOK ABOVE -> LATIN CAPITAL LETTER U WITH HORN AND HOOK ABOVE
    charset += UIntSetRange(7918, 7918); // LATIN CAPITAL LETTER U WITH HORN AND TILDE -> LATIN CAPITAL LETTER U WITH HORN AND TILDE
    charset += UIntSetRange(7920, 7920); // LATIN CAPITAL LETTER U WITH HORN AND DOT BELOW -> LATIN CAPITAL LETTER U WITH HORN AND DOT BELOW
    charset += UIntSetRange(7922, 7922); // LATIN CAPITAL LETTER Y WITH GRAVE -> LATIN CAPITAL LETTER Y WITH GRAVE
    charset += UIntSetRange(7924, 7924); // LATIN CAPITAL LETTER Y WITH DOT BELOW -> LATIN CAPITAL LETTER Y WITH DOT BELOW
    charset += UIntSetRange(7926, 7926); // LATIN CAPITAL LETTER Y WITH HOOK ABOVE -> LATIN CAPITAL LETTER Y WITH HOOK ABOVE
    charset += UIntSetRange(7928, 7928); // LATIN CAPITAL LETTER Y WITH TILDE -> LATIN CAPITAL LETTER Y WITH TILDE
    charset += UIntSetRange(7930, 7930); // LATIN CAPITAL LETTER MIDDLE-WELSH LL -> LATIN CAPITAL LETTER MIDDLE-WELSH LL
    charset += UIntSetRange(7932, 7932); // LATIN CAPITAL LETTER MIDDLE-WELSH V -> LATIN CAPITAL LETTER MIDDLE-WELSH V
    charset += UIntSetRange(7934, 7934); // LATIN CAPITAL LETTER Y WITH LOOP -> LATIN CAPITAL LETTER Y WITH LOOP
    charset += UIntSetRange(7944, 7951); // GREEK CAPITAL LETTER ALPHA WITH PSILI -> GREEK CAPITAL LETTER ALPHA WITH DASIA AND PERISPOMENI
    charset += UIntSetRange(7960, 7965); // GREEK CAPITAL LETTER EPSILON WITH PSILI -> GREEK CAPITAL LETTER EPSILON WITH DASIA AND OXIA
    charset += UIntSetRange(7976, 7983); // GREEK CAPITAL LETTER ETA WITH PSILI -> GREEK CAPITAL LETTER ETA WITH DASIA AND PERISPOMENI
    charset += UIntSetRange(7992, 7999); // GREEK CAPITAL LETTER IOTA WITH PSILI -> GREEK CAPITAL LETTER IOTA WITH DASIA AND PERISPOMENI
    charset += UIntSetRange(8008, 8013); // GREEK CAPITAL LETTER OMICRON WITH PSILI -> GREEK CAPITAL LETTER OMICRON WITH DASIA AND OXIA
    charset += UIntSetRange(8025, 8025); // GREEK CAPITAL LETTER UPSILON WITH DASIA -> GREEK CAPITAL LETTER UPSILON WITH DASIA
    charset += UIntSetRange(8027, 8027); // GREEK CAPITAL LETTER UPSILON WITH DASIA AND VARIA -> GREEK CAPITAL LETTER UPSILON WITH DASIA AND VARIA
    charset += UIntSetRange(8029, 8029); // GREEK CAPITAL LETTER UPSILON WITH DASIA AND OXIA -> GREEK CAPITAL LETTER UPSILON WITH DASIA AND OXIA
    charset += UIntSetRange(8031, 8031); // GREEK CAPITAL LETTER UPSILON WITH DASIA AND PERISPOMENI -> GREEK CAPITAL LETTER UPSILON WITH DASIA AND PERISPOMENI
    charset += UIntSetRange(8040, 8047); // GREEK CAPITAL LETTER OMEGA WITH PSILI -> GREEK CAPITAL LETTER OMEGA WITH DASIA AND PERISPOMENI
    charset += UIntSetRange(8120, 8123); // GREEK CAPITAL LETTER ALPHA WITH VRACHY -> GREEK CAPITAL LETTER ALPHA WITH OXIA
    charset += UIntSetRange(8136, 8139); // GREEK CAPITAL LETTER EPSILON WITH VARIA -> GREEK CAPITAL LETTER ETA WITH OXIA
    charset += UIntSetRange(8152, 8155); // GREEK CAPITAL LETTER IOTA WITH VRACHY -> GREEK CAPITAL LETTER IOTA WITH OXIA
    charset += UIntSetRange(8168, 8172); // GREEK CAPITAL LETTER UPSILON WITH VRACHY -> GREEK CAPITAL LETTER RHO WITH DASIA
    charset += UIntSetRange(8184, 8187); // GREEK CAPITAL LETTER OMICRON WITH VARIA -> GREEK CAPITAL LETTER OMEGA WITH OXIA
    charset += UIntSetRange(8450, 8450); // DOUBLE-STRUCK CAPITAL C -> DOUBLE-STRUCK CAPITAL C
    charset += UIntSetRange(8455, 8455); // EULER CONSTANT -> EULER CONSTANT
    charset += UIntSetRange(8459, 8461); // SCRIPT CAPITAL H -> DOUBLE-STRUCK CAPITAL H
    charset += UIntSetRange(8464, 8466); // SCRIPT CAPITAL I -> SCRIPT CAPITAL L
    charset += UIntSetRange(8469, 8469); // DOUBLE-STRUCK CAPITAL N -> DOUBLE-STRUCK CAPITAL N
    charset += UIntSetRange(8473, 8477); // DOUBLE-STRUCK CAPITAL P -> DOUBLE-STRUCK CAPITAL R
    charset += UIntSetRange(8484, 8484); // DOUBLE-STRUCK CAPITAL Z -> DOUBLE-STRUCK CAPITAL Z
    charset += UIntSetRange(8486, 8486); // OHM SIGN -> OHM SIGN
    charset += UIntSetRange(8488, 8488); // BLACK-LETTER CAPITAL Z -> BLACK-LETTER CAPITAL Z
    charset += UIntSetRange(8490, 8493); // KELVIN SIGN -> BLACK-LETTER CAPITAL C
    charset += UIntSetRange(8496, 8499); // SCRIPT CAPITAL E -> SCRIPT CAPITAL M
    charset += UIntSetRange(8510, 8511); // DOUBLE-STRUCK CAPITAL GAMMA -> DOUBLE-STRUCK CAPITAL PI
    charset += UIntSetRange(8517, 8517); // DOUBLE-STRUCK ITALIC CAPITAL D -> DOUBLE-STRUCK ITALIC CAPITAL D
    charset += UIntSetRange(8579, 8579); // ROMAN NUMERAL REVERSED ONE HUNDRED -> ROMAN NUMERAL REVERSED ONE HUNDRED
    charset += UIntSetRange(11264, 11310); // GLAGOLITIC CAPITAL LETTER AZU -> GLAGOLITIC CAPITAL LETTER LATINATE MYSLITE
    charset += UIntSetRange(11360, 11360); // LATIN CAPITAL LETTER L WITH DOUBLE BAR -> LATIN CAPITAL LETTER L WITH DOUBLE BAR
    charset += UIntSetRange(11362, 11364); // LATIN CAPITAL LETTER L WITH MIDDLE TILDE -> LATIN CAPITAL LETTER R WITH TAIL
    charset += UIntSetRange(11367, 11367); // LATIN CAPITAL LETTER H WITH DESCENDER -> LATIN CAPITAL LETTER H WITH DESCENDER
    charset += UIntSetRange(11369, 11369); // LATIN CAPITAL LETTER K WITH DESCENDER -> LATIN CAPITAL LETTER K WITH DESCENDER
    charset += UIntSetRange(11371, 11371); // LATIN CAPITAL LETTER Z WITH DESCENDER -> LATIN CAPITAL LETTER Z WITH DESCENDER
    charset += UIntSetRange(11373, 11375); // LATIN CAPITAL LETTER ALPHA -> LATIN CAPITAL LETTER TURNED A
    charset += UIntSetRange(11378, 11378); // LATIN CAPITAL LETTER W WITH HOOK -> LATIN CAPITAL LETTER W WITH HOOK
    charset += UIntSetRange(11381, 11381); // LATIN CAPITAL LETTER HALF H -> LATIN CAPITAL LETTER HALF H
    charset += UIntSetRange(11392, 11392); // COPTIC CAPITAL LETTER ALFA -> COPTIC CAPITAL LETTER ALFA
    charset += UIntSetRange(11394, 11394); // COPTIC CAPITAL LETTER VIDA -> COPTIC CAPITAL LETTER VIDA
    charset += UIntSetRange(11396, 11396); // COPTIC CAPITAL LETTER GAMMA -> COPTIC CAPITAL LETTER GAMMA
    charset += UIntSetRange(11398, 11398); // COPTIC CAPITAL LETTER DALDA -> COPTIC CAPITAL LETTER DALDA
    charset += UIntSetRange(11400, 11400); // COPTIC CAPITAL LETTER EIE -> COPTIC CAPITAL LETTER EIE
    charset += UIntSetRange(11402, 11402); // COPTIC CAPITAL LETTER SOU -> COPTIC CAPITAL LETTER SOU
    charset += UIntSetRange(11404, 11404); // COPTIC CAPITAL LETTER ZATA -> COPTIC CAPITAL LETTER ZATA
    charset += UIntSetRange(11406, 11406); // COPTIC CAPITAL LETTER HATE -> COPTIC CAPITAL LETTER HATE
    charset += UIntSetRange(11408, 11408); // COPTIC CAPITAL LETTER THETHE -> COPTIC CAPITAL LETTER THETHE
    charset += UIntSetRange(11410, 11410); // COPTIC CAPITAL LETTER IAUDA -> COPTIC CAPITAL LETTER IAUDA
    charset += UIntSetRange(11412, 11412); // COPTIC CAPITAL LETTER KAPA -> COPTIC CAPITAL LETTER KAPA
    charset += UIntSetRange(11414, 11414); // COPTIC CAPITAL LETTER LAULA -> COPTIC CAPITAL LETTER LAULA
    charset += UIntSetRange(11416, 11416); // COPTIC CAPITAL LETTER MI -> COPTIC CAPITAL LETTER MI
    charset += UIntSetRange(11418, 11418); // COPTIC CAPITAL LETTER NI -> COPTIC CAPITAL LETTER NI
    charset += UIntSetRange(11420, 11420); // COPTIC CAPITAL LETTER KSI -> COPTIC CAPITAL LETTER KSI
    charset += UIntSetRange(11422, 11422); // COPTIC CAPITAL LETTER O -> COPTIC CAPITAL LETTER O
    charset += UIntSetRange(11424, 11424); // COPTIC CAPITAL LETTER PI -> COPTIC CAPITAL LETTER PI
    charset += UIntSetRange(11426, 11426); // COPTIC CAPITAL LETTER RO -> COPTIC CAPITAL LETTER RO
    charset += UIntSetRange(11428, 11428); // COPTIC CAPITAL LETTER SIMA -> COPTIC CAPITAL LETTER SIMA
    charset += UIntSetRange(11430, 11430); // COPTIC CAPITAL LETTER TAU -> COPTIC CAPITAL LETTER TAU
    charset += UIntSetRange(11432, 11432); // COPTIC CAPITAL LETTER UA -> COPTIC CAPITAL LETTER UA
    charset += UIntSetRange(11434, 11434); // COPTIC CAPITAL LETTER FI -> COPTIC CAPITAL LETTER FI
    charset += UIntSetRange(11436, 11436); // COPTIC CAPITAL LETTER KHI -> COPTIC CAPITAL LETTER KHI
    charset += UIntSetRange(11438, 11438); // COPTIC CAPITAL LETTER PSI -> COPTIC CAPITAL LETTER PSI
    charset += UIntSetRange(11440, 11440); // COPTIC CAPITAL LETTER OOU -> COPTIC CAPITAL LETTER OOU
    charset += UIntSetRange(11442, 11442); // COPTIC CAPITAL LETTER DIALECT-P ALEF -> COPTIC CAPITAL LETTER DIALECT-P ALEF
    charset += UIntSetRange(11444, 11444); // COPTIC CAPITAL LETTER OLD COPTIC AIN -> COPTIC CAPITAL LETTER OLD COPTIC AIN
    charset += UIntSetRange(11446, 11446); // COPTIC CAPITAL LETTER CRYPTOGRAMMIC EIE -> COPTIC CAPITAL LETTER CRYPTOGRAMMIC EIE
    charset += UIntSetRange(11448, 11448); // COPTIC CAPITAL LETTER DIALECT-P KAPA -> COPTIC CAPITAL LETTER DIALECT-P KAPA
    charset += UIntSetRange(11450, 11450); // COPTIC CAPITAL LETTER DIALECT-P NI -> COPTIC CAPITAL LETTER DIALECT-P NI
    charset += UIntSetRange(11452, 11452); // COPTIC CAPITAL LETTER CRYPTOGRAMMIC NI -> COPTIC CAPITAL LETTER CRYPTOGRAMMIC NI
    charset += UIntSetRange(11454, 11454); // COPTIC CAPITAL LETTER OLD COPTIC OOU -> COPTIC CAPITAL LETTER OLD COPTIC OOU
    charset += UIntSetRange(11456, 11456); // COPTIC CAPITAL LETTER SAMPI -> COPTIC CAPITAL LETTER SAMPI
    charset += UIntSetRange(11458, 11458); // COPTIC CAPITAL LETTER CROSSED SHEI -> COPTIC CAPITAL LETTER CROSSED SHEI
    charset += UIntSetRange(11460, 11460); // COPTIC CAPITAL LETTER OLD COPTIC SHEI -> COPTIC CAPITAL LETTER OLD COPTIC SHEI
    charset += UIntSetRange(11462, 11462); // COPTIC CAPITAL LETTER OLD COPTIC ESH -> COPTIC CAPITAL LETTER OLD COPTIC ESH
    charset += UIntSetRange(11464, 11464); // COPTIC CAPITAL LETTER AKHMIMIC KHEI -> COPTIC CAPITAL LETTER AKHMIMIC KHEI
    charset += UIntSetRange(11466, 11466); // COPTIC CAPITAL LETTER DIALECT-P HORI -> COPTIC CAPITAL LETTER DIALECT-P HORI
    charset += UIntSetRange(11468, 11468); // COPTIC CAPITAL LETTER OLD COPTIC HORI -> COPTIC CAPITAL LETTER OLD COPTIC HORI
    charset += UIntSetRange(11470, 11470); // COPTIC CAPITAL LETTER OLD COPTIC HA -> COPTIC CAPITAL LETTER OLD COPTIC HA
    charset += UIntSetRange(11472, 11472); // COPTIC CAPITAL LETTER L-SHAPED HA -> COPTIC CAPITAL LETTER L-SHAPED HA
    charset += UIntSetRange(11474, 11474); // COPTIC CAPITAL LETTER OLD COPTIC HEI -> COPTIC CAPITAL LETTER OLD COPTIC HEI
    charset += UIntSetRange(11476, 11476); // COPTIC CAPITAL LETTER OLD COPTIC HAT -> COPTIC CAPITAL LETTER OLD COPTIC HAT
    charset += UIntSetRange(11478, 11478); // COPTIC CAPITAL LETTER OLD COPTIC GANGIA -> COPTIC CAPITAL LETTER OLD COPTIC GANGIA
    charset += UIntSetRange(11480, 11480); // COPTIC CAPITAL LETTER OLD COPTIC DJA -> COPTIC CAPITAL LETTER OLD COPTIC DJA
    charset += UIntSetRange(11482, 11482); // COPTIC CAPITAL LETTER OLD COPTIC SHIMA -> COPTIC CAPITAL LETTER OLD COPTIC SHIMA
    charset += UIntSetRange(11484, 11484); // COPTIC CAPITAL LETTER OLD NUBIAN SHIMA -> COPTIC CAPITAL LETTER OLD NUBIAN SHIMA
    charset += UIntSetRange(11486, 11486); // COPTIC CAPITAL LETTER OLD NUBIAN NGI -> COPTIC CAPITAL LETTER OLD NUBIAN NGI
    charset += UIntSetRange(11488, 11488); // COPTIC CAPITAL LETTER OLD NUBIAN NYI -> COPTIC CAPITAL LETTER OLD NUBIAN NYI
    charset += UIntSetRange(11490, 11490); // COPTIC CAPITAL LETTER OLD NUBIAN WAU -> COPTIC CAPITAL LETTER OLD NUBIAN WAU
    charset += UIntSetRange(42560, 42560); // CYRILLIC CAPITAL LETTER ZEMLYA -> CYRILLIC CAPITAL LETTER ZEMLYA
    charset += UIntSetRange(42562, 42562); // CYRILLIC CAPITAL LETTER DZELO -> CYRILLIC CAPITAL LETTER DZELO
    charset += UIntSetRange(42564, 42564); // CYRILLIC CAPITAL LETTER REVERSED DZE -> CYRILLIC CAPITAL LETTER REVERSED DZE
    charset += UIntSetRange(42566, 42566); // CYRILLIC CAPITAL LETTER IOTA -> CYRILLIC CAPITAL LETTER IOTA
    charset += UIntSetRange(42568, 42568); // CYRILLIC CAPITAL LETTER DJERV -> CYRILLIC CAPITAL LETTER DJERV
    charset += UIntSetRange(42570, 42570); // CYRILLIC CAPITAL LETTER MONOGRAPH UK -> CYRILLIC CAPITAL LETTER MONOGRAPH UK
    charset += UIntSetRange(42572, 42572); // CYRILLIC CAPITAL LETTER BROAD OMEGA -> CYRILLIC CAPITAL LETTER BROAD OMEGA
    charset += UIntSetRange(42574, 42574); // CYRILLIC CAPITAL LETTER NEUTRAL YER -> CYRILLIC CAPITAL LETTER NEUTRAL YER
    charset += UIntSetRange(42576, 42576); // CYRILLIC CAPITAL LETTER YERU WITH BACK YER -> CYRILLIC CAPITAL LETTER YERU WITH BACK YER
    charset += UIntSetRange(42578, 42578); // CYRILLIC CAPITAL LETTER IOTIFIED YAT -> CYRILLIC CAPITAL LETTER IOTIFIED YAT
    charset += UIntSetRange(42580, 42580); // CYRILLIC CAPITAL LETTER REVERSED YU -> CYRILLIC CAPITAL LETTER REVERSED YU
    charset += UIntSetRange(42582, 42582); // CYRILLIC CAPITAL LETTER IOTIFIED A -> CYRILLIC CAPITAL LETTER IOTIFIED A
    charset += UIntSetRange(42584, 42584); // CYRILLIC CAPITAL LETTER CLOSED LITTLE YUS -> CYRILLIC CAPITAL LETTER CLOSED LITTLE YUS
    charset += UIntSetRange(42586, 42586); // CYRILLIC CAPITAL LETTER BLENDED YUS -> CYRILLIC CAPITAL LETTER BLENDED YUS
    charset += UIntSetRange(42588, 42588); // CYRILLIC CAPITAL LETTER IOTIFIED CLOSED LITTLE YUS -> CYRILLIC CAPITAL LETTER IOTIFIED CLOSED LITTLE YUS
    charset += UIntSetRange(42590, 42590); // CYRILLIC CAPITAL LETTER YN -> CYRILLIC CAPITAL LETTER YN
    charset += UIntSetRange(42594, 42594); // CYRILLIC CAPITAL LETTER SOFT DE -> CYRILLIC CAPITAL LETTER SOFT DE
    charset += UIntSetRange(42596, 42596); // CYRILLIC CAPITAL LETTER SOFT EL -> CYRILLIC CAPITAL LETTER SOFT EL
    charset += UIntSetRange(42598, 42598); // CYRILLIC CAPITAL LETTER SOFT EM -> CYRILLIC CAPITAL LETTER SOFT EM
    charset += UIntSetRange(42600, 42600); // CYRILLIC CAPITAL LETTER MONOCULAR O -> CYRILLIC CAPITAL LETTER MONOCULAR O
    charset += UIntSetRange(42602, 42602); // CYRILLIC CAPITAL LETTER BINOCULAR O -> CYRILLIC CAPITAL LETTER BINOCULAR O
    charset += UIntSetRange(42604, 42604); // CYRILLIC CAPITAL LETTER DOUBLE MONOCULAR O -> CYRILLIC CAPITAL LETTER DOUBLE MONOCULAR O
    charset += UIntSetRange(42624, 42624); // CYRILLIC CAPITAL LETTER DWE -> CYRILLIC CAPITAL LETTER DWE
    charset += UIntSetRange(42626, 42626); // CYRILLIC CAPITAL LETTER DZWE -> CYRILLIC CAPITAL LETTER DZWE
    charset += UIntSetRange(42628, 42628); // CYRILLIC CAPITAL LETTER ZHWE -> CYRILLIC CAPITAL LETTER ZHWE
    charset += UIntSetRange(42630, 42630); // CYRILLIC CAPITAL LETTER CCHE -> CYRILLIC CAPITAL LETTER CCHE
    charset += UIntSetRange(42632, 42632); // CYRILLIC CAPITAL LETTER DZZE -> CYRILLIC CAPITAL LETTER DZZE
    charset += UIntSetRange(42634, 42634); // CYRILLIC CAPITAL LETTER TE WITH MIDDLE HOOK -> CYRILLIC CAPITAL LETTER TE WITH MIDDLE HOOK
    charset += UIntSetRange(42636, 42636); // CYRILLIC CAPITAL LETTER TWE -> CYRILLIC CAPITAL LETTER TWE
    charset += UIntSetRange(42638, 42638); // CYRILLIC CAPITAL LETTER TSWE -> CYRILLIC CAPITAL LETTER TSWE
    charset += UIntSetRange(42640, 42640); // CYRILLIC CAPITAL LETTER TSSE -> CYRILLIC CAPITAL LETTER TSSE
    charset += UIntSetRange(42642, 42642); // CYRILLIC CAPITAL LETTER TCHE -> CYRILLIC CAPITAL LETTER TCHE
    charset += UIntSetRange(42644, 42644); // CYRILLIC CAPITAL LETTER HWE -> CYRILLIC CAPITAL LETTER HWE
    charset += UIntSetRange(42646, 42646); // CYRILLIC CAPITAL LETTER SHWE -> CYRILLIC CAPITAL LETTER SHWE
    charset += UIntSetRange(42786, 42786); // LATIN CAPITAL LETTER EGYPTOLOGICAL ALEF -> LATIN CAPITAL LETTER EGYPTOLOGICAL ALEF
    charset += UIntSetRange(42788, 42788); // LATIN CAPITAL LETTER EGYPTOLOGICAL AIN -> LATIN CAPITAL LETTER EGYPTOLOGICAL AIN
    charset += UIntSetRange(42790, 42790); // LATIN CAPITAL LETTER HENG -> LATIN CAPITAL LETTER HENG
    charset += UIntSetRange(42792, 42792); // LATIN CAPITAL LETTER TZ -> LATIN CAPITAL LETTER TZ
    charset += UIntSetRange(42794, 42794); // LATIN CAPITAL LETTER TRESILLO -> LATIN CAPITAL LETTER TRESILLO
    charset += UIntSetRange(42796, 42796); // LATIN CAPITAL LETTER CUATRILLO -> LATIN CAPITAL LETTER CUATRILLO
    charset += UIntSetRange(42798, 42798); // LATIN CAPITAL LETTER CUATRILLO WITH COMMA -> LATIN CAPITAL LETTER CUATRILLO WITH COMMA
    charset += UIntSetRange(42802, 42802); // LATIN CAPITAL LETTER AA -> LATIN CAPITAL LETTER AA
    charset += UIntSetRange(42804, 42804); // LATIN CAPITAL LETTER AO -> LATIN CAPITAL LETTER AO
    charset += UIntSetRange(42806, 42806); // LATIN CAPITAL LETTER AU -> LATIN CAPITAL LETTER AU
    charset += UIntSetRange(42808, 42808); // LATIN CAPITAL LETTER AV -> LATIN CAPITAL LETTER AV
    charset += UIntSetRange(42810, 42810); // LATIN CAPITAL LETTER AV WITH HORIZONTAL BAR -> LATIN CAPITAL LETTER AV WITH HORIZONTAL BAR
    charset += UIntSetRange(42812, 42812); // LATIN CAPITAL LETTER AY -> LATIN CAPITAL LETTER AY
    charset += UIntSetRange(42814, 42814); // LATIN CAPITAL LETTER REVERSED C WITH DOT -> LATIN CAPITAL LETTER REVERSED C WITH DOT
    charset += UIntSetRange(42816, 42816); // LATIN CAPITAL LETTER K WITH STROKE -> LATIN CAPITAL LETTER K WITH STROKE
    charset += UIntSetRange(42818, 42818); // LATIN CAPITAL LETTER K WITH DIAGONAL STROKE -> LATIN CAPITAL LETTER K WITH DIAGONAL STROKE
    charset += UIntSetRange(42820, 42820); // LATIN CAPITAL LETTER K WITH STROKE AND DIAGONAL STROKE -> LATIN CAPITAL LETTER K WITH STROKE AND DIAGONAL STROKE
    charset += UIntSetRange(42822, 42822); // LATIN CAPITAL LETTER BROKEN L -> LATIN CAPITAL LETTER BROKEN L
    charset += UIntSetRange(42824, 42824); // LATIN CAPITAL LETTER L WITH HIGH STROKE -> LATIN CAPITAL LETTER L WITH HIGH STROKE
    charset += UIntSetRange(42826, 42826); // LATIN CAPITAL LETTER O WITH LONG STROKE OVERLAY -> LATIN CAPITAL LETTER O WITH LONG STROKE OVERLAY
    charset += UIntSetRange(42828, 42828); // LATIN CAPITAL LETTER O WITH LOOP -> LATIN CAPITAL LETTER O WITH LOOP
    charset += UIntSetRange(42830, 42830); // LATIN CAPITAL LETTER OO -> LATIN CAPITAL LETTER OO
    charset += UIntSetRange(42832, 42832); // LATIN CAPITAL LETTER P WITH STROKE THROUGH DESCENDER -> LATIN CAPITAL LETTER P WITH STROKE THROUGH DESCENDER
    charset += UIntSetRange(42834, 42834); // LATIN CAPITAL LETTER P WITH FLOURISH -> LATIN CAPITAL LETTER P WITH FLOURISH
    charset += UIntSetRange(42836, 42836); // LATIN CAPITAL LETTER P WITH SQUIRREL TAIL -> LATIN CAPITAL LETTER P WITH SQUIRREL TAIL
    charset += UIntSetRange(42838, 42838); // LATIN CAPITAL LETTER Q WITH STROKE THROUGH DESCENDER -> LATIN CAPITAL LETTER Q WITH STROKE THROUGH DESCENDER
    charset += UIntSetRange(42840, 42840); // LATIN CAPITAL LETTER Q WITH DIAGONAL STROKE -> LATIN CAPITAL LETTER Q WITH DIAGONAL STROKE
    charset += UIntSetRange(42842, 42842); // LATIN CAPITAL LETTER R ROTUNDA -> LATIN CAPITAL LETTER R ROTUNDA
    charset += UIntSetRange(42844, 42844); // LATIN CAPITAL LETTER RUM ROTUNDA -> LATIN CAPITAL LETTER RUM ROTUNDA
    charset += UIntSetRange(42846, 42846); // LATIN CAPITAL LETTER V WITH DIAGONAL STROKE -> LATIN CAPITAL LETTER V WITH DIAGONAL STROKE
    charset += UIntSetRange(42848, 42848); // LATIN CAPITAL LETTER VY -> LATIN CAPITAL LETTER VY
    charset += UIntSetRange(42850, 42850); // LATIN CAPITAL LETTER VISIGOTHIC Z -> LATIN CAPITAL LETTER VISIGOTHIC Z
    charset += UIntSetRange(42852, 42852); // LATIN CAPITAL LETTER THORN WITH STROKE -> LATIN CAPITAL LETTER THORN WITH STROKE
    charset += UIntSetRange(42854, 42854); // LATIN CAPITAL LETTER THORN WITH STROKE THROUGH DESCENDER -> LATIN CAPITAL LETTER THORN WITH STROKE THROUGH DESCENDER
    charset += UIntSetRange(42856, 42856); // LATIN CAPITAL LETTER VEND -> LATIN CAPITAL LETTER VEND
    charset += UIntSetRange(42858, 42858); // LATIN CAPITAL LETTER ET -> LATIN CAPITAL LETTER ET
    charset += UIntSetRange(42860, 42860); // LATIN CAPITAL LETTER IS -> LATIN CAPITAL LETTER IS
    charset += UIntSetRange(42862, 42862); // LATIN CAPITAL LETTER CON -> LATIN CAPITAL LETTER CON
    charset += UIntSetRange(42873, 42873); // LATIN CAPITAL LETTER INSULAR D -> LATIN CAPITAL LETTER INSULAR D
    charset += UIntSetRange(42875, 42875); // LATIN CAPITAL LETTER INSULAR F -> LATIN CAPITAL LETTER INSULAR F
    charset += UIntSetRange(42877, 42878); // LATIN CAPITAL LETTER INSULAR G -> LATIN CAPITAL LETTER TURNED INSULAR G
    charset += UIntSetRange(42880, 42880); // LATIN CAPITAL LETTER TURNED L -> LATIN CAPITAL LETTER TURNED L
    charset += UIntSetRange(42882, 42882); // LATIN CAPITAL LETTER INSULAR R -> LATIN CAPITAL LETTER INSULAR R
    charset += UIntSetRange(42884, 42884); // LATIN CAPITAL LETTER INSULAR S -> LATIN CAPITAL LETTER INSULAR S
    charset += UIntSetRange(42886, 42886); // LATIN CAPITAL LETTER INSULAR T -> LATIN CAPITAL LETTER INSULAR T
    charset += UIntSetRange(42891, 42891); // LATIN CAPITAL LETTER SALTILLO -> LATIN CAPITAL LETTER SALTILLO
    charset += UIntSetRange(65313, 65338); // FULLWIDTH LATIN CAPITAL LETTER A -> FULLWIDTH LATIN CAPITAL LETTER Z
    charset += UIntSetRange(66560, 66599); // DESERET CAPITAL LETTER LONG I -> DESERET CAPITAL LETTER EW
    charset += UIntSetRange(119808, 119833); // MATHEMATICAL BOLD CAPITAL A -> MATHEMATICAL BOLD CAPITAL Z
    charset += UIntSetRange(119860, 119885); // MATHEMATICAL ITALIC CAPITAL A -> MATHEMATICAL ITALIC CAPITAL Z
    charset += UIntSetRange(119912, 119937); // MATHEMATICAL BOLD ITALIC CAPITAL A -> MATHEMATICAL BOLD ITALIC CAPITAL Z
    charset += UIntSetRange(119964, 119964); // MATHEMATICAL SCRIPT CAPITAL A -> MATHEMATICAL SCRIPT CAPITAL A
    charset += UIntSetRange(119966, 119967); // MATHEMATICAL SCRIPT CAPITAL C -> MATHEMATICAL SCRIPT CAPITAL D
    charset += UIntSetRange(119970, 119970); // MATHEMATICAL SCRIPT CAPITAL G -> MATHEMATICAL SCRIPT CAPITAL G
    charset += UIntSetRange(119973, 119974); // MATHEMATICAL SCRIPT CAPITAL J -> MATHEMATICAL SCRIPT CAPITAL K
    charset += UIntSetRange(119977, 119980); // MATHEMATICAL SCRIPT CAPITAL N -> MATHEMATICAL SCRIPT CAPITAL Q
    charset += UIntSetRange(119982, 119989); // MATHEMATICAL SCRIPT CAPITAL S -> MATHEMATICAL SCRIPT CAPITAL Z
    charset += UIntSetRange(120016, 120041); // MATHEMATICAL BOLD SCRIPT CAPITAL A -> MATHEMATICAL BOLD SCRIPT CAPITAL Z
    charset += UIntSetRange(120068, 120069); // MATHEMATICAL FRAKTUR CAPITAL A -> MATHEMATICAL FRAKTUR CAPITAL B
    charset += UIntSetRange(120071, 120074); // MATHEMATICAL FRAKTUR CAPITAL D -> MATHEMATICAL FRAKTUR CAPITAL G
    charset += UIntSetRange(120077, 120084); // MATHEMATICAL FRAKTUR CAPITAL J -> MATHEMATICAL FRAKTUR CAPITAL Q
    charset += UIntSetRange(120086, 120092); // MATHEMATICAL FRAKTUR CAPITAL S -> MATHEMATICAL FRAKTUR CAPITAL Y
    charset += UIntSetRange(120120, 120121); // MATHEMATICAL DOUBLE-STRUCK CAPITAL A -> MATHEMATICAL DOUBLE-STRUCK CAPITAL B
    charset += UIntSetRange(120123, 120126); // MATHEMATICAL DOUBLE-STRUCK CAPITAL D -> MATHEMATICAL DOUBLE-STRUCK CAPITAL G
    charset += UIntSetRange(120128, 120132); // MATHEMATICAL DOUBLE-STRUCK CAPITAL I -> MATHEMATICAL DOUBLE-STRUCK CAPITAL M
    charset += UIntSetRange(120134, 120134); // MATHEMATICAL DOUBLE-STRUCK CAPITAL O -> MATHEMATICAL DOUBLE-STRUCK CAPITAL O
    charset += UIntSetRange(120138, 120144); // MATHEMATICAL DOUBLE-STRUCK CAPITAL S -> MATHEMATICAL DOUBLE-STRUCK CAPITAL Y
    charset += UIntSetRange(120172, 120197); // MATHEMATICAL BOLD FRAKTUR CAPITAL A -> MATHEMATICAL BOLD FRAKTUR CAPITAL Z
    charset += UIntSetRange(120224, 120249); // MATHEMATICAL SANS-SERIF CAPITAL A -> MATHEMATICAL SANS-SERIF CAPITAL Z
    charset += UIntSetRange(120276, 120301); // MATHEMATICAL SANS-SERIF BOLD CAPITAL A -> MATHEMATICAL SANS-SERIF BOLD CAPITAL Z
    charset += UIntSetRange(120328, 120353); // MATHEMATICAL SANS-SERIF ITALIC CAPITAL A -> MATHEMATICAL SANS-SERIF ITALIC CAPITAL Z
    charset += UIntSetRange(120380, 120405); // MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL A -> MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL Z
    charset += UIntSetRange(120432, 120457); // MATHEMATICAL MONOSPACE CAPITAL A -> MATHEMATICAL MONOSPACE CAPITAL Z
    charset += UIntSetRange(120488, 120512); // MATHEMATICAL BOLD CAPITAL ALPHA -> MATHEMATICAL BOLD CAPITAL OMEGA
    charset += UIntSetRange(120546, 120570); // MATHEMATICAL ITALIC CAPITAL ALPHA -> MATHEMATICAL ITALIC CAPITAL OMEGA
    charset += UIntSetRange(120604, 120628); // MATHEMATICAL BOLD ITALIC CAPITAL ALPHA -> MATHEMATICAL BOLD ITALIC CAPITAL OMEGA
    charset += UIntSetRange(120662, 120686); // MATHEMATICAL SANS-SERIF BOLD CAPITAL ALPHA -> MATHEMATICAL SANS-SERIF BOLD CAPITAL OMEGA
    charset += UIntSetRange(120720, 120744); // MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL ALPHA -> MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL OMEGA
    charset += UIntSetRange(120778, 120778); // MATHEMATICAL BOLD CAPITAL DIGAMMA -> MATHEMATICAL BOLD CAPITAL DIGAMMA
    return charset;
}


const UIntSet &named_charset_alnum()
{
    static UIntSet charset;
    if( charset.count() )
        return charset;
    charset += UIntSetRange(48, 57); // DIGIT ZERO -> DIGIT NINE
    charset += UIntSetRange(65, 90); // LATIN CAPITAL LETTER A -> LATIN CAPITAL LETTER Z
    charset += UIntSetRange(97, 122); // LATIN SMALL LETTER A -> LATIN SMALL LETTER Z
    charset += UIntSetRange(170, 170); // FEMININE ORDINAL INDICATOR -> FEMININE ORDINAL INDICATOR
    charset += UIntSetRange(181, 181); // MICRO SIGN -> MICRO SIGN
    charset += UIntSetRange(186, 186); // MASCULINE ORDINAL INDICATOR -> MASCULINE ORDINAL INDICATOR
    charset += UIntSetRange(192, 214); // LATIN CAPITAL LETTER A WITH GRAVE -> LATIN CAPITAL LETTER O WITH DIAERESIS
    charset += UIntSetRange(216, 246); // LATIN CAPITAL LETTER O WITH STROKE -> LATIN SMALL LETTER O WITH DIAERESIS
    charset += UIntSetRange(248, 705); // LATIN SMALL LETTER O WITH STROKE -> MODIFIER LETTER REVERSED GLOTTAL STOP
    charset += UIntSetRange(710, 721); // MODIFIER LETTER CIRCUMFLEX ACCENT -> MODIFIER LETTER HALF TRIANGULAR COLON
    charset += UIntSetRange(736, 740); // MODIFIER LETTER SMALL GAMMA -> MODIFIER LETTER SMALL REVERSED GLOTTAL STOP
    charset += UIntSetRange(748, 748); // MODIFIER LETTER VOICING -> MODIFIER LETTER VOICING
    charset += UIntSetRange(750, 750); // MODIFIER LETTER DOUBLE APOSTROPHE -> MODIFIER LETTER DOUBLE APOSTROPHE
    charset += UIntSetRange(880, 884); // GREEK CAPITAL LETTER HETA -> GREEK NUMERAL SIGN
    charset += UIntSetRange(886, 887); // GREEK CAPITAL LETTER PAMPHYLIAN DIGAMMA -> GREEK SMALL LETTER PAMPHYLIAN DIGAMMA
    charset += UIntSetRange(890, 893); // GREEK YPOGEGRAMMENI -> GREEK SMALL REVERSED DOTTED LUNATE SIGMA SYMBOL
    charset += UIntSetRange(902, 902); // GREEK CAPITAL LETTER ALPHA WITH TONOS -> GREEK CAPITAL LETTER ALPHA WITH TONOS
    charset += UIntSetRange(904, 906); // GREEK CAPITAL LETTER EPSILON WITH TONOS -> GREEK CAPITAL LETTER IOTA WITH TONOS
    charset += UIntSetRange(908, 908); // GREEK CAPITAL LETTER OMICRON WITH TONOS -> GREEK CAPITAL LETTER OMICRON WITH TONOS
    charset += UIntSetRange(910, 929); // GREEK CAPITAL LETTER UPSILON WITH TONOS -> GREEK CAPITAL LETTER RHO
    charset += UIntSetRange(931, 1013); // GREEK CAPITAL LETTER SIGMA -> GREEK LUNATE EPSILON SYMBOL
    charset += UIntSetRange(1015, 1153); // GREEK CAPITAL LETTER SHO -> CYRILLIC SMALL LETTER KOPPA
    charset += UIntSetRange(1162, 1315); // CYRILLIC CAPITAL LETTER SHORT I WITH TAIL -> CYRILLIC SMALL LETTER EN WITH MIDDLE HOOK
    charset += UIntSetRange(1329, 1366); // ARMENIAN CAPITAL LETTER AYB -> ARMENIAN CAPITAL LETTER FEH
    charset += UIntSetRange(1369, 1369); // ARMENIAN MODIFIER LETTER LEFT HALF RING -> ARMENIAN MODIFIER LETTER LEFT HALF RING
    charset += UIntSetRange(1377, 1415); // ARMENIAN SMALL LETTER AYB -> ARMENIAN SMALL LIGATURE ECH YIWN
    charset += UIntSetRange(1488, 1514); // HEBREW LETTER ALEF -> HEBREW LETTER TAV
    charset += UIntSetRange(1520, 1522); // HEBREW LIGATURE YIDDISH DOUBLE VAV -> HEBREW LIGATURE YIDDISH DOUBLE YOD
    charset += UIntSetRange(1569, 1610); // ARABIC LETTER HAMZA -> ARABIC LETTER YEH
    charset += UIntSetRange(1632, 1641); // ARABIC-INDIC DIGIT ZERO -> ARABIC-INDIC DIGIT NINE
    charset += UIntSetRange(1646, 1647); // ARABIC LETTER DOTLESS BEH -> ARABIC LETTER DOTLESS QAF
    charset += UIntSetRange(1649, 1747); // ARABIC LETTER ALEF WASLA -> ARABIC LETTER YEH BARREE WITH HAMZA ABOVE
    charset += UIntSetRange(1749, 1749); // ARABIC LETTER AE -> ARABIC LETTER AE
    charset += UIntSetRange(1765, 1766); // ARABIC SMALL WAW -> ARABIC SMALL YEH
    charset += UIntSetRange(1774, 1788); // ARABIC LETTER DAL WITH INVERTED V -> ARABIC LETTER GHAIN WITH DOT BELOW
    charset += UIntSetRange(1791, 1791); // ARABIC LETTER HEH WITH INVERTED V -> ARABIC LETTER HEH WITH INVERTED V
    charset += UIntSetRange(1808, 1808); // SYRIAC LETTER ALAPH -> SYRIAC LETTER ALAPH
    charset += UIntSetRange(1810, 1839); // SYRIAC LETTER BETH -> SYRIAC LETTER PERSIAN DHALATH
    charset += UIntSetRange(1869, 1957); // SYRIAC LETTER SOGDIAN ZHAIN -> THAANA LETTER WAAVU
    charset += UIntSetRange(1969, 1969); // THAANA LETTER NAA -> THAANA LETTER NAA
    charset += UIntSetRange(1984, 2026); // NKO DIGIT ZERO -> NKO LETTER JONA RA
    charset += UIntSetRange(2036, 2037); // NKO HIGH TONE APOSTROPHE -> NKO LOW TONE APOSTROPHE
    charset += UIntSetRange(2042, 2042); // NKO LAJANYALAN -> NKO LAJANYALAN
    charset += UIntSetRange(2308, 2361); // DEVANAGARI LETTER SHORT A -> DEVANAGARI LETTER HA
    charset += UIntSetRange(2365, 2365); // DEVANAGARI SIGN AVAGRAHA -> DEVANAGARI SIGN AVAGRAHA
    charset += UIntSetRange(2384, 2384); // DEVANAGARI OM -> DEVANAGARI OM
    charset += UIntSetRange(2392, 2401); // DEVANAGARI LETTER QA -> DEVANAGARI LETTER VOCALIC LL
    charset += UIntSetRange(2406, 2415); // DEVANAGARI DIGIT ZERO -> DEVANAGARI DIGIT NINE
    charset += UIntSetRange(2417, 2418); // DEVANAGARI SIGN HIGH SPACING DOT -> DEVANAGARI LETTER CANDRA A
    charset += UIntSetRange(2427, 2431); // DEVANAGARI LETTER GGA -> DEVANAGARI LETTER BBA
    charset += UIntSetRange(2437, 2444); // BENGALI LETTER A -> BENGALI LETTER VOCALIC L
    charset += UIntSetRange(2447, 2448); // BENGALI LETTER E -> BENGALI LETTER AI
    charset += UIntSetRange(2451, 2472); // BENGALI LETTER O -> BENGALI LETTER NA
    charset += UIntSetRange(2474, 2480); // BENGALI LETTER PA -> BENGALI LETTER RA
    charset += UIntSetRange(2482, 2482); // BENGALI LETTER LA -> BENGALI LETTER LA
    charset += UIntSetRange(2486, 2489); // BENGALI LETTER SHA -> BENGALI LETTER HA
    charset += UIntSetRange(2493, 2493); // BENGALI SIGN AVAGRAHA -> BENGALI SIGN AVAGRAHA
    charset += UIntSetRange(2510, 2510); // BENGALI LETTER KHANDA TA -> BENGALI LETTER KHANDA TA
    charset += UIntSetRange(2524, 2525); // BENGALI LETTER RRA -> BENGALI LETTER RHA
    charset += UIntSetRange(2527, 2529); // BENGALI LETTER YYA -> BENGALI LETTER VOCALIC LL
    charset += UIntSetRange(2534, 2545); // BENGALI DIGIT ZERO -> BENGALI LETTER RA WITH LOWER DIAGONAL
    charset += UIntSetRange(2565, 2570); // GURMUKHI LETTER A -> GURMUKHI LETTER UU
    charset += UIntSetRange(2575, 2576); // GURMUKHI LETTER EE -> GURMUKHI LETTER AI
    charset += UIntSetRange(2579, 2600); // GURMUKHI LETTER OO -> GURMUKHI LETTER NA
    charset += UIntSetRange(2602, 2608); // GURMUKHI LETTER PA -> GURMUKHI LETTER RA
    charset += UIntSetRange(2610, 2611); // GURMUKHI LETTER LA -> GURMUKHI LETTER LLA
    charset += UIntSetRange(2613, 2614); // GURMUKHI LETTER VA -> GURMUKHI LETTER SHA
    charset += UIntSetRange(2616, 2617); // GURMUKHI LETTER SA -> GURMUKHI LETTER HA
    charset += UIntSetRange(2649, 2652); // GURMUKHI LETTER KHHA -> GURMUKHI LETTER RRA
    charset += UIntSetRange(2654, 2654); // GURMUKHI LETTER FA -> GURMUKHI LETTER FA
    charset += UIntSetRange(2662, 2671); // GURMUKHI DIGIT ZERO -> GURMUKHI DIGIT NINE
    charset += UIntSetRange(2674, 2676); // GURMUKHI IRI -> GURMUKHI EK ONKAR
    charset += UIntSetRange(2693, 2701); // GUJARATI LETTER A -> GUJARATI VOWEL CANDRA E
    charset += UIntSetRange(2703, 2705); // GUJARATI LETTER E -> GUJARATI VOWEL CANDRA O
    charset += UIntSetRange(2707, 2728); // GUJARATI LETTER O -> GUJARATI LETTER NA
    charset += UIntSetRange(2730, 2736); // GUJARATI LETTER PA -> GUJARATI LETTER RA
    charset += UIntSetRange(2738, 2739); // GUJARATI LETTER LA -> GUJARATI LETTER LLA
    charset += UIntSetRange(2741, 2745); // GUJARATI LETTER VA -> GUJARATI LETTER HA
    charset += UIntSetRange(2749, 2749); // GUJARATI SIGN AVAGRAHA -> GUJARATI SIGN AVAGRAHA
    charset += UIntSetRange(2768, 2768); // GUJARATI OM -> GUJARATI OM
    charset += UIntSetRange(2784, 2785); // GUJARATI LETTER VOCALIC RR -> GUJARATI LETTER VOCALIC LL
    charset += UIntSetRange(2790, 2799); // GUJARATI DIGIT ZERO -> GUJARATI DIGIT NINE
    charset += UIntSetRange(2821, 2828); // ORIYA LETTER A -> ORIYA LETTER VOCALIC L
    charset += UIntSetRange(2831, 2832); // ORIYA LETTER E -> ORIYA LETTER AI
    charset += UIntSetRange(2835, 2856); // ORIYA LETTER O -> ORIYA LETTER NA
    charset += UIntSetRange(2858, 2864); // ORIYA LETTER PA -> ORIYA LETTER RA
    charset += UIntSetRange(2866, 2867); // ORIYA LETTER LA -> ORIYA LETTER LLA
    charset += UIntSetRange(2869, 2873); // ORIYA LETTER VA -> ORIYA LETTER HA
    charset += UIntSetRange(2877, 2877); // ORIYA SIGN AVAGRAHA -> ORIYA SIGN AVAGRAHA
    charset += UIntSetRange(2908, 2909); // ORIYA LETTER RRA -> ORIYA LETTER RHA
    charset += UIntSetRange(2911, 2913); // ORIYA LETTER YYA -> ORIYA LETTER VOCALIC LL
    charset += UIntSetRange(2918, 2927); // ORIYA DIGIT ZERO -> ORIYA DIGIT NINE
    charset += UIntSetRange(2929, 2929); // ORIYA LETTER WA -> ORIYA LETTER WA
    charset += UIntSetRange(2947, 2947); // TAMIL SIGN VISARGA -> TAMIL SIGN VISARGA
    charset += UIntSetRange(2949, 2954); // TAMIL LETTER A -> TAMIL LETTER UU
    charset += UIntSetRange(2958, 2960); // TAMIL LETTER E -> TAMIL LETTER AI
    charset += UIntSetRange(2962, 2965); // TAMIL LETTER O -> TAMIL LETTER KA
    charset += UIntSetRange(2969, 2970); // TAMIL LETTER NGA -> TAMIL LETTER CA
    charset += UIntSetRange(2972, 2972); // TAMIL LETTER JA -> TAMIL LETTER JA
    charset += UIntSetRange(2974, 2975); // TAMIL LETTER NYA -> TAMIL LETTER TTA
    charset += UIntSetRange(2979, 2980); // TAMIL LETTER NNA -> TAMIL LETTER TA
    charset += UIntSetRange(2984, 2986); // TAMIL LETTER NA -> TAMIL LETTER PA
    charset += UIntSetRange(2990, 3001); // TAMIL LETTER MA -> TAMIL LETTER HA
    charset += UIntSetRange(3024, 3024); // TAMIL OM -> TAMIL OM
    charset += UIntSetRange(3046, 3055); // TAMIL DIGIT ZERO -> TAMIL DIGIT NINE
    charset += UIntSetRange(3077, 3084); // TELUGU LETTER A -> TELUGU LETTER VOCALIC L
    charset += UIntSetRange(3086, 3088); // TELUGU LETTER E -> TELUGU LETTER AI
    charset += UIntSetRange(3090, 3112); // TELUGU LETTER O -> TELUGU LETTER NA
    charset += UIntSetRange(3114, 3123); // TELUGU LETTER PA -> TELUGU LETTER LLA
    charset += UIntSetRange(3125, 3129); // TELUGU LETTER VA -> TELUGU LETTER HA
    charset += UIntSetRange(3133, 3133); // TELUGU SIGN AVAGRAHA -> TELUGU SIGN AVAGRAHA
    charset += UIntSetRange(3160, 3161); // TELUGU LETTER TSA -> TELUGU LETTER DZA
    charset += UIntSetRange(3168, 3169); // TELUGU LETTER VOCALIC RR -> TELUGU LETTER VOCALIC LL
    charset += UIntSetRange(3174, 3183); // TELUGU DIGIT ZERO -> TELUGU DIGIT NINE
    charset += UIntSetRange(3205, 3212); // KANNADA LETTER A -> KANNADA LETTER VOCALIC L
    charset += UIntSetRange(3214, 3216); // KANNADA LETTER E -> KANNADA LETTER AI
    charset += UIntSetRange(3218, 3240); // KANNADA LETTER O -> KANNADA LETTER NA
    charset += UIntSetRange(3242, 3251); // KANNADA LETTER PA -> KANNADA LETTER LLA
    charset += UIntSetRange(3253, 3257); // KANNADA LETTER VA -> KANNADA LETTER HA
    charset += UIntSetRange(3261, 3261); // KANNADA SIGN AVAGRAHA -> KANNADA SIGN AVAGRAHA
    charset += UIntSetRange(3294, 3294); // KANNADA LETTER FA -> KANNADA LETTER FA
    charset += UIntSetRange(3296, 3297); // KANNADA LETTER VOCALIC RR -> KANNADA LETTER VOCALIC LL
    charset += UIntSetRange(3302, 3311); // KANNADA DIGIT ZERO -> KANNADA DIGIT NINE
    charset += UIntSetRange(3333, 3340); // MALAYALAM LETTER A -> MALAYALAM LETTER VOCALIC L
    charset += UIntSetRange(3342, 3344); // MALAYALAM LETTER E -> MALAYALAM LETTER AI
    charset += UIntSetRange(3346, 3368); // MALAYALAM LETTER O -> MALAYALAM LETTER NA
    charset += UIntSetRange(3370, 3385); // MALAYALAM LETTER PA -> MALAYALAM LETTER HA
    charset += UIntSetRange(3389, 3389); // MALAYALAM SIGN AVAGRAHA -> MALAYALAM SIGN AVAGRAHA
    charset += UIntSetRange(3424, 3425); // MALAYALAM LETTER VOCALIC RR -> MALAYALAM LETTER VOCALIC LL
    charset += UIntSetRange(3430, 3439); // MALAYALAM DIGIT ZERO -> MALAYALAM DIGIT NINE
    charset += UIntSetRange(3450, 3455); // MALAYALAM LETTER CHILLU NN -> MALAYALAM LETTER CHILLU K
    charset += UIntSetRange(3461, 3478); // SINHALA LETTER AYANNA -> SINHALA LETTER AUYANNA
    charset += UIntSetRange(3482, 3505); // SINHALA LETTER ALPAPRAANA KAYANNA -> SINHALA LETTER DANTAJA NAYANNA
    charset += UIntSetRange(3507, 3515); // SINHALA LETTER SANYAKA DAYANNA -> SINHALA LETTER RAYANNA
    charset += UIntSetRange(3517, 3517); // SINHALA LETTER DANTAJA LAYANNA -> SINHALA LETTER DANTAJA LAYANNA
    charset += UIntSetRange(3520, 3526); // SINHALA LETTER VAYANNA -> SINHALA LETTER FAYANNA
    charset += UIntSetRange(3585, 3632); // THAI CHARACTER KO KAI -> THAI CHARACTER SARA A
    charset += UIntSetRange(3634, 3635); // THAI CHARACTER SARA AA -> THAI CHARACTER SARA AM
    charset += UIntSetRange(3648, 3654); // THAI CHARACTER SARA E -> THAI CHARACTER MAIYAMOK
    charset += UIntSetRange(3664, 3673); // THAI DIGIT ZERO -> THAI DIGIT NINE
    charset += UIntSetRange(3713, 3714); // LAO LETTER KO -> LAO LETTER KHO SUNG
    charset += UIntSetRange(3716, 3716); // LAO LETTER KHO TAM -> LAO LETTER KHO TAM
    charset += UIntSetRange(3719, 3720); // LAO LETTER NGO -> LAO LETTER CO
    charset += UIntSetRange(3722, 3722); // LAO LETTER SO TAM -> LAO LETTER SO TAM
    charset += UIntSetRange(3725, 3725); // LAO LETTER NYO -> LAO LETTER NYO
    charset += UIntSetRange(3732, 3735); // LAO LETTER DO -> LAO LETTER THO TAM
    charset += UIntSetRange(3737, 3743); // LAO LETTER NO -> LAO LETTER FO SUNG
    charset += UIntSetRange(3745, 3747); // LAO LETTER MO -> LAO LETTER LO LING
    charset += UIntSetRange(3749, 3749); // LAO LETTER LO LOOT -> LAO LETTER LO LOOT
    charset += UIntSetRange(3751, 3751); // LAO LETTER WO -> LAO LETTER WO
    charset += UIntSetRange(3754, 3755); // LAO LETTER SO SUNG -> LAO LETTER HO SUNG
    charset += UIntSetRange(3757, 3760); // LAO LETTER O -> LAO VOWEL SIGN A
    charset += UIntSetRange(3762, 3763); // LAO VOWEL SIGN AA -> LAO VOWEL SIGN AM
    charset += UIntSetRange(3773, 3773); // LAO SEMIVOWEL SIGN NYO -> LAO SEMIVOWEL SIGN NYO
    charset += UIntSetRange(3776, 3780); // LAO VOWEL SIGN E -> LAO VOWEL SIGN AI
    charset += UIntSetRange(3782, 3782); // LAO KO LA -> LAO KO LA
    charset += UIntSetRange(3792, 3801); // LAO DIGIT ZERO -> LAO DIGIT NINE
    charset += UIntSetRange(3804, 3805); // LAO HO NO -> LAO HO MO
    charset += UIntSetRange(3840, 3840); // TIBETAN SYLLABLE OM -> TIBETAN SYLLABLE OM
    charset += UIntSetRange(3872, 3881); // TIBETAN DIGIT ZERO -> TIBETAN DIGIT NINE
    charset += UIntSetRange(3904, 3911); // TIBETAN LETTER KA -> TIBETAN LETTER JA
    charset += UIntSetRange(3913, 3948); // TIBETAN LETTER NYA -> TIBETAN LETTER RRA
    charset += UIntSetRange(3976, 3979); // TIBETAN SIGN LCE TSA CAN -> TIBETAN SIGN GRU MED RGYINGS
    charset += UIntSetRange(4096, 4138); // MYANMAR LETTER KA -> MYANMAR LETTER AU
    charset += UIntSetRange(4159, 4169); // MYANMAR LETTER GREAT SA -> MYANMAR DIGIT NINE
    charset += UIntSetRange(4176, 4181); // MYANMAR LETTER SHA -> MYANMAR LETTER VOCALIC LL
    charset += UIntSetRange(4186, 4189); // MYANMAR LETTER MON NGA -> MYANMAR LETTER MON BBE
    charset += UIntSetRange(4193, 4193); // MYANMAR LETTER SGAW KAREN SHA -> MYANMAR LETTER SGAW KAREN SHA
    charset += UIntSetRange(4197, 4198); // MYANMAR LETTER WESTERN PWO KAREN THA -> MYANMAR LETTER WESTERN PWO KAREN PWA
    charset += UIntSetRange(4206, 4208); // MYANMAR LETTER EASTERN PWO KAREN NNA -> MYANMAR LETTER EASTERN PWO KAREN GHWA
    charset += UIntSetRange(4213, 4225); // MYANMAR LETTER SHAN KA -> MYANMAR LETTER SHAN HA
    charset += UIntSetRange(4238, 4238); // MYANMAR LETTER RUMAI PALAUNG FA -> MYANMAR LETTER RUMAI PALAUNG FA
    charset += UIntSetRange(4240, 4249); // MYANMAR SHAN DIGIT ZERO -> MYANMAR SHAN DIGIT NINE
    charset += UIntSetRange(4256, 4293); // GEORGIAN CAPITAL LETTER AN -> GEORGIAN CAPITAL LETTER HOE
    charset += UIntSetRange(4304, 4346); // GEORGIAN LETTER AN -> GEORGIAN LETTER AIN
    charset += UIntSetRange(4348, 4348); // MODIFIER LETTER GEORGIAN NAR -> MODIFIER LETTER GEORGIAN NAR
    charset += UIntSetRange(4352, 4441); // HANGUL CHOSEONG KIYEOK -> HANGUL CHOSEONG YEORINHIEUH
    charset += UIntSetRange(4447, 4514); // HANGUL CHOSEONG FILLER -> HANGUL JUNGSEONG SSANGARAEA
    charset += UIntSetRange(4520, 4601); // HANGUL JONGSEONG KIYEOK -> HANGUL JONGSEONG YEORINHIEUH
    charset += UIntSetRange(4608, 4680); // ETHIOPIC SYLLABLE HA -> ETHIOPIC SYLLABLE QWA
    charset += UIntSetRange(4682, 4685); // ETHIOPIC SYLLABLE QWI -> ETHIOPIC SYLLABLE QWE
    charset += UIntSetRange(4688, 4694); // ETHIOPIC SYLLABLE QHA -> ETHIOPIC SYLLABLE QHO
    charset += UIntSetRange(4696, 4696); // ETHIOPIC SYLLABLE QHWA -> ETHIOPIC SYLLABLE QHWA
    charset += UIntSetRange(4698, 4701); // ETHIOPIC SYLLABLE QHWI -> ETHIOPIC SYLLABLE QHWE
    charset += UIntSetRange(4704, 4744); // ETHIOPIC SYLLABLE BA -> ETHIOPIC SYLLABLE XWA
    charset += UIntSetRange(4746, 4749); // ETHIOPIC SYLLABLE XWI -> ETHIOPIC SYLLABLE XWE
    charset += UIntSetRange(4752, 4784); // ETHIOPIC SYLLABLE NA -> ETHIOPIC SYLLABLE KWA
    charset += UIntSetRange(4786, 4789); // ETHIOPIC SYLLABLE KWI -> ETHIOPIC SYLLABLE KWE
    charset += UIntSetRange(4792, 4798); // ETHIOPIC SYLLABLE KXA -> ETHIOPIC SYLLABLE KXO
    charset += UIntSetRange(4800, 4800); // ETHIOPIC SYLLABLE KXWA -> ETHIOPIC SYLLABLE KXWA
    charset += UIntSetRange(4802, 4805); // ETHIOPIC SYLLABLE KXWI -> ETHIOPIC SYLLABLE KXWE
    charset += UIntSetRange(4808, 4822); // ETHIOPIC SYLLABLE WA -> ETHIOPIC SYLLABLE PHARYNGEAL O
    charset += UIntSetRange(4824, 4880); // ETHIOPIC SYLLABLE ZA -> ETHIOPIC SYLLABLE GWA
    charset += UIntSetRange(4882, 4885); // ETHIOPIC SYLLABLE GWI -> ETHIOPIC SYLLABLE GWE
    charset += UIntSetRange(4888, 4954); // ETHIOPIC SYLLABLE GGA -> ETHIOPIC SYLLABLE FYA
    charset += UIntSetRange(4992, 5007); // ETHIOPIC SYLLABLE SEBATBEIT MWA -> ETHIOPIC SYLLABLE PWE
    charset += UIntSetRange(5024, 5108); // CHEROKEE LETTER A -> CHEROKEE LETTER YV
    charset += UIntSetRange(5121, 5740); // CANADIAN SYLLABICS E -> CANADIAN SYLLABICS CARRIER TTSA
    charset += UIntSetRange(5743, 5750); // CANADIAN SYLLABICS QAI -> CANADIAN SYLLABICS NNGAA
    charset += UIntSetRange(5761, 5786); // OGHAM LETTER BEITH -> OGHAM LETTER PEITH
    charset += UIntSetRange(5792, 5866); // RUNIC LETTER FEHU FEOH FE F -> RUNIC LETTER X
    charset += UIntSetRange(5888, 5900); // TAGALOG LETTER A -> TAGALOG LETTER YA
    charset += UIntSetRange(5902, 5905); // TAGALOG LETTER LA -> TAGALOG LETTER HA
    charset += UIntSetRange(5920, 5937); // HANUNOO LETTER A -> HANUNOO LETTER HA
    charset += UIntSetRange(5952, 5969); // BUHID LETTER A -> BUHID LETTER HA
    charset += UIntSetRange(5984, 5996); // TAGBANWA LETTER A -> TAGBANWA LETTER YA
    charset += UIntSetRange(5998, 6000); // TAGBANWA LETTER LA -> TAGBANWA LETTER SA
    charset += UIntSetRange(6016, 6067); // KHMER LETTER KA -> KHMER INDEPENDENT VOWEL QAU
    charset += UIntSetRange(6103, 6103); // KHMER SIGN LEK TOO -> KHMER SIGN LEK TOO
    charset += UIntSetRange(6108, 6108); // KHMER SIGN AVAKRAHASANYA -> KHMER SIGN AVAKRAHASANYA
    charset += UIntSetRange(6112, 6121); // KHMER DIGIT ZERO -> KHMER DIGIT NINE
    charset += UIntSetRange(6160, 6169); // MONGOLIAN DIGIT ZERO -> MONGOLIAN DIGIT NINE
    charset += UIntSetRange(6176, 6263); // MONGOLIAN LETTER A -> MONGOLIAN LETTER MANCHU ZHA
    charset += UIntSetRange(6272, 6312); // MONGOLIAN LETTER ALI GALI ANUSVARA ONE -> MONGOLIAN LETTER MANCHU ALI GALI BHA
    charset += UIntSetRange(6314, 6314); // MONGOLIAN LETTER MANCHU ALI GALI LHA -> MONGOLIAN LETTER MANCHU ALI GALI LHA
    charset += UIntSetRange(6400, 6428); // LIMBU VOWEL-CARRIER LETTER -> LIMBU LETTER HA
    charset += UIntSetRange(6470, 6509); // LIMBU DIGIT ZERO -> TAI LE LETTER AI
    charset += UIntSetRange(6512, 6516); // TAI LE LETTER TONE-2 -> TAI LE LETTER TONE-6
    charset += UIntSetRange(6528, 6569); // NEW TAI LUE LETTER HIGH QA -> NEW TAI LUE LETTER LOW XVA
    charset += UIntSetRange(6593, 6599); // NEW TAI LUE LETTER FINAL V -> NEW TAI LUE LETTER FINAL B
    charset += UIntSetRange(6608, 6617); // NEW TAI LUE DIGIT ZERO -> NEW TAI LUE DIGIT NINE
    charset += UIntSetRange(6656, 6678); // BUGINESE LETTER KA -> BUGINESE LETTER HA
    charset += UIntSetRange(6917, 6963); // BALINESE LETTER AKARA -> BALINESE LETTER HA
    charset += UIntSetRange(6981, 6987); // BALINESE LETTER KAF SASAK -> BALINESE LETTER ASYURA SASAK
    charset += UIntSetRange(6992, 7001); // BALINESE DIGIT ZERO -> BALINESE DIGIT NINE
    charset += UIntSetRange(7043, 7072); // SUNDANESE LETTER A -> SUNDANESE LETTER HA
    charset += UIntSetRange(7086, 7097); // SUNDANESE LETTER KHA -> SUNDANESE DIGIT NINE
    charset += UIntSetRange(7168, 7203); // LEPCHA LETTER KA -> LEPCHA LETTER A
    charset += UIntSetRange(7232, 7241); // LEPCHA DIGIT ZERO -> LEPCHA DIGIT NINE
    charset += UIntSetRange(7245, 7293); // LEPCHA LETTER TTA -> OL CHIKI AHAD
    charset += UIntSetRange(7424, 7615); // LATIN LETTER SMALL CAPITAL A -> MODIFIER LETTER SMALL THETA
    charset += UIntSetRange(7680, 7957); // LATIN CAPITAL LETTER A WITH RING BELOW -> GREEK SMALL LETTER EPSILON WITH DASIA AND OXIA
    charset += UIntSetRange(7960, 7965); // GREEK CAPITAL LETTER EPSILON WITH PSILI -> GREEK CAPITAL LETTER EPSILON WITH DASIA AND OXIA
    charset += UIntSetRange(7968, 8005); // GREEK SMALL LETTER ETA WITH PSILI -> GREEK SMALL LETTER OMICRON WITH DASIA AND OXIA
    charset += UIntSetRange(8008, 8013); // GREEK CAPITAL LETTER OMICRON WITH PSILI -> GREEK CAPITAL LETTER OMICRON WITH DASIA AND OXIA
    charset += UIntSetRange(8016, 8023); // GREEK SMALL LETTER UPSILON WITH PSILI -> GREEK SMALL LETTER UPSILON WITH DASIA AND PERISPOMENI
    charset += UIntSetRange(8025, 8025); // GREEK CAPITAL LETTER UPSILON WITH DASIA -> GREEK CAPITAL LETTER UPSILON WITH DASIA
    charset += UIntSetRange(8027, 8027); // GREEK CAPITAL LETTER UPSILON WITH DASIA AND VARIA -> GREEK CAPITAL LETTER UPSILON WITH DASIA AND VARIA
    charset += UIntSetRange(8029, 8029); // GREEK CAPITAL LETTER UPSILON WITH DASIA AND OXIA -> GREEK CAPITAL LETTER UPSILON WITH DASIA AND OXIA
    charset += UIntSetRange(8031, 8061); // GREEK CAPITAL LETTER UPSILON WITH DASIA AND PERISPOMENI -> GREEK SMALL LETTER OMEGA WITH OXIA
    charset += UIntSetRange(8064, 8116); // GREEK SMALL LETTER ALPHA WITH PSILI AND YPOGEGRAMMENI -> GREEK SMALL LETTER ALPHA WITH OXIA AND YPOGEGRAMMENI
    charset += UIntSetRange(8118, 8124); // GREEK SMALL LETTER ALPHA WITH PERISPOMENI -> GREEK CAPITAL LETTER ALPHA WITH PROSGEGRAMMENI
    charset += UIntSetRange(8126, 8126); // GREEK PROSGEGRAMMENI -> GREEK PROSGEGRAMMENI
    charset += UIntSetRange(8130, 8132); // GREEK SMALL LETTER ETA WITH VARIA AND YPOGEGRAMMENI -> GREEK SMALL LETTER ETA WITH OXIA AND YPOGEGRAMMENI
    charset += UIntSetRange(8134, 8140); // GREEK SMALL LETTER ETA WITH PERISPOMENI -> GREEK CAPITAL LETTER ETA WITH PROSGEGRAMMENI
    charset += UIntSetRange(8144, 8147); // GREEK SMALL LETTER IOTA WITH VRACHY -> GREEK SMALL LETTER IOTA WITH DIALYTIKA AND OXIA
    charset += UIntSetRange(8150, 8155); // GREEK SMALL LETTER IOTA WITH PERISPOMENI -> GREEK CAPITAL LETTER IOTA WITH OXIA
    charset += UIntSetRange(8160, 8172); // GREEK SMALL LETTER UPSILON WITH VRACHY -> GREEK CAPITAL LETTER RHO WITH DASIA
    charset += UIntSetRange(8178, 8180); // GREEK SMALL LETTER OMEGA WITH VARIA AND YPOGEGRAMMENI -> GREEK SMALL LETTER OMEGA WITH OXIA AND YPOGEGRAMMENI
    charset += UIntSetRange(8182, 8188); // GREEK SMALL LETTER OMEGA WITH PERISPOMENI -> GREEK CAPITAL LETTER OMEGA WITH PROSGEGRAMMENI
    charset += UIntSetRange(8305, 8305); // SUPERSCRIPT LATIN SMALL LETTER I -> SUPERSCRIPT LATIN SMALL LETTER I
    charset += UIntSetRange(8319, 8319); // SUPERSCRIPT LATIN SMALL LETTER N -> SUPERSCRIPT LATIN SMALL LETTER N
    charset += UIntSetRange(8336, 8340); // LATIN SUBSCRIPT SMALL LETTER A -> LATIN SUBSCRIPT SMALL LETTER SCHWA
    charset += UIntSetRange(8450, 8450); // DOUBLE-STRUCK CAPITAL C -> DOUBLE-STRUCK CAPITAL C
    charset += UIntSetRange(8455, 8455); // EULER CONSTANT -> EULER CONSTANT
    charset += UIntSetRange(8458, 8467); // SCRIPT SMALL G -> SCRIPT SMALL L
    charset += UIntSetRange(8469, 8469); // DOUBLE-STRUCK CAPITAL N -> DOUBLE-STRUCK CAPITAL N
    charset += UIntSetRange(8473, 8477); // DOUBLE-STRUCK CAPITAL P -> DOUBLE-STRUCK CAPITAL R
    charset += UIntSetRange(8484, 8484); // DOUBLE-STRUCK CAPITAL Z -> DOUBLE-STRUCK CAPITAL Z
    charset += UIntSetRange(8486, 8486); // OHM SIGN -> OHM SIGN
    charset += UIntSetRange(8488, 8488); // BLACK-LETTER CAPITAL Z -> BLACK-LETTER CAPITAL Z
    charset += UIntSetRange(8490, 8493); // KELVIN SIGN -> BLACK-LETTER CAPITAL C
    charset += UIntSetRange(8495, 8505); // SCRIPT SMALL E -> INFORMATION SOURCE
    charset += UIntSetRange(8508, 8511); // DOUBLE-STRUCK SMALL PI -> DOUBLE-STRUCK CAPITAL PI
    charset += UIntSetRange(8517, 8521); // DOUBLE-STRUCK ITALIC CAPITAL D -> DOUBLE-STRUCK ITALIC SMALL J
    charset += UIntSetRange(8526, 8526); // TURNED SMALL F -> TURNED SMALL F
    charset += UIntSetRange(8579, 8580); // ROMAN NUMERAL REVERSED ONE HUNDRED -> LATIN SMALL LETTER REVERSED C
    charset += UIntSetRange(11264, 11310); // GLAGOLITIC CAPITAL LETTER AZU -> GLAGOLITIC CAPITAL LETTER LATINATE MYSLITE
    charset += UIntSetRange(11312, 11358); // GLAGOLITIC SMALL LETTER AZU -> GLAGOLITIC SMALL LETTER LATINATE MYSLITE
    charset += UIntSetRange(11360, 11375); // LATIN CAPITAL LETTER L WITH DOUBLE BAR -> LATIN CAPITAL LETTER TURNED A
    charset += UIntSetRange(11377, 11389); // LATIN SMALL LETTER V WITH RIGHT HOOK -> MODIFIER LETTER CAPITAL V
    charset += UIntSetRange(11392, 11492); // COPTIC CAPITAL LETTER ALFA -> COPTIC SYMBOL KAI
    charset += UIntSetRange(11520, 11557); // GEORGIAN SMALL LETTER AN -> GEORGIAN SMALL LETTER HOE
    charset += UIntSetRange(11568, 11621); // TIFINAGH LETTER YA -> TIFINAGH LETTER YAZZ
    charset += UIntSetRange(11631, 11631); // TIFINAGH MODIFIER LETTER LABIALIZATION MARK -> TIFINAGH MODIFIER LETTER LABIALIZATION MARK
    charset += UIntSetRange(11648, 11670); // ETHIOPIC SYLLABLE LOA -> ETHIOPIC SYLLABLE GGWE
    charset += UIntSetRange(11680, 11686); // ETHIOPIC SYLLABLE SSA -> ETHIOPIC SYLLABLE SSO
    charset += UIntSetRange(11688, 11694); // ETHIOPIC SYLLABLE CCA -> ETHIOPIC SYLLABLE CCO
    charset += UIntSetRange(11696, 11702); // ETHIOPIC SYLLABLE ZZA -> ETHIOPIC SYLLABLE ZZO
    charset += UIntSetRange(11704, 11710); // ETHIOPIC SYLLABLE CCHA -> ETHIOPIC SYLLABLE CCHO
    charset += UIntSetRange(11712, 11718); // ETHIOPIC SYLLABLE QYA -> ETHIOPIC SYLLABLE QYO
    charset += UIntSetRange(11720, 11726); // ETHIOPIC SYLLABLE KYA -> ETHIOPIC SYLLABLE KYO
    charset += UIntSetRange(11728, 11734); // ETHIOPIC SYLLABLE XYA -> ETHIOPIC SYLLABLE XYO
    charset += UIntSetRange(11736, 11742); // ETHIOPIC SYLLABLE GYA -> ETHIOPIC SYLLABLE GYO
    charset += UIntSetRange(11823, 11823); // VERTICAL TILDE -> VERTICAL TILDE
    charset += UIntSetRange(12293, 12294); // IDEOGRAPHIC ITERATION MARK -> IDEOGRAPHIC CLOSING MARK
    charset += UIntSetRange(12337, 12341); // VERTICAL KANA REPEAT MARK -> VERTICAL KANA REPEAT MARK LOWER HALF
    charset += UIntSetRange(12347, 12348); // VERTICAL IDEOGRAPHIC ITERATION MARK -> MASU MARK
    charset += UIntSetRange(12353, 12438); // HIRAGANA LETTER SMALL A -> HIRAGANA LETTER SMALL KE
    charset += UIntSetRange(12445, 12447); // HIRAGANA ITERATION MARK -> HIRAGANA DIGRAPH YORI
    charset += UIntSetRange(12449, 12538); // KATAKANA LETTER SMALL A -> KATAKANA LETTER VO
    charset += UIntSetRange(12540, 12543); // KATAKANA-HIRAGANA PROLONGED SOUND MARK -> KATAKANA DIGRAPH KOTO
    charset += UIntSetRange(12549, 12589); // BOPOMOFO LETTER B -> BOPOMOFO LETTER IH
    charset += UIntSetRange(12593, 12686); // HANGUL LETTER KIYEOK -> HANGUL LETTER ARAEAE
    charset += UIntSetRange(12704, 12727); // BOPOMOFO LETTER BU -> BOPOMOFO FINAL LETTER H
    charset += UIntSetRange(12784, 12799); // KATAKANA LETTER SMALL KU -> KATAKANA LETTER SMALL RO
    charset += UIntSetRange(13312, 19893); // -3400 -> -4DB5
    charset += UIntSetRange(19968, 40899); // -4E00 -> -9FC3
    charset += UIntSetRange(40960, 42124); // YI SYLLABLE IT -> YI SYLLABLE YYR
    charset += UIntSetRange(42240, 42508); // VAI SYLLABLE EE -> VAI SYLLABLE LENGTHENER
    charset += UIntSetRange(42512, 42539); // VAI SYLLABLE NDOLE FA -> VAI SYLLABLE NDOLE DO
    charset += UIntSetRange(42560, 42591); // CYRILLIC CAPITAL LETTER ZEMLYA -> CYRILLIC SMALL LETTER YN
    charset += UIntSetRange(42594, 42606); // CYRILLIC CAPITAL LETTER SOFT DE -> CYRILLIC LETTER MULTIOCULAR O
    charset += UIntSetRange(42623, 42647); // CYRILLIC PAYEROK -> CYRILLIC SMALL LETTER SHWE
    charset += UIntSetRange(42775, 42783); // MODIFIER LETTER DOT VERTICAL BAR -> MODIFIER LETTER LOW INVERTED EXCLAMATION MARK
    charset += UIntSetRange(42786, 42888); // LATIN CAPITAL LETTER EGYPTOLOGICAL ALEF -> MODIFIER LETTER LOW CIRCUMFLEX ACCENT
    charset += UIntSetRange(42891, 42892); // LATIN CAPITAL LETTER SALTILLO -> LATIN SMALL LETTER SALTILLO
    charset += UIntSetRange(43003, 43009); // LATIN EPIGRAPHIC LETTER REVERSED F -> SYLOTI NAGRI LETTER I
    charset += UIntSetRange(43011, 43013); // SYLOTI NAGRI LETTER U -> SYLOTI NAGRI LETTER O
    charset += UIntSetRange(43015, 43018); // SYLOTI NAGRI LETTER KO -> SYLOTI NAGRI LETTER GHO
    charset += UIntSetRange(43020, 43042); // SYLOTI NAGRI LETTER CO -> SYLOTI NAGRI LETTER HO
    charset += UIntSetRange(43072, 43123); // PHAGS-PA LETTER KA -> PHAGS-PA LETTER CANDRABINDU
    charset += UIntSetRange(43138, 43187); // SAURASHTRA LETTER A -> SAURASHTRA LETTER LLA
    charset += UIntSetRange(43216, 43225); // SAURASHTRA DIGIT ZERO -> SAURASHTRA DIGIT NINE
    charset += UIntSetRange(43264, 43301); // KAYAH LI DIGIT ZERO -> KAYAH LI LETTER OO
    charset += UIntSetRange(43312, 43334); // REJANG LETTER KA -> REJANG LETTER A
    charset += UIntSetRange(43520, 43560); // CHAM LETTER A -> CHAM LETTER HA
    charset += UIntSetRange(43584, 43586); // CHAM LETTER FINAL K -> CHAM LETTER FINAL NG
    charset += UIntSetRange(43588, 43595); // CHAM LETTER FINAL CH -> CHAM LETTER FINAL SS
    charset += UIntSetRange(43600, 43609); // CHAM DIGIT ZERO -> CHAM DIGIT NINE
    charset += UIntSetRange(44032, 55203); // -AC00 -> -D7A3
    charset += UIntSetRange(63744, 64045); // CJK COMPATIBILITY IDEOGRAPH-F900 -> CJK COMPATIBILITY IDEOGRAPH-FA2D
    charset += UIntSetRange(64048, 64106); // CJK COMPATIBILITY IDEOGRAPH-FA30 -> CJK COMPATIBILITY IDEOGRAPH-FA6A
    charset += UIntSetRange(64112, 64217); // CJK COMPATIBILITY IDEOGRAPH-FA70 -> CJK COMPATIBILITY IDEOGRAPH-FAD9
    charset += UIntSetRange(64256, 64262); // LATIN SMALL LIGATURE FF -> LATIN SMALL LIGATURE ST
    charset += UIntSetRange(64275, 64279); // ARMENIAN SMALL LIGATURE MEN NOW -> ARMENIAN SMALL LIGATURE MEN XEH
    charset += UIntSetRange(64285, 64285); // HEBREW LETTER YOD WITH HIRIQ -> HEBREW LETTER YOD WITH HIRIQ
    charset += UIntSetRange(64287, 64296); // HEBREW LIGATURE YIDDISH YOD YOD PATAH -> HEBREW LETTER WIDE TAV
    charset += UIntSetRange(64298, 64310); // HEBREW LETTER SHIN WITH SHIN DOT -> HEBREW LETTER ZAYIN WITH DAGESH
    charset += UIntSetRange(64312, 64316); // HEBREW LETTER TET WITH DAGESH -> HEBREW LETTER LAMED WITH DAGESH
    charset += UIntSetRange(64318, 64318); // HEBREW LETTER MEM WITH DAGESH -> HEBREW LETTER MEM WITH DAGESH
    charset += UIntSetRange(64320, 64321); // HEBREW LETTER NUN WITH DAGESH -> HEBREW LETTER SAMEKH WITH DAGESH
    charset += UIntSetRange(64323, 64324); // HEBREW LETTER FINAL PE WITH DAGESH -> HEBREW LETTER PE WITH DAGESH
    charset += UIntSetRange(64326, 64433); // HEBREW LETTER TSADI WITH DAGESH -> ARABIC LETTER YEH BARREE WITH HAMZA ABOVE FINAL FORM
    charset += UIntSetRange(64467, 64829); // ARABIC LETTER NG ISOLATED FORM -> ARABIC LIGATURE ALEF WITH FATHATAN ISOLATED FORM
    charset += UIntSetRange(64848, 64911); // ARABIC LIGATURE TEH WITH JEEM WITH MEEM INITIAL FORM -> ARABIC LIGATURE MEEM WITH KHAH WITH MEEM INITIAL FORM
    charset += UIntSetRange(64914, 64967); // ARABIC LIGATURE MEEM WITH JEEM WITH KHAH INITIAL FORM -> ARABIC LIGATURE NOON WITH JEEM WITH YEH FINAL FORM
    charset += UIntSetRange(65008, 65019); // ARABIC LIGATURE SALLA USED AS KORANIC STOP SIGN ISOLATED FORM -> ARABIC LIGATURE JALLAJALALOUHOU
    charset += UIntSetRange(65136, 65140); // ARABIC FATHATAN ISOLATED FORM -> ARABIC KASRATAN ISOLATED FORM
    charset += UIntSetRange(65142, 65276); // ARABIC FATHA ISOLATED FORM -> ARABIC LIGATURE LAM WITH ALEF FINAL FORM
    charset += UIntSetRange(65296, 65305); // FULLWIDTH DIGIT ZERO -> FULLWIDTH DIGIT NINE
    charset += UIntSetRange(65313, 65338); // FULLWIDTH LATIN CAPITAL LETTER A -> FULLWIDTH LATIN CAPITAL LETTER Z
    charset += UIntSetRange(65345, 65370); // FULLWIDTH LATIN SMALL LETTER A -> FULLWIDTH LATIN SMALL LETTER Z
    charset += UIntSetRange(65382, 65470); // HALFWIDTH KATAKANA LETTER WO -> HALFWIDTH HANGUL LETTER HIEUH
    charset += UIntSetRange(65474, 65479); // HALFWIDTH HANGUL LETTER A -> HALFWIDTH HANGUL LETTER E
    charset += UIntSetRange(65482, 65487); // HALFWIDTH HANGUL LETTER YEO -> HALFWIDTH HANGUL LETTER OE
    charset += UIntSetRange(65490, 65495); // HALFWIDTH HANGUL LETTER YO -> HALFWIDTH HANGUL LETTER YU
    charset += UIntSetRange(65498, 65500); // HALFWIDTH HANGUL LETTER EU -> HALFWIDTH HANGUL LETTER I
    charset += UIntSetRange(65536, 65547); // LINEAR B SYLLABLE B008 A -> LINEAR B SYLLABLE B046 JE
    charset += UIntSetRange(65549, 65574); // LINEAR B SYLLABLE B036 JO -> LINEAR B SYLLABLE B032 QO
    charset += UIntSetRange(65576, 65594); // LINEAR B SYLLABLE B060 RA -> LINEAR B SYLLABLE B042 WO
    charset += UIntSetRange(65596, 65597); // LINEAR B SYLLABLE B017 ZA -> LINEAR B SYLLABLE B074 ZE
    charset += UIntSetRange(65599, 65613); // LINEAR B SYLLABLE B020 ZO -> LINEAR B SYLLABLE B091 TWO
    charset += UIntSetRange(65616, 65629); // LINEAR B SYMBOL B018 -> LINEAR B SYMBOL B089
    charset += UIntSetRange(65664, 65786); // LINEAR B IDEOGRAM B100 MAN -> LINEAR B IDEOGRAM VESSEL B305
    charset += UIntSetRange(66176, 66204); // LYCIAN LETTER A -> LYCIAN LETTER X
    charset += UIntSetRange(66208, 66256); // CARIAN LETTER A -> CARIAN LETTER UUU3
    charset += UIntSetRange(66304, 66334); // OLD ITALIC LETTER A -> OLD ITALIC LETTER UU
    charset += UIntSetRange(66352, 66368); // GOTHIC LETTER AHSA -> GOTHIC LETTER PAIRTHRA
    charset += UIntSetRange(66370, 66377); // GOTHIC LETTER RAIDA -> GOTHIC LETTER OTHAL
    charset += UIntSetRange(66432, 66461); // UGARITIC LETTER ALPA -> UGARITIC LETTER SSU
    charset += UIntSetRange(66464, 66499); // OLD PERSIAN SIGN A -> OLD PERSIAN SIGN HA
    charset += UIntSetRange(66504, 66511); // OLD PERSIAN SIGN AURAMAZDAA -> OLD PERSIAN SIGN BUUMISH
    charset += UIntSetRange(66560, 66717); // DESERET CAPITAL LETTER LONG I -> OSMANYA LETTER OO
    charset += UIntSetRange(66720, 66729); // OSMANYA DIGIT ZERO -> OSMANYA DIGIT NINE
    charset += UIntSetRange(67584, 67589); // CYPRIOT SYLLABLE A -> CYPRIOT SYLLABLE JA
    charset += UIntSetRange(67592, 67592); // CYPRIOT SYLLABLE JO -> CYPRIOT SYLLABLE JO
    charset += UIntSetRange(67594, 67637); // CYPRIOT SYLLABLE KA -> CYPRIOT SYLLABLE WO
    charset += UIntSetRange(67639, 67640); // CYPRIOT SYLLABLE XA -> CYPRIOT SYLLABLE XE
    charset += UIntSetRange(67644, 67644); // CYPRIOT SYLLABLE ZA -> CYPRIOT SYLLABLE ZA
    charset += UIntSetRange(67647, 67647); // CYPRIOT SYLLABLE ZO -> CYPRIOT SYLLABLE ZO
    charset += UIntSetRange(67840, 67861); // PHOENICIAN LETTER ALF -> PHOENICIAN LETTER TAU
    charset += UIntSetRange(67872, 67897); // LYDIAN LETTER A -> LYDIAN LETTER C
    charset += UIntSetRange(68096, 68096); // KHAROSHTHI LETTER A -> KHAROSHTHI LETTER A
    charset += UIntSetRange(68112, 68115); // KHAROSHTHI LETTER KA -> KHAROSHTHI LETTER GHA
    charset += UIntSetRange(68117, 68119); // KHAROSHTHI LETTER CA -> KHAROSHTHI LETTER JA
    charset += UIntSetRange(68121, 68147); // KHAROSHTHI LETTER NYA -> KHAROSHTHI LETTER TTTHA
    charset += UIntSetRange(73728, 74606); // CUNEIFORM SIGN A -> CUNEIFORM SIGN ZUM
    charset += UIntSetRange(119808, 119892); // MATHEMATICAL BOLD CAPITAL A -> MATHEMATICAL ITALIC SMALL G
    charset += UIntSetRange(119894, 119964); // MATHEMATICAL ITALIC SMALL I -> MATHEMATICAL SCRIPT CAPITAL A
    charset += UIntSetRange(119966, 119967); // MATHEMATICAL SCRIPT CAPITAL C -> MATHEMATICAL SCRIPT CAPITAL D
    charset += UIntSetRange(119970, 119970); // MATHEMATICAL SCRIPT CAPITAL G -> MATHEMATICAL SCRIPT CAPITAL G
    charset += UIntSetRange(119973, 119974); // MATHEMATICAL SCRIPT CAPITAL J -> MATHEMATICAL SCRIPT CAPITAL K
    charset += UIntSetRange(119977, 119980); // MATHEMATICAL SCRIPT CAPITAL N -> MATHEMATICAL SCRIPT CAPITAL Q
    charset += UIntSetRange(119982, 119993); // MATHEMATICAL SCRIPT CAPITAL S -> MATHEMATICAL SCRIPT SMALL D
    charset += UIntSetRange(119995, 119995); // MATHEMATICAL SCRIPT SMALL F -> MATHEMATICAL SCRIPT SMALL F
    charset += UIntSetRange(119997, 120003); // MATHEMATICAL SCRIPT SMALL H -> MATHEMATICAL SCRIPT SMALL N
    charset += UIntSetRange(120005, 120069); // MATHEMATICAL SCRIPT SMALL P -> MATHEMATICAL FRAKTUR CAPITAL B
    charset += UIntSetRange(120071, 120074); // MATHEMATICAL FRAKTUR CAPITAL D -> MATHEMATICAL FRAKTUR CAPITAL G
    charset += UIntSetRange(120077, 120084); // MATHEMATICAL FRAKTUR CAPITAL J -> MATHEMATICAL FRAKTUR CAPITAL Q
    charset += UIntSetRange(120086, 120092); // MATHEMATICAL FRAKTUR CAPITAL S -> MATHEMATICAL FRAKTUR CAPITAL Y
    charset += UIntSetRange(120094, 120121); // MATHEMATICAL FRAKTUR SMALL A -> MATHEMATICAL DOUBLE-STRUCK CAPITAL B
    charset += UIntSetRange(120123, 120126); // MATHEMATICAL DOUBLE-STRUCK CAPITAL D -> MATHEMATICAL DOUBLE-STRUCK CAPITAL G
    charset += UIntSetRange(120128, 120132); // MATHEMATICAL DOUBLE-STRUCK CAPITAL I -> MATHEMATICAL DOUBLE-STRUCK CAPITAL M
    charset += UIntSetRange(120134, 120134); // MATHEMATICAL DOUBLE-STRUCK CAPITAL O -> MATHEMATICAL DOUBLE-STRUCK CAPITAL O
    charset += UIntSetRange(120138, 120144); // MATHEMATICAL DOUBLE-STRUCK CAPITAL S -> MATHEMATICAL DOUBLE-STRUCK CAPITAL Y
    charset += UIntSetRange(120146, 120485); // MATHEMATICAL DOUBLE-STRUCK SMALL A -> MATHEMATICAL ITALIC SMALL DOTLESS J
    charset += UIntSetRange(120488, 120512); // MATHEMATICAL BOLD CAPITAL ALPHA -> MATHEMATICAL BOLD CAPITAL OMEGA
    charset += UIntSetRange(120514, 120538); // MATHEMATICAL BOLD SMALL ALPHA -> MATHEMATICAL BOLD SMALL OMEGA
    charset += UIntSetRange(120540, 120570); // MATHEMATICAL BOLD EPSILON SYMBOL -> MATHEMATICAL ITALIC CAPITAL OMEGA
    charset += UIntSetRange(120572, 120596); // MATHEMATICAL ITALIC SMALL ALPHA -> MATHEMATICAL ITALIC SMALL OMEGA
    charset += UIntSetRange(120598, 120628); // MATHEMATICAL ITALIC EPSILON SYMBOL -> MATHEMATICAL BOLD ITALIC CAPITAL OMEGA
    charset += UIntSetRange(120630, 120654); // MATHEMATICAL BOLD ITALIC SMALL ALPHA -> MATHEMATICAL BOLD ITALIC SMALL OMEGA
    charset += UIntSetRange(120656, 120686); // MATHEMATICAL BOLD ITALIC EPSILON SYMBOL -> MATHEMATICAL SANS-SERIF BOLD CAPITAL OMEGA
    charset += UIntSetRange(120688, 120712); // MATHEMATICAL SANS-SERIF BOLD SMALL ALPHA -> MATHEMATICAL SANS-SERIF BOLD SMALL OMEGA
    charset += UIntSetRange(120714, 120744); // MATHEMATICAL SANS-SERIF BOLD EPSILON SYMBOL -> MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL OMEGA
    charset += UIntSetRange(120746, 120770); // MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL ALPHA -> MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL OMEGA
    charset += UIntSetRange(120772, 120779); // MATHEMATICAL SANS-SERIF BOLD ITALIC EPSILON SYMBOL -> MATHEMATICAL BOLD SMALL DIGAMMA
    charset += UIntSetRange(120782, 120831); // MATHEMATICAL BOLD DIGIT ZERO -> MATHEMATICAL MONOSPACE DIGIT NINE
    charset += UIntSetRange(131072, 173782); // -20000 -> -2A6D6
    charset += UIntSetRange(194560, 195101); // CJK COMPATIBILITY IDEOGRAPH-2F800 -> CJK COMPATIBILITY IDEOGRAPH-2FA1D
    return charset;
}


const UIntSet &named_charset_space()
{
    static UIntSet charset;
    if( charset.count() )
        return charset;
    charset += UIntSetRange(9, 13); // CHARACTER TABULATION -> CARRIAGE RETURN (CR)
    charset += UIntSetRange(32, 32); // SPACE -> SPACE
    charset += UIntSetRange(133, 133); // NEXT LINE (NEL) -> NEXT LINE (NEL)
    charset += UIntSetRange(160, 160); // NO-BREAK SPACE -> NO-BREAK SPACE
    charset += UIntSetRange(5760, 5760); // OGHAM SPACE MARK -> OGHAM SPACE MARK
    charset += UIntSetRange(6158, 6158); // MONGOLIAN VOWEL SEPARATOR -> MONGOLIAN VOWEL SEPARATOR
    charset += UIntSetRange(8192, 8202); // EN QUAD -> HAIR SPACE
    charset += UIntSetRange(8232, 8233); // LINE SEPARATOR -> PARAGRAPH SEPARATOR
    charset += UIntSetRange(8239, 8239); // NARROW NO-BREAK SPACE -> NARROW NO-BREAK SPACE
    charset += UIntSetRange(8287, 8287); // MEDIUM MATHEMATICAL SPACE -> MEDIUM MATHEMATICAL SPACE
    charset += UIntSetRange(12288, 12288); // IDEOGRAPHIC SPACE -> IDEOGRAPHIC SPACE
    return charset;
}


const UIntSet &named_charset_pspace()
{
    static UIntSet charset;
    if( charset.count() )
        return charset;
    charset += UIntSetRange(9, 13); // CHARACTER TABULATION -> CARRIAGE RETURN (CR)
    charset += UIntSetRange(32, 32); // SPACE -> SPACE
    charset += UIntSetRange(133, 133); // NEXT LINE (NEL) -> NEXT LINE (NEL)
    charset += UIntSetRange(8206, 8207); // LEFT-TO-RIGHT MARK -> RIGHT-TO-LEFT MARK
    charset += UIntSetRange(8232, 8233); // LINE SEPARATOR -> PARAGRAPH SEPARATOR
    return charset;
}


const UIntSet &named_charset_blank()
{
    static UIntSet charset;
    if( charset.count() )
        return charset;
    charset += UIntSetRange(9, 9); // CHARACTER TABULATION -> CHARACTER TABULATION
    charset += UIntSetRange(32, 32); // SPACE -> SPACE
    return charset;
}


const UIntSet &named_charset_digit()
{
    static UIntSet charset;
    if( charset.count() )
        return charset;
    charset += UIntSetRange(48, 57); // DIGIT ZERO -> DIGIT NINE
    charset += UIntSetRange(1632, 1641); // ARABIC-INDIC DIGIT ZERO -> ARABIC-INDIC DIGIT NINE
    charset += UIntSetRange(1776, 1785); // EXTENDED ARABIC-INDIC DIGIT ZERO -> EXTENDED ARABIC-INDIC DIGIT NINE
    charset += UIntSetRange(1984, 1993); // NKO DIGIT ZERO -> NKO DIGIT NINE
    charset += UIntSetRange(2406, 2415); // DEVANAGARI DIGIT ZERO -> DEVANAGARI DIGIT NINE
    charset += UIntSetRange(2534, 2543); // BENGALI DIGIT ZERO -> BENGALI DIGIT NINE
    charset += UIntSetRange(2662, 2671); // GURMUKHI DIGIT ZERO -> GURMUKHI DIGIT NINE
    charset += UIntSetRange(2790, 2799); // GUJARATI DIGIT ZERO -> GUJARATI DIGIT NINE
    charset += UIntSetRange(2918, 2927); // ORIYA DIGIT ZERO -> ORIYA DIGIT NINE
    charset += UIntSetRange(3046, 3055); // TAMIL DIGIT ZERO -> TAMIL DIGIT NINE
    charset += UIntSetRange(3174, 3183); // TELUGU DIGIT ZERO -> TELUGU DIGIT NINE
    charset += UIntSetRange(3302, 3311); // KANNADA DIGIT ZERO -> KANNADA DIGIT NINE
    charset += UIntSetRange(3430, 3439); // MALAYALAM DIGIT ZERO -> MALAYALAM DIGIT NINE
    charset += UIntSetRange(3664, 3673); // THAI DIGIT ZERO -> THAI DIGIT NINE
    charset += UIntSetRange(3792, 3801); // LAO DIGIT ZERO -> LAO DIGIT NINE
    charset += UIntSetRange(3872, 3881); // TIBETAN DIGIT ZERO -> TIBETAN DIGIT NINE
    charset += UIntSetRange(4160, 4169); // MYANMAR DIGIT ZERO -> MYANMAR DIGIT NINE
    charset += UIntSetRange(4240, 4249); // MYANMAR SHAN DIGIT ZERO -> MYANMAR SHAN DIGIT NINE
    charset += UIntSetRange(6112, 6121); // KHMER DIGIT ZERO -> KHMER DIGIT NINE
    charset += UIntSetRange(6160, 6169); // MONGOLIAN DIGIT ZERO -> MONGOLIAN DIGIT NINE
    charset += UIntSetRange(6470, 6479); // LIMBU DIGIT ZERO -> LIMBU DIGIT NINE
    charset += UIntSetRange(6608, 6617); // NEW TAI LUE DIGIT ZERO -> NEW TAI LUE DIGIT NINE
    charset += UIntSetRange(6992, 7001); // BALINESE DIGIT ZERO -> BALINESE DIGIT NINE
    charset += UIntSetRange(7088, 7097); // SUNDANESE DIGIT ZERO -> SUNDANESE DIGIT NINE
    charset += UIntSetRange(7232, 7241); // LEPCHA DIGIT ZERO -> LEPCHA DIGIT NINE
    charset += UIntSetRange(7248, 7257); // OL CHIKI DIGIT ZERO -> OL CHIKI DIGIT NINE
    charset += UIntSetRange(42528, 42537); // VAI DIGIT ZERO -> VAI DIGIT NINE
    charset += UIntSetRange(43216, 43225); // SAURASHTRA DIGIT ZERO -> SAURASHTRA DIGIT NINE
    charset += UIntSetRange(43264, 43273); // KAYAH LI DIGIT ZERO -> KAYAH LI DIGIT NINE
    charset += UIntSetRange(43600, 43609); // CHAM DIGIT ZERO -> CHAM DIGIT NINE
    charset += UIntSetRange(65296, 65305); // FULLWIDTH DIGIT ZERO -> FULLWIDTH DIGIT NINE
    charset += UIntSetRange(66720, 66729); // OSMANYA DIGIT ZERO -> OSMANYA DIGIT NINE
    charset += UIntSetRange(120782, 120831); // MATHEMATICAL BOLD DIGIT ZERO -> MATHEMATICAL MONOSPACE DIGIT NINE
    return charset;
}


const UIntSet &named_charset_xdigit()
{
    static UIntSet charset;
    if( charset.count() )
        return charset;
    charset += UIntSetRange(48, 57); // DIGIT ZERO -> DIGIT NINE
    charset += UIntSetRange(65, 70); // LATIN CAPITAL LETTER A -> LATIN CAPITAL LETTER F
    charset += UIntSetRange(97, 102); // LATIN SMALL LETTER A -> LATIN SMALL LETTER F
    charset += UIntSetRange(65296, 65305); // FULLWIDTH DIGIT ZERO -> FULLWIDTH DIGIT NINE
    charset += UIntSetRange(65313, 65318); // FULLWIDTH LATIN CAPITAL LETTER A -> FULLWIDTH LATIN CAPITAL LETTER F
    charset += UIntSetRange(65345, 65350); // FULLWIDTH LATIN SMALL LETTER A -> FULLWIDTH LATIN SMALL LETTER F
    return charset;
}
